2002-12-31  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300-protos.h: Update the prototypes.
	* config/h8300/h8300.c (const_le_2_operand): Change to
	const_int_le_2_operand.
	(const_int_le_6_operand): Change to const_int_le_6_operand.
	* config/h8300/h8300.md (two peepholes): Update the function
	names.

2002-12-31  Tom Tromey  <tromey@redhat.com>

	* doc/install.texi (Testing): Fixed typo.

2002-12-31  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.h (TRAMPOLINE_TEMPLATE): Remove.
	(TRAMPOLINE_SIZE): Support the normal mode.
	(INITIALIZE_TRAMPOLINE): Emit the entire trampoline.

2002-12-31  Mark Mitchell  <mark@codesourcery.com>

	* c-common.h (pending_lang_change): Declare.

2002-12-31  Jerry Quinn  <jlquinn@optonline.net>

	* gcc/doc/invoke.texi (Optimization Options): Clean up -O flag
	descriptions.

2002-12-31  Jerry Quinn  <jlquinn@optonline.net>

	* gcc/doc/invoke.texi (Optimization Options): List the options
	enabled by each -O flag.

2002-12-31  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/install.texi (Configuration): Explicitly refer
	gcc/config.gcc for a list of cpu models.

2002-12-31  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.h: Fix comment typos.

2002-12-30  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.h (WIDEST_HARDWARE_FP_SIZE): Define.

2002-12-30  Tom Tromey  <tromey@redhat.com>

	* doc/install.texi (Testing): Mention Jacks.

2002-12-30  Joseph S. Myers  <jsm@polyomino.org.uk>

	* doc/gcc.texi, doc/gccint.texi: Update last modification dates.

2002-12-30  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (output_logical_op): Use extu.w in more
	cases.
	(compute_logical_op_length): Update to reflect the change in
	output_logical_op.
	(compute_logical_op_cc): Likewise.

2002-12-30  Joseph S. Myers  <jsm@polyomino.org.uk>

	* doc/service.texi: Uncomment and update FAQ link.

2002-12-30  Andreas Jaeger  <aj@suse.de>

	* unwind-dw2-fde.h (last_fde): Add unused attribute for obj.

2002-12-30  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (*addsi3_lshiftrt_16_zexthi): New.

2002-12-30  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (output_logical_op): Use extu.w if we
	are clearing the most significant byte.
	(compute_logical_op_length): Update to reflect the change in
	output_logical_op.
	(compute_logical_op_cc): Likewise.

2002-12-29  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md: Give internal names to anonymous
	insns.

2002-12-29  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md: Reorder some insns.

2002-12-29  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300-protos.h: Add prototypes for
	const_int_qi_operand and const_int_hi_operand.
	* config/h8300/h8300.c (const_int_qi_operand): New.
	(const_int_hi_operand): Likewise.
	* config/h8300/h8300.md (three peepholes): New.

2002-12-28  Joseph S. Myers  <jsm@polyomino.org.uk>

	* doc/cpp.texi, doc/gcc.texi, doc/gccint.texi, doc/install.texi:
	Use @copying.

2002-12-28  Joseph S. Myers  <jsm@polyomino.org.uk>

	* configure.in: Increase makeinfo version requirement to 4.[2-9].
	* configure: Regenerate.
	* doc/install.texi: Update Texinfo version requirement.

2002-12-28  Andreas Jaeger  <aj@suse.de>

	* config/i386/i386.c (x86_function_profiler): Mark labelno as
	possibly unused.

	* c-parse.in (yyprint): Use HOST_WIDE_INT_PRINT_DOUBLE_HEX for
	correct format.

2002-12-27  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (*iorhi_shift_8): Change the name to
	*iorhi_ashift_8.
	(*iorhi_lshiftrt_8): New.

2002-12-27  Joseph S. Myers  <jsm@polyomino.org.uk>

	* doc/include/texinfo.tex: Update to version 2002-12-26.16.

2002-12-27  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/contrib.texi (Contributors): Add Abramo and Roberto Bagnara.

2002-12-26  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300-protos.h: Fix comment typos.
	Update copyright.
	* config/h8300/h8300.c: Fix comment typos.

2002-12-26  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.h (IDENT_ASM_OP): End with a tab.

2002-12-26  Kazu Hirata  <kazu@cs.umass.edu>

	* config/i386/athlon.md: Fix comment typos.
	* config/i386/crtdll.h: Likewise.
	* config/i386/djgpp.h: Likewise.
	* config/i386/i386-interix.h: Likewise.
	* config/i386/i386.c: Likewise.
	* config/i386/i386.h: Likewise.
	* config/i386/i386.md: Likewise.
	* config/i386/k6.md: Likewise.
	* config/i386/mingw32.h: Likewise.
	* config/i386/pentium.md: Likewise.
	* config/i386/sco5.h: Likewise.
	* config/i386/winnt.c: Likewise.
	* config/i386/xmmintrin.h: Likewise.

2002-12-26  Jose Renau <renau@cs.uiuc.edu>

	* ssa-dce.c (EXECUTE_IF_UNNECESSARY): Verify INSN is an
	INSN_P before checking to see if it is dead.
	(mark_all_insn_unnecessary): Similarly.
	(ssa_eliminate_dead_code): Similarly.
	* rtl.h (struct rtx_def): Update comments for in_struct usage
	in dead code elimination pass.
	(INSN_DEAD_CODE_P): Allow JUMP_INSN and CALL_INSN as well.

2002-12-26  Andreas Schwab  <schwab@suse.de>

	* config.gcc (powerpc*-*-*, rs6000-*-*): Fix assignment syntax.

2002-12-25  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.c (rs6000_override_options): Convert to
	tartet_flags_explicit.
	* config/rs6000/rs6000.h (MASK_MULTIPLE_SET, MASK_STRING_SET): Delete.
	Compact target_flags bits.
	(TARGET_MULTIPLE_SET, TARGET_STRING_SET): Delete.
	(TARGET_SWITCHES): Delete references to *_SET flags.

Wed Dec 25 20:30:53 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (memory attribute): Fix setcc attribute.

2002-12-25  Kazu Hirata  <kazu@cs.umass.edu>

	* output.h: Fix comment typos.
	* predict.c: Likewise.
	* print-tree.c: Likewise.
	* profile.c: Likewise.
	* ra-build.c: Likewise.
	* ra-colorize.c: Likewise.
	* ra-debug.c: Likewise.
	* ra-rewrite.c: Likewise.
	* ra.c: Likewise.
	* ra.h: Likewise.
	* real.c: Likewise.
	* recog.c: Likewise.
	* reg-stack.c: Likewise.
	* regclass.c: Likewise.

2002-12-25  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (print_operand_address): Do not negate
	a negative number when printing one.

2002-12-25  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300-protos.h: Add prototypes for
	output_plussi, compute_plussi_length, and compute_plussi_cc.
	* config/h8300/h8300.c (output_plussi): New.
	(compute_plussi_length): Likewise.
	(compute_plussi_cc): Likewise.
	* config/h8300/h8300.md (addsi_h8300h): Call
	output_plussi, compute_plussi_length, and compute_plussi_cc.

2002-12-24  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (two peepholes): Use match_dup instead
	of match_operand in the new patterns.

2002-12-24  Joseph S. Myers  <jsm@polyomino.org.uk>

	* doc/include/texinfo.tex: Update to version 2002-11-25.11.

2002-12-24  Nathan Sidwell  <nathan@codesourcery.com>

	* configure.in (enable-coverage): Add SELF_COVERAGE.
	* profile.c (end_branch_prob): Use SELF_COVERAGE.

2002-12-24  Jim Wilson  <wilson@redhat.com>

	* alias.c (record_set): Handle multi-reg hard registers.

2002-12-24  Kazu Hirata  <kazu@cs.umass.edu>

	* regmove.c: Fix comment typos.
	* reload.c: Likewise.
	* reload1.c: Likewise.
	* resource.c: Likewise.
	* rtl.def: Likewise.
	* rtl.h: Likewise.
	* rtlanal.c: Likewise.
	* sched-deps.c: Likewise.
	* sched-rgn.c: Likewise.
	* sibcall.c: Likewise.
	* simplify-rtx.c: Likewise.
	* ssa-ccp.c: Likewise.
	* ssa.c: Likewise.
	* stmt.c: Likewise.
	* stor-layout.c: Likewise.
	* system.h: Likewise.
	* tlink.c: Likewise.
	* toplev.c: Likewise.
	* tracer.c: Likewise.
	* tree-inline.c: Likewise.
	* tree.c: Likewise.
	* tree.h: Likewise.
	* unroll.c: Likewise.
	* varasm.c: Likewise.

2002-12-23  Larin Hennessy  <larin@science.oregonstate.edu>

	* doc/install.texi: Remove i386-*-isc, i860-*-bsd,
	m68k-altos-sysv, m68k-isi-bsd, m68k-sony-bsd entries.
	* doc/invoke.texi: Remove AMD 29K, ARM RISC/iX, Clipper, Convex,
	DG/UX entries.
	* doc/md.texi: Remove AMD 29K entries.
	* doc/trouble.texi: Remove Alliant, DG/UX, Iris 4.0.5F, GAS
	1.38.1, NewsOS, RT PC, WE32K entries.

2002-12-23  Aldy Hernandez  <aldyh@redhat.com>

	PR/8763
	* config/rs6000/altivec.md (mulv4sf3): Rewrite to add -0.0 vector.
	(altivec_vspltisw_v4sf): Name pattern.
	(altivec_vslw_v4sf): New pattern.

2002-12-23  Joseph S. Myers  <jsm@polyomino.org.uk>

	* doc/include/gcc-common.texi: Define DEVELOPMENT.

2002-12-23  Mark Mitchell  <mark@codesourcery.com>

	* stor-layout.c (update_alignment_for_field): Correct handling of
	unnamed bitfields on PCC_BITFIELD_TYPE_MATTERS machines.
	* doc/tm.texi (PCC_BITFIELD_TYPE_MATTERS): Note that an unnamed
	bitfield does not affect alignment.

2002-12-23  David Edelsohn  <edelsohn@gnu.org>

	* expr.c (expand_assignment): Apply special treatment to
	ARRAY_TYPE.

2002-12-23  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300-protos.h: Update the prototype of
	expand_a_shift.
	* config/h8300/h8300.c (expand_a_shift): Change the return
	type to void.
	* config/h8300/h8300.md: Update all the uses of
	expand_a_shift.

2002-12-22  Nathan Sidwell  <nathan@codesourcery.com>

	* tree.c (save_expr): Allow either side of a dyadic operand to be
	constant.

	* doc/portability.texi (portability): Update portability goals.

2002-12-23  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (output_a_shift): Remove unused code.

2002-12-22  Mark Mitchell  <mark@codesourcery.com>

	* stor-layout.c (update_alignment_for_field): Guard use of
	ADJUST_FIELD_ALIGN with #ifdef.

	* stor-layout.c (update_alignment_for_field): Use
	ADJUST_FIELD_ALIGN when computing the alignment for a zero-width
	bitfield when PCC_BITFIELD_TYPE_MATTERS.

2002-12-22  Kazu Hirata  <kazu@cs.umass.edu>

	* genautomata.c: Fix comment typos.

Sun Dec 22 18:23:44 CET 2002  Jan Hubicka  <jh@suse.cz>

	* params.def (tracer-min-branch-probability-feedback): Fix default.
	* final.c (compute_alignments): Use profile to avoid code bloat.

2002-12-22  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (get_shift_alg): Make shift insn
	sequences end with a valid cc0 whenever possible.

2002-12-22  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (negsf2): New.
	(*negsf2_h8300): Likewise.
	(*negsf2_h8300hs): Likewise.

2002-12-21  Geoffrey Keating  <geoffk@apple.com>

	* integrate.c (output_inline_function): Don't hold private
	pointers to 'struct function' over GC calls.

2002-12-21  Kaz kojima  <kkojima@gcc.gnu.org>

	* config/sh/lib1funcs.asm (__fpscr_values): Conditionalize with
	NO_FPSCR_VALUES.
	* config/sh/t-linux (TARGET_LIBGCC2_CFLAGS): Add -DNO_FPSCR_VALUES.

2002-12-21  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (zero_extendqisi2): Correct the
	length.

2002-12-21  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (*zero_extendqihi2_h8300): Make the
	second alternative "#".
	(*zero_extendqihi2_h8300hs): Likewise.
	(a define_split): New.

2002-12-21  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300-protos.h: Update the prototype for
	split_adds_subs.
	Add prototypes for const_le_2_operand and const_le_6_operand.
	* config/h8300/h8300.c (split_adds_subs): Add an argument to
	specify whether inc/dec should be used when possible.
	(const_le_2_operand): New.
	(const_le_6_operand): Likewise.
	* config/h8300/h8300.md (two peepholes): New.

2002-12-21  Kazu Hirata  <kazu@cs.umass.edu>

	* config/fr30/fr30.md: Fix a comment typo.
	* config/i386/i386.c: Likewise.
	* config/ip2k/ip2k.h: Likewise.

2002-12-20  Jim Wilson  <wilson@redhat.com>

	* config/rs6000/spe.h (__ev_subifw): Reverse arguments.
	(__ev_subw, __ev_subiw): New.
	(ev_mwlssf, ev_mwlsmf, ev_mwlssfa, ev_mwlsmfa, ev_mwlssfaaw,
	ev_mwlsmfaaw, ev_mwlssfanw, ev_mwlsmfanw): Delete.

2002-12-20  John David Anglin  <dave.anglin@nrc.gc.ca>

	* pa-linux.h (TARGET_HAS_STUBS_AND_ELF_SECTIONS): Delete define.
	* pa32-linux.h (FUNCTION_OK_FOR_SIBCALL): Delete define.
	* pa.c (pa_function_ok_for_sibcall): Allow non indirect sibcalls on
	TARGET_ELF32.  Add comment on sibcall issues for TARGET_64BIT.

2002-12-20  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300-protos.h: Add prototypes for
	incdec_operand and eqne_operator.
	* config/h8300/h8300.c (incdec_operand): New.
	(eqne_operator): Likewise.
	* config/h8300/h8300.h (CONST_OK_FOR_M): Likewise.
	(CONST_OK_FOR_O): Likewise.
	(CONST_OK_FOR_LETTER_P): Use CONST_OK_FOR_M and
	CONST_OK_FOR_O.
	* config/h8300/h8300.md (UNSPEC_INCDEC): New.
	(addhi3_incdec): New.
	(addsi3_incdec): Likewise.
	(two peepholes): Likewise.

2002-12-20  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (dosize): Remove warnings.
	(print_operand): Likewise.

2002-12-20  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.c (decl_has_samegp): New.
	(samegp_function_operand): Use it.  Rename from
	current_file_function_operand.
	(direct_call_operand): Handle -msmall-text via symbol->jump.
	(tls_symbolic_operand_1): Use T for tprel64, t for smaller tprel.
	(tls_symbolic_operand_type): Likewise.
	(alpha_encode_section_info): Likewise.  Handle -msmall-text.
	(alpha_function_ok_for_sibcall): Use decl_has_samegp.
	(alpha_end_function): Set symbol->jump for functions defined in
	the text section.
	* config/alpha/alpha-protos.h: Update.
	* config/alpha/alpha.h (MASK_SMALL_TEXT, TARGET_SMALL_TEXT): New.
	(TARGET_SWITCHES): Add -msmall-text and -mlarge-text.
	(PREDICATE_CODES): Update.
	* config/alpha/alpha.md (call patterns): Update for
	samegp_function_operand rename; use !samegp reloc if
	TARGET_EXPLICIT_RELOCS.
	* doc/invoke.text: Document -msmall-text and -mlarge-text.

2002-12-20  Ian Dall  <ian@sibyl.beware.dropbear.id.au>

	* config/ns32k/ns32k.md (movdi): Use "l" instead of "f" to match
	all registers capable of holding a double float.
	(*rcond): change name of "reverse branch" insns to
	something more meaningful.
	(*rbgt, *rblt, *rbge, *rble): Reverse branches to handle IEEE
	comparisons properly.
	(*ffs): Change operand 0 from write to read-modify-write.
	(*ffsssi2): Drop constraints from define_expand.

	* config/ns32k/ns32k.h (STORE_RATIO, STORE_BY_PIECES): Avoid using
	MOVE_RATIO as default for store operations.

	* config/ns32k/ns32k.h (enum reg_class, REG_CLASS_NAMES): Add
	LONG_REGS class.
	(CANNOT_CHANGE_MODE_CLASS): Can't subreg LONG_REGS.
	(GO_IF_LEGITIMATE_ADDRESS): Remove spurious abort().
	* config/ns32k/ns32k.c (regclass_map): Add LONG_REGS class.

	* config/ns32k/STATUS: New File
	* config/ns32k/NOTES: New file.

2002-12-20  Hartmut Penner  <hpenner@de.ibm.com>

	* doc/invoke.texi: Document -mzarch, -mesa, -mcpu= and -march=
	option for S/390 and zSeries.
	* config/s390/s390.c (s390_cpu, s390_cpu_string, s390_arch,
	s390_arch_string): New variables.
	(override_options): Checking for options and setting of
	appropriate target_flags, cpu and arch flags.
	* config/s390/s390.h: (processor_type): New enum.
	(TARGET_SWITCHES): New switches -mesa/zarch.
	* config/s390/s390.md: New attribute 'cpu'.

2002-12-19  Kazu Hirata  <kazu@cs.umass.edu>

	* c-pretty-print.h: Fix comment typos.
	* integrate.c: Likewise.
	* varasm.c: Likewise.
	* config/c4x/c4x.h: Likewise.
	* config/c4x/c4x.md: Likewise.
	* config/fr30/fr30.md: Likewise.
	* config/frv/frv.c: Likewise.
	* config/h8300/h8300.c: Likewise.
	* config/i386/i386.c: Likewise.
	* config/i386/i386.h: Likewise.
	* config/ia64/ia64.c: Likewise.
	* config/ia64/ia64.h: Likewise.
	* config/ip2k/ip2k.md: Likewise.
	* config/m68hc11/m68hc11-crt0.S: Likewise.
	* config/m68hc11/m68hc11.h: Likewise.
	* config/m68hc11/m68hc11.md: Likewise.
	* config/m68hc11/m68hc12.h: Likewise.
	* config/mcore/mcore.md: Likewise.
	* config/mips/mips.c: Likewise.
	* config/mips/mips.md: Likewise.
	* config/mmix/mmix-modes.def: Likewise.
	* config/pa/pa.c: Likewise.
	* config/rs6000/rs6000.c: Likewise.
	* config/rs6000/rs6000.h: Likewise.
	* config/rs6000/rs6000.md: Likewise.

2002-12-19  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (output_a_shift): Clean up the code to
	output shifts using rotation.

2002-12-20  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	* flow.c (allocate_reg_life_data): Reset REG_FREQ.

2002-12-19  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (pushqi_h8300): Don't push the stack
	pointer.
	(pushqi_h8300hs): Likewise.
	(pushhi_h8300): Likewise.
	(pushhi_h8300hs): Likewise.

Thu Dec 19 23:44:09 2002  J"orn Rennecke <joern.rennecke@superh.com>

	* sched-rgn.c (init_regions): Update comment.

2002-12-19  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.md (define_attr type): Remove altivec.
	* config/rs6000/altivec.md (movv4si_internal): Set correct instruction
	attributes.
	(movv8hi_internal,movv16qi_internal,movv4sf_internal): Same.
	(get_vrsave_internal,set_vrsave_internal): Same.
	(altivec_vspltisb,altivec_vspltish,altivec_vspltisw): Same.
	(absv16qi2,absv8hi2,absv4si2,absv4sf2): Same
	(altivec_abss_v16qi,altivec_abss_v8hi,altivec_abss_v4si): Same.

2002-12-19  Casper S. Hornstrup  <chorns@users.sourceforge.net>
	    Danny Smith  <dannysmith@users.sourceforge.net>
	    Eric Kohl  <ekohl@rz-online.de>

	* config/i386/i386.c (ix86_handle_cdecl_attribute): Check for
	attributes incompatible with fastcall attribute.
	(ix86_handle_regparm_attribute): Likewise.

	* config/i386/i386.c (ix86_comp_type_attributes): Check for mismatched
	fastcall types.

	* config/i386/cygwin.h (TARGET_OS_CPP_BUILTINS): Add fastcall
	attributes.
	(ASM_OUTPUT_LABELREF): Define as i386_pe_output_labelref.
	* config/i386/i386-protos.h (i386_pe_output_labelref): Declare.
	* config/i386/winnt.c (i386_pe_mark_dllimport). Add __imp_ prefix in
	i386_pe_output_labelref rather than here.
	(gen_fastcall_suffix): New function. Decorates a label name with the
	fastcall prefix (@) and the stdcall suffix.
	(i386_pe_encode_section_info): Call gen_fastcall_suffix() if a symbol
	has a fastcall attribute.
	(i386_pe_output_labelref): New function. Outputs a label reference.
	* config/i386/i386.c (ix86_attribute_table): Accept 'fastcall' as a
	valid attribute.
	(ix86_return_pops_args): Fastcall functions pop the stack.
	(init_cumulative_args): Reserve registers ECX and EDX if function has
	fastcall attribute.
	(function_arg): Use registers ECX and EDX if function has fastcall
	attribute.
	* config/i386/i386.h (CUMULATIVE_ARGS): Add fastcall attribute flag.
	(DLL_IMPORT_EXPORT_PREFIX): Redefine as '#'.
	(FASTCALL_PREFIX): Define as '@'.
	* config/i386/mingw32.h (TARGET_OS_CPP_BUILTINS): Add fastcall
	attributes.
	* doc/extend.texi: Add documentation of fastcall attribute.

2002-12-19  Nathanael Nerode  <neroden@gcc.gnu.org>

	* configure.in: FORBUILD when build!=host changed from
	../$build-alias to ../build-$build_alias to match change made
	in top directory.
	* configure: Regenerated.

2002-12-19  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/8988
	* loop.c (maybe_eliminate_biv): Kill REG_EQUAL notes mentioning
	the biv when eliminating.

2002-12-19  Devang Patel  <dpatel@apple.com>
	* gcc.c (struct default_compiler): Recognizes input file name with
	.CPP extension as C++ source files
	* cp/lang-spec.h: Same
	* doc/invoke.texi:  Add documentation for .CPP support.

2002-12-19  Aldy Hernandez  <aldyh@redhat.com>

	PR 8553
	* config/rs6000/altivec.md ("absv8hi2"): Add & to clobbered
	registers.
	("absv16qi2"): Same.
	("absv4si2"): Same.
	("absv4sf2"): Same.
	("altivec_abss_v16qi"): Same.
	("altivec_abss_v8hi"): Same.
	("altivec_abss_v4si"): Same.

2002-12-19  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.md ("*tsthiCCT", "*tsthiCCT_cconly",
	"*tstqiCCT", "*tstqiCCT_cconly"): New insns.

2002-12-19  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR target/8340
	* stmt.c (expand_asm_operands): Produce an error when
	the PIC register is clobbered.

2002-12-18  Daniel Berlin  <dberlin@dberlin.org>

	* Makefile.in (OBJS): Add alloc-pool.o
	(alloc-pool.o): New object.

	* alloc-pool.c: New file.
	* alloc-pool.h: New file.

2002-12-18  Loren James Rittle  <ljrittle@acm.org>

	* gcc.c (validate_switches): Robustify against skipping past '\0'.

2002-12-18  Geoffrey Keating  <geoffk@apple.com>

	* config.gcc: Set extra_objs in the generic Darwin rule,
	not in the machine-specific rules.

2002-12-19  Kazu Hirata  <kazu@cs.umass.edu>

	* ChangeLog: Follow spelling conventions.
	* ChangeLog.2: Likewise.
	* ChangeLog.4: Likewise.
	* ChangeLog.5: Likewise.
	* cppexp.c: Likewise.
	* df.c: Likewise.
	* gcov.c: Likewise.
	* gengtype.c: Likewise.
	* reload1.c: Likewise.
	* sched-rgn.c: Likewise.
	* stmt.c: Likewise.
	* stor-layout.c: Likewise.
	* timevar.c: Likewise.
	* toplev.c: Likewise.
	* tree.h: Likewise.
	* varasm.c: Likewise.
	* config/fr30/fr30.md: Likewise.
	* config/i386/i386.c: Likewise.
	* config/ia64/ia64.c: Likewise.
	* config/pa/pa.c: Likewise.

2002-12-18  Roger Sayle  <roger@eyesopen.com>

	* basic-block.h (flow_bb_inside_loop_p): Correct prototype.

2002-12-18  Aldy Hernandez  <aldyh@redhat.com>

	PR 8551
	* config/rs6000/altivec.h (vec_cmplt macro): Reverse arguments in
	macro.
	(vec_cmplt C++ functions): Reverse arguments.

2002-12-18  Geoffrey Keating  <geoffk@apple.com>

	* config/rs6000/t-rs6000: Move contents to t-fprules,
	add rules for dependencies of rs6000.o and to build rs6000-c.o
	* config/rs6000/t-fprules: New file from t-rs6000.
	* config/rs6000/t-beos: Remove soft-fp rules.
	* config/rs6000/t-ppccomm: Likewise.
	* config/rs6000/t-newas: Likewise.
	* config/rs6000/t-rs6000-c-rule: Delete.
	* config.gcc: Use t-fprules for rs6000/ ports when appropriate.
	Use t-rs6000 for all rs6000/ ports instead of t-rs6000-c-rule.
	Create generic Darwin rules.

	* gengenrtl.c (gencode): Delete unnecessary rtl_obstack declaration.

2002-12-18  Doug Evans  <dje@sebabeach.org>

	* m32r/m32r.c (addr24_operand): Fix arg to CONSTANT_POOL_ADDRESS_P
	and LIT_NAME_P.
	(move_src_operand): Remove compile-time warning.
	* m32r/m32r.h (ROUND_ADVANCE_ARG): Ditto.

2002-12-18  Jason Merrill  <jason@redhat.com>

	* unwind-dw2-fde.c (frame_downheap): Split out from...
	(frame_heapsort): Here.

2002-12-17  Jason Merrill  <jason@redhat.com>

	* tree.c (make_node): Don't set TREE_TYPE on 's' class nodes.
	(build1): Always set TREE_SIDE_EFFECTS on 's' class nodes.

	* gcc.c (do_spec_1) ['W']: End any pending argument from the braces.

	* calls.c (expand_call): Don't try to be clever about expanding
	the return slot address.

2002-12-18  Kaz kojima  <kkojima@gcc.gnu.org>

	* config/sh/linux.h (NO_IMPLICIT_EXTERN_C, CPLUSPLUS_CPP_SPEC):
	Define.

2002-12-17  Jason Merrill  <jason@redhat.com>

	* genmultilib: Use 'cd ./foo'.

2002-12-17  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/c-tree.texi: Restore deliberate spelling mistakes.

2002-12-17  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/c-tree.texi: Fix typos and follow spelling conventions.
	* doc/cpp.texi: Likewise.
	* doc/extend.texi: Likewise.
	* doc/gty.texi: Likewise.
	* doc/install.texi: Likewise.
	* doc/invoke.texi: Likewise.
	* doc/md.texi: Likewise.
	* doc/passes.texi: Likewise.
	* doc/rtl.texi: Likewise.
	* doc/sourcebuild.texi: Likewise.
	* doc/tm.texi: Likewise.

2002-12-17  Jerry Quinn  <jlquinn@optonline.net>

	* doc/invoke.texi: Minor spelling and grammar fixes.

2002-12-17  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.c (s390_output_constant_pool): Replace
	ASM_OUTPUT_INTERNAL_LABEL by (*targetm.asm_out.internal_label).

Tue Dec 17 09:47:57 CET 2002  Jan Hubicka  <jh@suse.cz>

	* convert.c (convert_to_real): Disable function transformation for
	now.

2002-12-16  Geoffrey Keating  <geoffk@apple.com>

	* gcc.c (handle_braces): Allow '@' as a switch name.

2002-12-16  Jason Merrill  <jason@redhat.com>

	* calls.c (expand_call): Handle CALL_EXPR_HAS_RETURN_SLOT_ADDR
	with special struct-return ABIs.

	* c-semantics.c (add_scope_stmt): Abort if the end SCOPE_STMT
	doesn't match the begin SCOPE_STMT in partialness.

2002-12-16  Geoffrey Keating  <geoffk@apple.com>

	* genmultilib: Create temporary files in unique subdirectory.

	* gcc.c (validate_switches): Allow '@' as a switch name.

2002-12-16  Loren J. Rittle  <ljrittle@acm.org>

	* Makefile.in (gcov-iov.h): Improve portability.

Mon Dec 16 23:39:19 CET 2002  Jan Hubicka  <jh@suse.cz>

	* mips.h (ASM_OUTPUT_ADDR_DIFF_ELT): Do not use qpword on API_N32/not
	gas
	* mips.md (tablejump insn): Likewise.

2002-12-16  Mark Mitchell  <mark@codesourcery.com>

	* doc/include/gcc-common.texi: Change version number to 3.4.

2002-12-16  Bruce Korb  <bkorb@gnu.org>

	* fixinc/fixlib.h: add: #include <signal.h>
	* fixinc/fixincl.c: remove: #include <signal.h>

Mon Dec 16 17:20:04 2002  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.h (EXTRA_CONSTRAINT_Z): New macro.
	(EXTRA_CONSTRAINT): Use it.
	* sh.md (anddi3): Use 'Z' constraint for alternative 2.

2002-12-15  Zack Weinberg  <zack@codesourcery.com>

	* config.gcc (need_64bit_hwint): New variable.
	(alpha*-*-*, x86_64-*-*, ia64-*-*, mips*-*-*, powerpc*-*-*,
	mmix-knuth-mmixware, rs6000*-*-*, sparc64*-*-*, s390*-*-*,
	sh*-*-*, hppa*64*-*-linux, parisc*64*-*-linux, hppa*64*-*-hpux11*,
	sparcv9-*-solaris2*, sparc*-*-solaris2.[789], ultrasparc-*-freebsd*):
	Set it.
	(powerpc*-*-darwin*): Unset it.
	(alpha-*-interix, alpha64-dec-*vms*, i?86-*-interix3*,
	i?86-*-interix*, sparc64-*-openbsd*): Remove references to
	deleted/nonexistent xm-*.h headers.
	* configure.in: AC_DEFINE NEED_64BIT_HOST_WIDE_INT if the
	target set need_64bit_hwint in config.gcc.
	* configure, config.in: Regenerate.

	* hwint.h: Overhaul.  Don't bother trying int for
	HOST_WIDE_INT.  Do try __int64 if long is not enough.  Base
	decision to force 64-bit HOST_WIDE_INT on
	NEED_64BIT_HOST_WIDE_INT, not (MAX_)LONG_TYPE_SIZE which is
	not visible at this point.  Don't allow prior definition of
	any macro defined by this file.

	* config/alpha/xm-vms.h: Don't define HOST_WIDE_INT or
	HOST_BITS_PER_WIDE_INT.
	* config/c4x/c4x.h: Adjust redefinition of
	HOST_WIDE_INT_PRINT_HEX to match changes to hwint.h.
	* config/alpha/xm-alpha-interix.h, config/alpha/xm-vms64.h,
	config/i386/xm-i386-interix.h: Delete file.

2002-12-14  Rodney Brown  <rbrown64@csc.com.au>
	    John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* pa.c (output_millicode_call): Convert ASM_OUTPUT_INTERNAL_LABEL.
	* pa64-hpux.h (ASM_OUTPUT_INTERNAL_LABEL): Delete define.

2002-12-14  Zack Weinberg  <zack@codesourcery.com>

	* mkconfig.sh: Correct comment.  Add copyright boilerplate.

2002-12-14  Zack Weinberg  <zack@codesourcery.com>

	* config/t-darwin, config/arm/t-pe, config/arm/t-strongarm-pe,
	config/c4x/t-c4x, config/i370/t-i370, config/i386/t-cygwin,
	config/i386/t-interix, config/i960/t-960bare, config/ia64/t-ia64,
	config/rs6000/t-rs6000-c-rule, config/sparc/t-sol2,
	config/v850/t-v850:  Correct dependencies and normalize
	compilation commands for files that include coretypes.h and tm.h.

	* config/sparc/gmon-sol2.c: Include tconfig.h and tsystem.h,
	not config.h and system.h.

Sat Dec 14 20:43:41 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (flags_reg_operand):  New function.
	* i386.h (PREDICATE_CODES): Add flags_reg_operand.
	* i386.md (cmov splitter, movqicc): Use new predicate.

Sat Dec 14 17:03:17 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (movqicc splitter): Fix template.

2002-12-13  Jason Merrill  <jason@redhat.com>

	* tree.h (CALL_EXPR_HAS_RETURN_SLOT_ADDR): New macro.
	* calls.c (expand_call): Handle it.
	* tree-inline.c (struct inline_data): Remove target_exprs field.
	(optimize_inline_calls): Don't initialize it.
	(expand_call_inline): Don't modify it.  Handle
	CALL_EXPR_HAS_RETURN_SLOT_ADDR.
	(declare_return_variable): Take return slot addr.
	* langhooks.h (copy_res_decl_for_inlining): Change target_exprs parm
	to return_slot_addr.
	* langhooks-def.h, langhooks.c: Adjust.
	* explow.c (maybe_set_unchanging): Don't set RTX_UNCHANGING_P for
	a decl with no DECL_INITIAL.

	* expr.c (expand_expr): Don't discard the target of a call which
	returns in memory.

2002-12-13  Neil Booth  <neil@daikokuya.co.uk>

	* cppinit.c (path_include): Take an environment variable name.
	Tidy up.
	(init_standard_includes): Simplify environment handling, and
	move to ...
	(cpp_read_main_file): ...here as -nostdinc should not affect
	environment variable paths.

2002-12-13  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* pa.c (output_millicode_call): Correct typo.
	(output_call): Likewise.

Fri Dec 13 21:07:18 2002  Alexandre Oliva  <aoliva@redhat.com>

	* config/mn10300/mn10300.c (print_operand) <case N>: Check
	operand's range.  Print value directly, without aid from
	output_address.
	<case U>: New.
	<case S>: Make sure argument to fprintf has the right type.
	* config/mn10300/mn10300.h (OK_FOR_T): New macro.
	(EXTRA_CONSTRAINT): Adjust.
	* config/mn10300/mn10300.md: Add new all-QImode pattern for
	bclr.  Use %U for immediate operands of bset and bclr.
	(iorqi3): New expand, with insns for AM33 and mn10300.

Fri Dec 13 16:02:27 2002  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.c (sh_register_operand): New function.
	(prepare_move_operands): Use it.
	* sh.h (PREDICATE_CODES): Add entry for sh_register_operand.
	* sh.md (movsi_media, movsi_media_nofpu): Allow stores of 0.
	(movqi_media, movhi_media, movdi_media, movdi_media_nofpu): Likewise.
	(movdf_media, movdf_media_nofpu, movv4sf_i, movsf_media): Likewise.
	(movsf_media_nofpu, movv2hi_i, movv4hi_i, movv8qi_i): Likewise.
	(movv2si_i): Likewise.

2002-12-13  Jim Wilson  <wilson@redhat.com>

	* doc/extend.texi (Complex Numbers): Update info on debug info.

2002-12-13  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (addhi3_h8300): Remove the last
	alternative.

2002-12-12  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	* hooks.h (hook_tree_tree_bool_false): Declare
	hook_bool_tree_tree_false instead.

2002-12-12  Devang Patel  <dpatel@apple.com>

	* doc/invoke.texi: Document Darwin linker options, -bundle
	-bind_at_load, -all_load and -arch_errors_fatal

2002-12-12  Jim Wilson  <wilson@redhat.com>

	* dbxout.c (dbxout_fptype_value): New.
	(dbxout_type, case COMPLEX_TYPE): Call it.  Use 'R' instead of 'r'.

2002-12-12  Kazu Hirata  <kazu@cs.umass.edu>

	* c-decl.c: Fix a comment typo.
	* cfg.c: Likewise.
	* cfgcleanup.c: Likewise.
	* cfglayout.c: Likewise.
	* cfgrtl.c: Likewise.
	* c-typeck.c: Likewise.
	* dominance.c: Likewise.
	* dwarf2asm.c: Likewise.
	* dwarfout.c: Likewise.
	* expmed.c: Likewise.
	* expr.c: Likewise.
	* final.c: Likewise.
	* flow.c: Likewise.
	* function.c: Likewise.
	* gcc.c: Likewise.
	* genautomata.c: Likewise.
	* integrate.c: Likewise.
	* loop.c: Likewise.
	* loop.h: Likewise.
	* output.h: Likewise.
	* profile.c: Likewise.
	* ra.h: Likewise.
	* reload1.c: Likewise.
	* reload.c: Likewise.
	* sched-rgn.c: Likewise.
	* stmt.c: Likewise.
	* tree.h: Likewise.
	* vmsdbgout.c: Likewise.

2002-12-12  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md: Add a new peephole2.

2002-12-12  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (a peephole2): Accept a constant
	that's accepted by CONST_OK_FOR_J.

2002-12-12  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.h (CONST_OK_FOR_J): New.
	(CONST_OK_FOR_LETTER_P): Use CONST_OK_FOR_J.
	* config/h8300/h8300.md (*addhi_h8300): Add a new alternative.
	(*addhi_h8300hs): Likewise.

Thu Dec 12 16:24:59 2002  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.c (reg_class_from_letter): No longer const.  Add 'e' entry.
	(sh_register_move_cost): Add clause for SImode fp-fp moves.
	Increase cost for moves involving multiple general purpose registers.
	* sh.h (OVERRIDE_OPTIONS): Set reg_class_from_letter['e'] according to
	TARGET_FMOVD.
	(HARD_REGNO_MODE_OK): Allow V2SFmode and V4SFmode in general purpose
	registers, and SImode in fp registers, for ! TARGET_SHMEDIA.
	(enum reg_class reg_class_from_letter): No longer const.
	(SECONDARY_OUTPUT_RELOAD_CLASS): Use REGCLASS_HAS_FP_REG /
	REGCLASS_HAS_GENERAL_REG.
	Handle SImode moves from/to fp registers.
	! TARGET_SHMEDIA && TARGET_FMOVD.
	(SECONDARY_INPUT_RELOAD_CLASS): Use REGCLASS_HAS_FP_REG.
	* sh.md (movsi_ie): Add alternatives to move from / to fp regisyters.

2002-12-12  Andreas Schwab  <schwab@suse.de>

	* config/ia64/ia64.c (ia64_hpux_asm_file_end): Fix typo in last
	change and some warnings.

2002-12-12  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/md.texi (pushm): Fix a typo.

2002-12-12  Alexandre Oliva  <aoliva@redhat.com>

	* config/mips/mips.c (mips_output_conditional_branch): Support
	PIC-safe out-of-range branch and branch-likely.
	* config/mips/mips.md (attr length): PIC-safe out-of-range
	branches are longer.
	("jump"): Support PIC-safe out-of-range-for-branch jumps.  Remove
	unused code to support indirect jumps.

2002-12-11  Zack Weinberg  <zack@codesourcery.com>

	* Makefile.in (GTFILES): Add $(host_xm_file_list) and
	$(tm_file_list).

2002-12-11  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/t-rs6000-c-rule: Add coretypes.h $(TM_H) dependencies.

Wed Dec 11 15:20:45 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (cmove splitters): Avoid creation of unnecesary subregs.

2002-12-11  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* pa.h (BIGGEST_ALIGNMENT): Change 32-bit value to 64 bits.
	(MAX_PARM_BOUNDARY, STACK_BOUNDARY): Express in terms of
	BIGGEST_ALIGNMENT.
	(PREFERRED_STACK_BOUNDARY): Express in terms of STACK_BOUNDARY.
	(FUNCTION_BOUNDARY): Express in terms of BITS_PER_WORD.

2002-12-11  Kazu Hirata  <kazu@cs.umass.edu>

	* doc/invoke.texi: Correct dump file names.

2002-12-09  Steve Ellcey  <sje@cup.hp.com>

	* config/ia64/ia64.c (ia64_hpux_asm_file_end): Don't send stripped
	name to globalize_label or assemble_name.

Wed Dec 11 20:15:19 2002  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.h (REG_CLASS_HAS_GENERAL_REG): Only true for SIBCALL_REGS
	if not TARGET_SHMEDIA.

Wed Dec 11 19:05:05 2002  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.h (REG_CLASS_HAS_FP_REG): New.
	(REGISTER_MOVE_COST) Use it.  Put body into a function and
	move it into:
	* sh.c (sh_register_move_cost).
	* sh-protos.h (sh_register_move_cost): Declare.

	* sh.c (sh_expand_builtin): Abort for unexpected nop values.
	(sh_adjust_cost): Always return a value.

Wed Dec 11 18:39:52 2002  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.h (REG_CLASS_HAS_GENERAL_REG): New.
	(REGISTER_MOVE_COST): Use it.

2002-12-11  Richard Henderson  <rth@redhat.com>

	* tree.h (MODULE_LOCAL_P): Kill.
	* varasm.c (default_binds_local_p_1): Use decl_visibility instead.

2002-12-11  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (two define_peephole2): New.

2002-12-11  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.h (CONST_OK_FOR_J): Remove.
	(CONST_OK_FOR_K): Likewise.
	(CONST_OK_FOR_M): Likewise.
	(CONST_OK_FOR_LETTER_P): Do not use the above macros.

2002-12-11  Neil Booth  <neil@daikokuya.co.uk>

	* c-common.c (builtin_define_type_max): Handle unsigned
	types too.

2002-12-10  David Edelsohn  <edelsohn@gnu.org>

	* haifa-sched.c (rank_for_schedule): Correct style.

2002-12-10  Per Bothner  <pbothner@apple.com>

	* cpplib.h (struct cpp_hashnode):  Split a non-portably-signed field
	directive_index into an unsigned field and a new is_directive field.
	* cppinit.c (mark_named_operators):  Update to set new fields.
	* cpplex.c (_cpp_lex_direct):  Now directive_field is unsigned.
	* cpplib.c [_cpp_handle_directive]:   Test is_directive field.
	No longer need to subtract 1 from directive_index.
	(_cpp_init_directives):  No longer need to add 1 to directive_index.
	* cpptrad.c (scan_out_logical_line):  Use is_directive field.

2002-12-10  Roger Sayle  <roger@eyesopen.com>

	* builtins.c (fold_builtin): Remove -funsafe-math-optimizations
	check for evaluating sqrt of a constant at compile time.
	* simplify-rtx.c (simplify_unary_operation): Likewise.

2002-12-10  Janis Johnson  <janis187@us.ibm.com>

	PR other/8882
	* doc/tm.texi (PUSH_ARGS): Remove misplaced line.

2002-12-10  Devang Patel  <dpatel@appple.com>

	* config/darwin.h(LINK_SPEC): Add darwin specific linker options.
	* doc/invoke.texi: Add new "Darwin Options" section.

2002-12-10  Jim Wilson  <wilson@redhat.com>

	* rs6000.h (RETURN_IN_MEMORY): If ABI_V4, then TFmode is returned in
	memory.

2002-12-10  Andrew Haley  <aph@redhat.com>

	* cse.c (cse_insn): Don't cse past a basic block boundary.

2002-12-10  Jakub Jelinek  <jakub@redhat.com>

	* config/linux.h (LIB_SPEC): If -pthread, add -lpthread even if
	-shared.
	* config/alpha/linux-elf.h (LIB_SPEC): Likewise.
	* config/alpha/linux.h (LIB_SPEC): Likewise.
	* config/arm/linux-elf.h (LIB_SPEC): Likewise.
	* config/pa/pa-linux.h (LIB_SPEC): Likewise.
	* config/sparc/linux.h (LIB_SPEC): Likewise.
	* config/sparc/linux64.h (LIB_SPEC): Likewise.

2002-12-09  Larin Hennessy  <larin@science.oregonstate.edu>

	* doc/invoke.texi: Document UltraSparc III option.

2002-12-09  Richard Henderson  <rth@redhat.com>

	* config/i386/i386.h (TARGET_CPU_CPP_BUILTINS): Define
	__tune_pentium2__ and __tune_pentium3__ as necessary.

2002-12-09  Richard Henderson  <rth@redhat.com>

	* target.h (gcc_target): Add cannot_force_const_mem.
	* target-def.h (TARGET_CANNOT_FORCE_CONST_MEM): New.
	(TARGET_INITIALIZER): Add it.
	* varasm.c (force_const_mem): Fail if cannot_force_const_mem.
	* expr.c (emit_move_insn): Be prepared for force_const_mem to fail.
	* reload1.c (reload): Likewise.
	* hooks.c (hook_bool_rtx_false): New.
	* hooks.h: Declare it.

	* config/i386/i386.c (ix86_cannot_force_const_mem): New.
	(TARGET_CANNOT_FORCE_CONST_MEM): New.
	(ix86_expand_move): Remove de-const-pooling hack.

Mon Dec  9 21:33:38 CET 2002  Jan Hubicka  <jh@suse.cz>

	* toplev.c (dump_file): Fix order to match reality.

2002-12-08  Geoffrey Keating  <geoffk@apple.com>

	* config/rs6000/rs6000.md (load_multiple): Use adjust_address_nv.
	(store_multiple): Likewise.

2002-12-09  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* pa/fptr.c (__canonicalize_funcptr_for_compare): Don't canonicalize
	function pointers in page 0.

2002-12-09  Steve Ellcey  <sje@cup.hp.com>

	* config/ia64/hpux.h (TARGET_STRUCT_ARG_REG_LITTLE_ENDIAN): Remove
	definition
	(MEMBER_TYPE_FORCES_BLK): Move.
	* config/ia64/ia64.c (ia64_function_arg): Use PARALLEL to pass
	aggregate arguments.
	(ia64_function_value): Use PARALLEL to return aggregate values.

2002-12-09  Steve Ellcey  <sje@cup.hp.com>

	* doc/tm.texi (FUNCTION_ARG_REG_LITTLE_ENDIAN): Remove definition.
	* defaults.h (FUNCTION_ARG_REG_LITTLE_ENDIAN): Remove definition.
	* calls.c (store_unaligned_arguments_into_pseudos) Remove
	FUNCTION_ARG_REG_LITTLE_ENDIAN.
	* stmt.c (expand_return): Ditto.
	* expr.c (move_block_from_reg): Ditto.
	(copy_blkmode_from_reg): Ditto.
	* expmed.c (store_bit_field): Ditto.

2002-12-09  Svein E. Seldal  <Svein.Seldal@solidas.com>

	* config.gcc: Added tic4x-* target as an alias to c4x-*

Sun Dec  8 14:57:39 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (ix86_expand_int_movcc): Use force_operand instead of
	constructing insn directly.

2002-12-06  Per Bothner  <pbothner@apple.com>

	* cpplib.h (struct cpp_hashnode):  Change field directive_index from
	char to an int bit-field, for hosts where char is unsigned.

2002-12-07  Roger Sayle  <roger@eyesopen.com>
	    Richard Henderson <rth@redhat.com>

	* real.c (ieee_extended_motorola_format,
	ieee_extended_intel_96_format, ieee_extended_intel_128_format,
	ieee_quad_format, vax_d_format, vax_g_format, i370_double_format):
	Provide appropriate values for new signbit field.

2002-12-07  Roger Sayle  <roger@eyesopen.com>

	* real.h (real_format): Add signbit field.
	* real.c (ieee_single_format, ieee_double_format,
	ieee_extended_motorola_format, ieee_extended_intel_96_format,
	ieee_extended_intel_128_format, ibm_extended_format,
	ieee_quad_format, vax_f_format, vax_d_format,
	vax_g_format, i370_single_format, i370_double_format,
	c4x_single_format, c4x_extended_format, real_internal_format):
	Provide suitable signbit value, or -1 to avoid bit twiddling.

	* optabs.c (expand_unop): Try implementing negation of
	floating point modes by flipping the sign bit.
	(expand_abs): Try implementing abs of floating point modes
	by clearing the sign bit.

Sat Dec  7 22:29:47 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (ix86_expand_int_movcc):  Use force_operand instead
	of constructing insn directly.

2002-12-07  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (*iorhi_shift_8): New.

2002-12-06  Bernd Schmidt  <bernds@redhat.com>

	* doc/invoke.texi: Document FRV port options.
	* doc/md.texi: Document FRV register classes.

2002-12-07  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/install.texi (Configuration): Improve description of cases
	where `make distclean` may fail; clarify --with-gnu-as; fix grammar.

2002-12-06  Per Bothner  <pbothner@apple.com>

	* cpplib.h (NODE_MACRO_ARG):  New flag.
	(struct cpp_hashnode):  Give _cpp_hashnode_value tag to value union.
	Remove value.operator field.  Move arg_index field to value union.
	(directive_index):  Make signed, since also used for C++ operators.
	* cppmacro.c (_cpp_save_parameter):  Use NODE_MACRO_ARG flag to
	check for duplicate parameter.  Set NODE_MACRO_ARG flag.
	Save node->value, and set node->value.arg_index.
	(_cpp_create_definition):  For each paramater, restore node->value.
	(lex_expansion_token):  Use NODE_MACRO_ARG flag, and moved arg_index.
	* cpptrad.c (scan_out_logical_line): Likewise.
	(scan_out_logical_line): Check for directive > 0.
	* cpplib.c (cpp_handle_directive):  Likewise.
	* cpplex.c (_cpp_lex_direct):  Update as value.operator is replaced
	by negative of directive_index.
	* cppinit.c (mark_named_operators):  Likewise.

	* hashtable.h (struct ht_identifier):  Swap fields, for better packing.

2002-12-06 Dhananjay Deshpande <dhananjayd@kpit.com>

	* gcc/config/sh/sh.c (calc_live_regs): Save fpscr only if target has
	FPU.
	(push): Generate push_fpscr.
	(pop): Generate pop_fpscr.
	* gcc/config/sh/sh.md : Add define_expand "push_fpscr", "pop_fpscr".
	(fpu_switch): Add alternative to push fpscr.  Enable for TARGET_SH3E.

Fri Dec  6 19:36:24 2002  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.c (dump_table): DImode pool constants need only 32 bit alignment.
	DFmode alignment depends on TARGET_FMOVD && TARGET_ALIGN_DOUBLE.

Fri Dec  6 19:17:49 2002  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.md (movdi_i): Name.  Remove inappropriate comment.

Fri Dec  6 15:44:46 2002  J"orn Rennecke <joern.rennecke@superh.com>
	Merged from basic improvements branch (excerpt):

	2002-11-19  Kaz Kojima  <kkojima@gcc.gnu.org>
	* config/sh/sh.h (SH_DBX_REGISTER_NUMBER): Handle PR_MEDIA_REG.

2002-12-06  Jakub Jelinek  <jakub@redhat.com>

	* expr.c (expand_expr) <case COND_EXPR>: Never modify exp in place.

Thu Dec  5 16:58:25 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (dimode peep2s): Re-add "&& 1".

Thu Dec  5 14:10:15 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (ix86_expand_prologue):  Add comment, do not use
	fast prologues for cold and normal functions.

Thu Dec  5 00:52:37 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (x86_rep_movl_optimal): New variable.
	(ix86_expand_movstr, ix86_expand_clrstr): Use TARGET_REP_MOVL_OPTIMAL
	* i386.h (TARGET_REP_MOVL_OPTIMAL): New macro.

	* i386.md (negsf2_ifs, negdf2_ifs, negdf2_ifs_rex64, abssf2_ifs,
	absdf2_ifs, absdf2_ifs_rex64): Fix constraints.
	neg?f2_ifs, abs?f2_ifs splitters): Refuse memory operand; do not
	generate unnecesary subregs.

2002-12-05  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* pa32-linux.h (CANONICALIZE_FUNCPTR_FOR_COMPARE_LIBCALL): Move define.
	* pa.h (CANONICALIZE_FUNCPTR_FOR_COMPARE_LIBCALL): To here.

2002-12-05  Dale Johannesen  <dalej@apple.com>

	* tree.c (unsafe_for_reeval):  Consider callee child of CALL_EXPR.

2002-12-05  Danny Smith  <dannysmith@users.sourceforge.net>

	* config/i386/cygwin.h (SUBTARGET_PROLOGUE): Replace with
	PROFILE_HOOK.
	* config/i386/mingw32.h (SUBTARGET_PROLOGUE): Don't undef.

2002-12-05  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/spe.h (__ev_mwlufi): Remove.
	(__ev_mwlufia): Remove.
	(__ev_mwlumfaaw): Remove.
	(__ev_mwlusfaaw): Remove.
	(__ev_mwlumfanw): Remove.
	(__ev_mwlusfanw): Remove.

2002-12-05  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (*andorsi3_shift_8): New.

2002-12-05  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (shift_alg_si): Optimize ashift:HI and
	lshiftrt:SI by 28, 29, and 30 bits when !TARGET_H8300.
	(get_shift_alg): Return optimal assembly instructions for the
	shifts mentioned above.

Wed Dec  4 11:53:07 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (ix86_expand_int_movcc): Force operand into register for QImode
	condtiional moves.

2002-12-04  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (h8300_init_once): Do not use loop to
	implement ashiftrt:HI by 13 bits on H8S.

2002-12-04  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* pa/fptr.c (__canonicalize_funcptr_for_compare): New file and function.
	* pa.md (canonicalize_funcptr_for_compare): Output library call to
	canonicalize_funcptr_for_compare_libfunc on TARGET_ELF32.
	* pa32-linux.h (CANONICALIZE_FUNCPTR_FOR_COMPARE_LIBCALL,
	CTOR_LIST_BEGIN): New defines.
	* pa/t-linux (LIB2FUNCS_EXTRA): New define.
	(fptr.c): Add make rules.

2002-12-04  Geoffrey Keating  <geoffk@apple.com>

	* combine.c (combine_simplify_rtx): Add new canonicalizations.
	* doc/md.texi (Insn Canonicalizations): Document new
	canonicalizations for multiply/add combinations.
	* config/rs6000/rs6000.md: Add and modify floating add/multiply
	patterns to ensure they're used whenever they can be.

2002-12-04  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c: Update the comments related to shifts.

2002-12-04  Chris Demetriou  <cgd@broadcom.com>

	* config/mips/mips.md (get_fnaddr): Correct length attribute.

2002-12-04  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (*extzv_8_8): New.
	(*extzv_8_16): Likewise.

2002-12-04  Jason Merrill  <jason@redhat.com>

	PR c++/8461, c++/8625
	* integrate.c (copy_decl_for_inlining): Handle explicit invisible
	references.
	* tree-inline.c (initialize_inlined_parameters): Likewise.

	* tree.c (variably_modified_type_p): Just return an error_mark_node.

2002-12-04  Chris Demetriou  <cgd@broadcom.com>

	* config/mips/mips.md (get_fnaddr): Avoid placing an "la"
	macro instruction in a branch delay slot, to avoid assembler
	warnings.

2002-12-04  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR c/7622
	* c-semantics (genrtl_scope_stmt): Do not output inlined
	nested functions that contain no code.

Wed Dec  4 15:20:54 CET 2002  Jan Hubicka  <jh@suse.cz>

	* cfgrtl.c (force_nonfallthru_and_redirect):  Allow abnormal edge
	to be forced into nonfallthru.

2002-12-03  Jason Thorpe  <thorpej@wasabisystems.com>

	* config/t-netbsd (USER_H): Set to $(EXTRA_HEADERS).

2002-12-03  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/spe.md (*movv1di_const0): New pattern.

2002-12-03  Richard Henderson  <rth@redhat.com>

	* libgcc-std.ver: Inherit GCC_3.3 from GCC_3.0.

2002-12-03  Hans-Peter Nilsson  <hp@bitrange.com>

	* bitmap.c (bitmap_ior_and_compl, bitmap_union_of_diff):
	Initialize tmp.using_obstack to 0.

2002-12-03  Andreas Schwab  <schwab@suse.de>

	* config/m68k/m68k.h (EH_RETURN_DATA_REGNO): Define.
	(EH_RETURN_STACKADJ_RTX): Define.
	(EH_RETURN_HANDLER_RTX): Define.
	(ASM_PREFERRED_EH_DATA_FORMAT): Define.
	* config/m68k/m68k.c (m68k_save_reg): New function.  Handle eh
	registers and don't save fixed registers.
	(m68k_output_function_prologue): Use it.
	(use_return_insn): Likewise.
	(m68k_output_function_epilogue): Likewise.

2002-12-03  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (single_one_operand): Fix a warning.
	(single_zero_operand): Likewise.

2002-12-02  Nathanael Nerode  <neroden@gcc.gnu.org>

	* Makefile.in configure configure.in dummy-conditions.c fix-header.c
	gcov-iov.c gen-protos.c genattr.c genattrtab.c genautomata.c
	gencheck.c gencodes.c genconditions.c genconfig.c genconstants.c
	genemit.c genextract.c genflags.c gengenrtl.c gengtype-lex.l
	gengtype-yacc.y gengtype.c genopinit.c genoutput.c genpeep.c
	genpreds.c genrecog.c gensupport.c mkconfig.sh read-rtl.c
	scan-decls.c scan.c config/sh/sh.h doc/configfiles.texi
	doc/install-old.texi: Replace hconfig.h with bconfig.h.
	* Makefile.in: Replace HCONFIG_H with BCONFIG_H.

2002-12-02  Andrew Pinski  <pinskia@physics.uc.edu>

	* config/rs6000/rs6000.md (ffssi): Convert to expander.
	(ffsdi): Likewise.
	(cntlzw2, cntlzd2): New patterns.

2002-12-02  H.J. Lu <hjl@gnu.org>

	* config.gcc (mips*-*-netbsd*): Remove mips/t-netbsd.
	(mips*-*-linux*): Remove mips/t-linux.

Mon Dec  2 19:26:30 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (ix86_expand_int_movcc):  Avoid overflow.

2002-12-02  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (dosize): Replace argument op with
	sign.
	(h8300_output_function_prologue): Update the call to dosize.
	(h8300_output_function_epilogue): Likewise.

2002-12-02  Bob Wilson  <bob.wilson@acm.org>

	* config/xtensa/xtensa.h: Delete ifndefs with nothing inside them.

2002-12-02  Craig Rodrigues  <rodrigc@gcc.gnu.org>

	* configure.in: Use "missing" script to generate warning if
	flex or bison programs not found, instead of invoking "false".
	* configure: Rebuilt.

Mon Dec  2 20:28:48 CET 2002  Jan Hubicka  <jh@suse.cz>

	* unroll.c (copy_loop_body): Copy CONST_OR_PURE_CALL_P.

Mon Dec  2 19:42:52 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (ix86_expand_int_movcc):  Avoid overflow.

2002-12-02  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (dosize): Output r7/er7 instead of sp.
	(push): Likewise.
	(pop): Likewise.
	(h8300_output_function_prologue): Likewise.
	(h8300_output_function_epilogue): Likewise.

Mon Dec  2 14:43:22 2002  J"orn Rennecke <joern.rennecke@superh.com>

	* expmed.c (store_bit_field): Use int_mode_for_mode to find
	corresponding mode of non-integer mode, unless it is VOIDmode.

2002-12-02  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (stm_h8300s_2): New.
	(stm_h8300s_3): Likewise.
	(stm_h8300s_4): Likewise.
	(five define_peephole2): Likewise.

2002-12-02  Kazu Hirata  <kazu@cs.umass.edu>

	* ra-build.c: Fix a comment typo.

Sun Dec  1 16:50:47 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (ix86_expand_int_movcc): fix
	reversed BRANCH_COST test; be curefull about infinite recursion.

2002-12-01  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (h8300_output_function_prologue):
	Remove variable idx.
	(h8300_output_function_epilogue): Likewise.

2002-12-01  Zack Weinberg  <zack@codesourcery.com>

	* config/frv/xm-frv.h: Delete, unnecessary.

2002-12-01  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md: Add comments for define_peephole2.

2002-12-01  Mark Mitchell  <mark@codesourcery.com>

	* builtin-types.def (BT_SIZE): Use size_type_node.
	* builtins.c (fold_builtin): Make the builtin strlen returns a
	size_t, not a sizetype.
	* c-common.c (c_sizeof_or_alignof_type): Use size_type_node, not
	c_size_type_node.
	(c_alignof_expr): Likewise.
	(c_common_nodes_and_builtins): Likewise.
	* c-common.h (CTI_C_SIZE_TYPE): Remove.
	(c_size_type_node): Likewise.
	* c-format.c (T_ST): Use size_type_node, not c_size_type_node.
	* tree.h (TI_SIZE_TYPE): New enumeral.
	(size_type_node): Likewise.

2002-11-30  Zack Weinberg  <zack@codesourcery.com>

	* configure.in: Don't put ${tm_file} into host_xm_file,
	build_xm_file, or xm_file.  Do put tm-preds.h into tm_p_file.
	Take location of tm-preds.h into account when calculating
	tm_p_file_list.
	* configure: Regenerate.
	* mkconfig.sh: No need for separate TM_DEFINES and XM_DEFINES
	arguments.  Do not provide rtx, rtvec, tree, or GTY here.
	Remove special case code for tm_p.h and *config.h; add new
	special case code for tm.h and tconfig.h. Clean up a bit.

	* Makefile.in (tm_file, tm_file_list): New variables set from
	@-substitutions.
	(GCONFIG_H): Deleted.
	(GTM_H, TM_H): New.
	(CONFIG_H): Is now just config.h $(host_xm_file_list).
	(TM_P_H): Move up with the other mkconfig.sh-generated
	headers; don't mention tm-preds.h explicitly.
	(tm.h, cs-tm.h): New rule.
	(cs-config.h, cs-hconfig.h, cs-tconfig.h, cs-tm_p.h): Adjust
	invocations of mkconfig.sh for changes to that program.
	(mostlyclean): Delete print-rtl1.c.
	(clean): Delete tm.h.
	Update dependencies for the files listed below.

	* mklibgcc.in:  Add 'coretypes.h $(TM_H)' to libgcc2_c_dep.

	* coretypes.h: New file.
	* system.h: #define malloc to xmalloc and realloc to xrealloc
	when FLEX_SCANNER or YYBISON is defined, independent of the
	value of GCC_VERSION.
	* alias.c, attribs.c, bb-reorder.c, bitmap.c, builtins.c,
	c-aux-info.c, c-common.c, c-convert.c, c-decl.c, c-dump.c,
	c-errors.c, c-format.c, c-lang.c, c-lex.c, c-objc-common.c,
	c-opts.c, c-parse.in, c-pragma.c, c-pretty-print.c,
	c-semantics.c, c-typeck.c, caller-save.c, calls.c, cfg.c,
	cfganal.c, cfgbuild.c, cfgcleanup.c, cfglayout.c, cfgloop.c,
	cfgrtl.c, collect2.c, combine.c, conflict.c, convert.c,
	cppdefault.c, cpperror.c, cppexp.c, cppfiles.c, cpphash.c,
	cppinit.c, cpplex.c, cpplib.c, cppmacro.c, cppmain.c,
	cppspec.c, cpptrad.c, crtstuff.c, cse.c, cselib.c, dbxout.c,
	debug.c, df.c, diagnostic.c, doloop.c, dominance.c,
	dummy-conditions.c, dwarf2asm.c, dwarf2out.c, dwarfout.c,
	emit-rtl.c, errors.c, et-forest.c, except.c, explow.c,
	expmed.c, expr.c, final.c, fix-header.c, flow.c, fold-const.c,
	function.c, gcc.c, gccspec.c, gcov-dump.c, gcov-iov.c, gcov.c,
	gcse.c, gen-protos.c, genattr.c, genattrtab.c, genautomata.c,
	gencheck.c, gencodes.c, genconditions.c, genconfig.c,
	genconstants.c, genemit.c, genextract.c, genflags.c,
	gengenrtl.c, gengtype-lex.l, gengtype-yacc.y, gengtype.c,
	genopinit.c, genoutput.c, genpeep.c, genpreds.c, genrecog.c,
	gensupport.c, ggc-common.c, ggc-none.c, ggc-page.c,
	ggc-simple.c, global.c, graph.c, haifa-sched.c, hashtable.c,
	hooks.c, ifcvt.c, integrate.c, intl.c, jump.c, langhooks.c,
	lcm.c, libgcc2.c, line-map.c, lists.c, local-alloc.c, loop.c,
	main.c, mbchar.c, mips-tdump.c, mips-tfile.c, mkdeps.c,
	optabs.c, params.c, predict.c, prefix.c, print-rtl.c,
	print-tree.c, profile.c, protoize.c, ra-build.c,
	ra-colorize.c, ra-debug.c, ra-rewrite.c, ra.c, read-rtl.c,
	real.c, recog.c, reg-stack.c, regclass.c, regmove.c,
	regrename.c, reload.c, reload1.c, reorg.c, resource.c,
	rtl-error.c, rtl.c, rtlanal.c, sbitmap.c, scan-decls.c,
	scan.c, sched-deps.c, sched-ebb.c, sched-rgn.c, sched-vis.c,
	sdbout.c, sibcall.c, simplify-rtx.c, ssa-ccp.c, ssa-dce.c,
	ssa.c, stmt.c, stor-layout.c, stringpool.c, timevar.c,
	tlink.c, toplev.c, tracer.c, tree-dump.c, tree-inline.c,
	tree.c, unroll.c, varasm.c, varray.c, varray.h, vmsdbgout.c,
	xcoffout.c, config/darwin-c.c, config/darwin.c,
	config/fp-bit.c, config/alpha/alpha.c, config/alpha/vms-cc.c,
	config/alpha/vms-ld.c, config/arc/arc.c, config/arm/arm.c,
	config/arm/pe.c, config/avr/avr.c, config/c4x/c4x-c.c,
	config/c4x/c4x.c, config/cris/cris.c, config/d30v/d30v.c,
	config/dsp16xx/dsp16xx.c, config/fr30/fr30.c,
	config/frv/frv.c, config/h8300/h8300.c, config/i370/i370-c.c,
	config/i370/i370.c, config/i386/i386.c, config/i386/winnt.c,
	config/i960/i960-c.c, config/i960/i960.c,
	config/ia64/ia64-c.c, config/ia64/ia64.c, config/ip2k/ip2k.c,
	config/m32r/m32r.c, config/m68hc11/m68hc11.c,
	config/m68k/m68k.c, config/m88k/m88k.c, config/mcore/mcore.c,
	config/mips/irix6-libc-compat.c, config/mips/mips.c,
	config/mmix/mmix.c, config/mn10200/mn10200.c,
	config/mn10300/mn10300.c, config/ns32k/ns32k.c,
	config/pa/pa.c, config/pdp11/pdp11.c, config/romp/romp.c,
	config/rs6000/rs6000-c.c, config/rs6000/rs6000.c,
	config/s390/s390.c, config/sh/sh.c, config/sparc/gmon-sol2.c,
	config/sparc/sparc.c, config/stormy16/stormy16.c,
	config/v850/v850-c.c, config/v850/v850.c, config/vax/vax.c,
	config/xtensa/xtensa.c, objc/objc-act.c, objc/objc-lang.c:
	Include coretypes.h and tm.h.

	* genattrtab.c, genconditions.c, genemit.c, genextract.c,
	gengenrtl.c, gengtype.c, genopinit.c, genoutput.c, genpeep.c,
	genrecog.c: Include coretypes.h and tm.h from the file
	generated by this program.

	* unwind-dw2-fde-darwin.c, unwind-dw2-fde-glibc.c,
	unwind-dw2-fde.c, unwind-dw2.c, unwind-sjlj.c: Include
	coretypes.h and tm.h, and tsystem.h when not already included.
	No need to include stddef.h nor stdlib.h.

	* fixinc/fixlib.h: Include coretypes.h and tm.h.  Do not
	include auto-host.h or ansidecl.h/
	* fixinc/server.h: Do not include stdio.h, unistd.h, or fixlib.h.
	* fixinc/procopen.c: Include server.h after fixlib.h.  Do not
	include auto-host.h, ansidecl.h, or system.h.
	* fixinc/server.c: Likewise.  Also, do not include signal.h,
	and do not redefine volatile.

Sat Nov 30 17:16:46 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (movdf_integer):  Always enable in 64bit.
	(movdf_nointeger): Always disable in 64bit.

2002-11-30  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* cfg.c (dump_flow_info): Use max_reg_num () to determine the largest
	pseudo register number plus 1.

Fri Nov 29 20:10:56 2002  J"orn Rennecke <joern.rennecke@superh.com>

	* expmed.c (store_bit_field): Use int_mode_for_mode to find
	corresponding mode of non-integer mode, unless it is VOIDmode.

2002-11-29  Hans-Peter Nilsson  <hp@bitrange.com>

	* cpplib.c (_cpp_test_assertion): Default *value to 0.

	* cppexp.c (num_part_mul): Initialize result.unsignedp, to 1.

2002-11-29  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/t-crtstuff: New target makefile fragment.
	* config.gcc [s390-*-linux, s390x-*-linux]: Use it.

2002-11-29  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (movsi_h8300hs): Change the order of
	alternatives to correct the length when the memory operand is
	either pre_dec or post_inc.

2002-11-29  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (an anonymous pattern): Give an
	internal name *tst_extzv_bitqi_1_n.
	Accept bit_operand instead of bit_memory_operand.
	Do not accept bit tests with the MSB.
	(*tst_extzv_memqi_1_n): New.

Thu Nov 28 23:56:24 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (ix86_expand_int_movcc): Add copy_rtx to avoid invalid RTX
	sharing when operand is SUBREG.

Thu Nov 28 08:57:26 CET 2002  Jan Hubicka  <jh@suse.cz>

	* athlon.md (athlon-decodev): New reservation unit.
	(athlon-direct0): New reservation.
	(athlon-vector): New use athlon-decodev.
	(athlon-double, athlon-direct): Better model.
	(athlon_imul_k8): Use athlon-direct0.
	(athlon_movlpd_load): New insn reservation.

2002-11-28  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (h8300_eightbit_constant_address_p):
	Fix a comment typo.
	(h8300_tiny_constant_address_p): Likewise.

2002-11-28  Michael Matz  <matz@suse.de>

	* doc/passes.texi: Mention the other register allocator.

2002-11-28  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (6 new peephole2 patterns): New.

2002-11-28  Jakub Jelinek  <jakub@redhat.com>

	* config.gcc (x86_64-*-linux*) [tmake_file]: Remove i386/t-crtstuff.
	* config/t-linux (CRTSTUFF_T_CFLAGS_S): Add $(CRTSTUFF_T_CFLAGS).
	* config/i386/t-linux64 (CRTSTUFF_T_CFLAGS): Define.

2002-11-28  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (h8300_and_costs): New.
	* config/h8300/h8300.h (RTX_COSTS): Use h8300_and_costs.
	* config/h8300/h8300-protos.h: Add a prototype for
	h8300_and_costs.

Wed Nov 27 20:34:13 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (x86_sse_partial_regs_for_cvtsd2ss): New.
	* i386.h (x86_sse_partial_regs_for_cvtsd2ss): Declare.
	(TARGET_SSE_PARTIAL_REGS_FOR_CVTSD2SS): New macro.
	* i386.md (truncdfsf patterns and splitters): Use
	TARGET_SSE_PARTIAL_REGS_FOR_CVTSD2SS

2002-11-27  Zack Weinberg  <zack@codesourcery.com>

	* config/rs6000/rs6000.c (altivec_init_builtins): Make the
	pointer argument in the prototypes of the following builtins
	be (const TYPE *) rather than (TYPE *):
	 + __builtin_altivec_ld_internal_4sf
	 + __builtin_altivec_ld_internal_4si
	 + __builtin_altivec_ld_internal_8hi
	 + __builtin_altivec_ld_internal_16qi
	 + __builtin_altivec_lvsl
	 + __builtin_altivec_lvsr
	 + __builtin_altivec_lvebx
	 + __builtin_altivec_lvehx
	 + __builtin_altivec_lvewx
	 + __builtin_altivec_lvxl
	 + __builtin_altivec_lvx
	 + __builtin_altivec_dst
	 + __builtin_altivec_dstt
	 + __builtin_altivec_dstst
	 + __builtin_altivec_dststt

2002-11-27  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* except.c (default_exception_section): Move variable into the
	scope where it is used.

2002-11-27  Krister Walfridsson  <cato@df.lth.se>

	* config.gcc (*-*-netbsd[2-9]*, *-*-netbsdelf[2-9]*): Test for
	correct version.

2002-11-27  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.h (OK_FOR_U): Remove extra parentheses.

2002-11-27  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (h8300_shift_costs): New.
	* config/h8300/h8300.h (RTX_COSTS): Use h8300_shift_costs.
	* config/h8300/h8300-protos.h: Add a prototype for
	h8300_shift_costs.

2002-11-27  Jim Wilson  <wilson@redhat.com>

	* config/rs6000/spe.md (spu_evsplatfi, spu_evsplati): Swap operands
	in output template.

2002-11-27  Casper S. Hornstrup  <chorns@users.sourceforge.net>

	* config/i386/i386.h (DLL_IMPORT_EXPORT_PREFIX): Define.
	* config/i386/winnt.c (i386_pe_dllexport_name_p): Use
	DLL_IMPORT_EXPORT_PREFIX, not '@'.
	(i386_pe_dllimport_name_p): Likewise.
	(i386_pe_mark_dllexport): Likewise.
	(i386_pe_mark_dllimport): Likewise.
	(i386_pe_encode_section_info): Likewise.
	(i386_pe_strip_name_encoding): Likewise.

2002-11-27  Richard Henderson  <rth@redhat.com>

	* mkmap-symver.awk (BEGIN): Set sawsymbol false.
	(nm && NF == 3): Set sawsymbol true.
	(END): Exit if no symbols seen.
	(output): Fix map syntax error if no globals for the version.

Wed Nov 27 14:45:46 CET 2002  Jan Hubicka  <jh@suse.cz>

	* builtins.def (DEF_C99_BUILTIN): Fix.

2002-11-26  Kaz Kojima  <kkojima@gcc.gnu.org>

	* config/sh/lib1funcs.asm (FUNC, ENDFUNC0, ENDFUNC): New macros.
	(all): Add .size and .type information.

Tue Nov 26 22:43:50 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (ix86_expand_int_movcc):  Do not emit lea for short mode on
	partial_reg_stall target.

Tue Nov 26 22:27:47 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (movhicc): Allow general operand.
	(movqicc): New expander.
	(movqicc_noc): New pattern.
	* i386.c (ix86_expand_carry_flag_compare): New function.
	(ix86_expand_int_movcc): Optimize harder using sbb; support more
	HImode conversion; support QImode conditional moves

Tue Nov 26 16:30:59 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (FAST_PROLOGUE_INSN_COUNT): Set to 20.
	(ix86_expand_prologue): Multiply the count by amount of registers to be
	pushed.

Tue Nov 26 15:55:27 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (override_options): Error about wrong -mcpu on x86-64
	compilation.

2002-11-26  NIIBE Yutaka  <gniibe@m17n.org>

	* config/sh/linux.h (FUNCTION_PROFILER): Implemented.

Tue Nov 26 00:14:20 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386-protos.h (x86_extended_QIreg_mentioned_p,
	x86_extended_reg_mentioned_p): Declare.
	* i386.c (extended_reg_mentioned_1): New static function.
	(x86_extended_QIreg_mentioned_p,
	x86_extended_reg_mentioned_p): New global functions.
	* i386.h (REX_SSE_REGNO_P): New macro.
	* i386.md (prefix_rex): New attribute.
	(length attribute): Add rex.

2002-11-26  Andrew Haley  <aph@redhat.com>

	* unwind-sjlj.c (_Unwind_FindEnclosingFunction): Rename
	from_Unwind_Find_Enclosing_Function.
	* unwind-dw2.c (_Unwind_FindEnclosingFunction): Likewise.
	* config/ia64/unwind-ia64.c (_Unwind_FindEnclosingFunction): Likewise.
	* libgcc-std.ver (_Unwind_FindEnclosingFunction): Rename from
	_Unwind_Find_Enclosing_Function, export @@GCC_3.3.
	* unwind.h (_Unwind_FindEnclosingFunction): Add.

2002-11-26  Hartmut Penner  <hpenner@de.ibm.com>

	* config/s390/s390.c (390_output_constant_pool): Set alignment
	before label in 64 bit mode, behind otherwise.

2002-11-26  Richard Henderson  <rth@redhat.com>

	* c-common.c (handle_visibility_attribute): Accept "default".
	* tree.h (enum symbol_visibility): New.
	(decl_visibility): Declare.
	* target.h (gcc_target.visibility): Take visibility arg as integer.
	* varasm.c (default_assemble_visibility): Likewise.
	(decl_visibility): New.
	(maybe_assemble_visibility): Use it.
	* output.h (default_assemble_visibility): Update prototype.
	* config/rs6000/rs6000.c (rs6000_assemble_visibility): Take
	visibility arg as integer.
	* doc/extend.texi: Document default visibility.

2002-11-26  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c: Adjust spacing.
	* config/h8300/h8300.h: Likewise.

2002-11-26  Richard Henderson  <rth@redhat.com>

	* hooks.c (hook_bool_void_false, hook_void_tree_int,
	hook_void_FILEptr_constcharptr): Rename so that the return
	type is first.
	(hook_int_tree_tree_1, hook_void_tree, hook_void_tree_treeptr,
	hook_bool_tree_false): New.
	* hooks.h: Update.
	* langhooks-def.h: Update for renames.
	* target-def.h: Likewise.
	* tree.c (default_comp_type_attributes,
	default_set_default_type_attributes, default_insert_attributes,
	default_function_attribute_inlinable_p,
	default_ms_bitfield_layout_p): Remove.
	* tree.h: Update.

2002-11-26  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* pa-protos.h (function_value): New prototype.
	* pa.c (function_value): Use a PARALLEL to return small aggregates on
	TARGET_64BIT.
	* pa.h (FUNCTION_VALUE): Use function_value.
	* pa.md (call_value_internal_symref, call_value_internal_reg_64bit,
	call_value_internal_reg, sibcall_value_internal_symref,
	sibcall_value_internal_symref_64bit): Remove =rf constraint on return
	value.

2002-11-26  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* expr.c (gen_group_rtx, emit_group_move): New functions.
	* expr.h (gen_group_rtx, emit_group_move): Prototype.
	* function.c (expand_function_start): Use gen_group_rtx to create a
	PARALLEL rtx to hold the return value when the real return rtx is a
	PARALLEL.
	(expand_function_end): Use emit_group_move to move the return value
	from a PARALLEL to the real return registers.
	* rtl.h (REG_FUNCTION_VALUE_P): Allow function values to be returned
	in PARALLELs.

2002-11-26  Jason Thorpe  <thorpej@wasabisystems.com>

	* config/t-libc-ok: Fix typo.

2002-11-26  Jakub Jelinek  <jakub@redhat.com>

	* configure.in: Move AC_CANONICAL_SYSTEM and AC_ARG_PROGRAM back
	before AC_PROG_CC.
	* configure: Rebuilt.

2002-11-26  Nathan Sidwell  <nathan@codesourcery.com>

	* c-decl.c: (start_struct): Commonize flag setting.

2002-11-26  Jason Thorpe  <thorpej@wasabisystems.com>

	* config/rs6000/rs6000.h (RS6000_CPU_CPP_ENDIAN_BUILTINS): New.
	* config/rs6000/rs6000-c.c (rs6000_cpu_cpp_builtins): Use
	RS6000_CPU_CPP_ENDIAN_BUILTINS.
	* config/rs6000/netbsd.h (RS6000_CPU_CPP_ENDIAN_BUILTINS): Redefine.

2002-11-26  Hartmut Penner  <hpenner@de.ibm.com>

	* config/s390/s390.md (literal_pool_64, literal_pool_31 ): New
	insns.
	* config/s390/s390.c (struct machine_function): Introduction of
	struct machine_function.
	(s390_output_symbolic_const): Use of cfun.
	(s390_optimize_prolog): Likewise.
	(s390_fixup_clobbered_return_reg): Likewise.
	(s390_frame_info): Likewise.
	(s390_emit_prologue, s390_emit_epilogue): Likewise.
	(s390_init_machine_status): New function.
	(override_options): call s390_init_machine_status.
	* config/s390/s390-protos.h (s390_output_constant_pool): Changed
	prototype.

2002-11-26  Jakub Jelinek  <jakub@redhat.com>

	* varasm.c (output_constant_pool): For pool constants in mergeable
	section ensure each constant is padded to multiple of entity size.

2002-11-26  Jakub Jelinek  <jakub@redhat.com>

	* varasm.c (default_exception_section): Move to...
	* except.c (default_exception_section): ... here. Make
	.gcc_except_table read-only if it is not expected to have any
	dynamic relocations and linker handles it.
	* dwarf2out.c (default_eh_frame_section): Make .eh_frame read-only
	if it is not expected to have any dynamic relocations and linker
	handles it.
	* configure.in (HAVE_LD_RO_RW_SECTION_MIXING): Check what ld does
	when linking read-only and read-write sections together.
	* configure, config.in: Rebuilt.
	* crtstuff.c (EH_FRAME_SECTION_CONST): Define.
	(__EH_FRAME_BEGIN__, __FRAME_END__): Add it.

Mon Nov 25 18:32:37 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (pushsf_rex64): Fix typo.

2002-11-25  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/spe.h (__ev_create_sfix32_fs): Change macro into
	new function.
	(__ev_create_ufix32_fs): Same.
	(__ev_get_sfix32_fs_internal): New.
	(__ev_get_sfix32_fs): Define to use function.
	(__ev_get_ufix32_fs_internal): New.
	(__ev_get_ufix32_fs): Define to use function.
	(__ev_get_upper_ufix32_fs): Call __ev_get_ufix32_fs.
	(__ev_get_lower_ufix32_fs): Same.
	(__ev_get_upper_sfix32_fs): Call __ev_get_sfix32_fs.
	(__ev_get_lower_sfix32_fs): Same.
	(__ev_set_sfix32_fs_internal): New.
	(__ev_set_ufix32_fs_internal): New.
	(__ev_set_sfix32_fs): Call __ev_set_sfix32_fs_internal.
	(__ev_set_ufix32_fs): Call __ev_set_ufix32_fs_internal.
	(__ev_set_upper_sfix32_fs): Call function.
	(__ev_set_lower_sfix32_fs): Same.
	(__ev_set_upper_ufix32_fs): Same.
	(__ev_set_lower_ufix32_fs): Same.

2002-11-25  Douglas B Rupp  <rupp@gnat.com>

	* gcc.c (do_spec_1): Reset delete_this_arg to zero.

2002-11-25  Jason Thorpe  <thorpej@wasabisystems.com>

	* config/elfos.h (HANDLE_SYSV_PRAGMA): Define as 1.
	* config/interix.h (HANDLE_SYSV_PRAGMA): Likewise.
	* config/linux-aout.h (HANDLE_SYSV_PRAGMA): Likewise.
	* config/lynx-ng.h (HANDLE_SYSV_PRAGMA): Likewise.
	* config/lynx.h (HANDLE_SYSV_PRAGMA): Likewise.
	* config/netbsd.h (HANDLE_SYSV_PRAGMA): Likewise.
	* config/openbsd.h (HANDLE_SYSV_PRAGMA: Likewise.
	* config/alpha/elf.h (HANDLE_SYSV_PRAGMA): Likewise.
	* config/arm/netbsd.h (HANDLE_SYSV_PRAGMA): Likewise.
	* config/cris/aout.h (HANDLE_SYSV_PRAGMA): Likewise.
	* config/d30v/d30v.h (HANDLE_SYSV_PRAGMA): Likewise.
	* config/frv/frv.h (HANDLE_SYSV_PRAGMA): Likewise.
	* config/i386/djgpp.h (HANDLE_SYSV_PRAGMA): Likewise.
	* config/i386/i386-interix.h (HANDLE_SYSV_PRAGMA): Likewise.
	* config/i386/vxi386.h (HANDLE_SYSV_PRAGMA): Likewise.
	* config/ia64/ia64.h (HANDLE_SYSV_PRAGMA): Likewise.
	* config/m88k/m88k.h (HANDLE_SYSV_PRAGMA): Likewise.
	* config/mmix/mmix.h (HANDLE_SYSV_PRAGMA): Likewise.
	* config/rs6000/aix.h (HANDLE_SYSV_PRAGMA): Likewise.
	* config/rs6000/darwin.h (HANDLE_SYSV_PRAGMA): Likewise.
	* config/sparc/linux-aout.h (HANDLE_SYSV_PRAGMA): Likewise.
	* config/sparc/vxsparc64.h (HANDLE_SYSV_PRAGMA): Likewise.
	* config/stormy16/stormy16.h (HANDLE_SYSV_PRAGMA): Likewise.
	* config/alpha/osf.h (HANDLE_SYSV_PRAGMA): Don't undef before
	defining.
	* config/i386/sco5.h (HANDLE_SYSV_PRAGMA): Likewise.
	* config/mips/iris5.h (HANDLE_SYSV_PRAGMA): Likewise.

2002-11-25  Dave Pitts  <dpitts@cozx.com>

	* gcc/fixinc/mkfixinc.sh: add i370-*-openedition to bypass fixinc list

2002-11-25  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (an anonymous pattern): New.

2002-11-25  Richard Henderson  <rth@redhat.com>

	* alias.c (find_base_value): Use new_reg_base_value if it's live.
	(copying_arguments): Make boolean.

2002-11-25  Jason Thorpe  <thorpej@wasabisystems.com>

	* gcc.c (static_spec_functions): Add if-exists-else spec
	function.
	(if_exists_else_spec_function): New function.
	* doc/invoke.texi: Document the if-exists-else spec function.

	* config/netbsd-elf.h (NETBSD_STARTFILE_SPEC): For -static, use
	"%:if-exists-else(crtbeginT%O%s crtbegin%O%s)".

2002-11-25  Jason Thorpe  <thorpej@wasabisystems.com>

	* config.gcc (powerpc-*-netbsd*): Replace "svr4.h" with
	"netbsd.h netbsd-elf.h" in tm_file.  Set tmake_file to
	"${tmake_file} rs6000/t-netbsd".
	* config/rs6000/netbsd.h: Rewrite.
	* config/rs6000/t-netbsd: New file.

2002-11-25  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (an anonymous pattern): Relax the
	condition for the pattern.

2002-11-25  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.h (enum rs6000_builtins): Remove evmwlssf,
	evmwlsmf, evmwlssfa, evmwlsmfa, evmwlssfaaw, evmwlsmfaaw,
	evmwlssfanw, evmwlsmfanw.

	* config/rs6000/rs6000.c (bdesc_2arg): Same.

	* config/rs6000/spe.md: Same for patterns.

2002-11-25  Christian Ehrhardt  <ehrhardt@mathematik.uni-ulm.de>

	PR c/8639
	* fold-const.c (extract_muldiv): Don't propagate division unless
	both arguments are multiples of C.

2002-11-25  Andrew Haley  <aph@redhat.com>

	* libgcc-std.ver (_Unwind_Find_Enclosing_Function): Add.
	* config/ia64/unwind-ia64.c (_Unwind_Find_Enclosing_Function): New.
	* unwind-sjlj.c (_Unwind_Find_Enclosing_Function): Likewise.
	* unwind-dw2.c (_Unwind_Find_Enclosing_Function): Likewise.

Sun Nov 24 10:38:04 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (x86_use_ffreep): New global variable.
	* i386.h (x86_use_frfeep): Declare
	(TARGET_USE_FFREEP): New macro
	* i386.md  (movs?f*): Use freep when asked for.
	(push?f): Remove dead code.

2002-11-24  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (h8300_init_once): Fix a typo in the
	target help message.

2002-11-24  Jason Thorpe  <thorpej@wasabisystems.com>

	* config.gcc (*-*-netbsd*1.[7-9]*, *-*-netbsd*[2-9]*): Set
	extra_parts to "crtbegin.o crtend.o crtbeginS.o crtendS.o
	crtbeginT.o".
	(arm*-*-netbsd*, i[34567]86-*-netbsd*, m68k*-*-netbsd*)
	(ns32k-*-netbsd*, sparc-*-netbsd*, vax-*-netbsd*): Set extra_parts
	to "" for a.out configurations.
	* config/t-netbsd (CRTSTUFF_T_CFLAGS): Set to "-fPIC".

2002-11-24  Jason Thorpe  <thorpej@wasabisystems.com>

	* config/alpha/netbsd.h (CPP_SUBTARGET_SPEC): Just use
	NETBSD_CPP_SPEC directly.
	(SUBTARGET_EXTRA_SPECS): Remove netbsd_cpp_spec.  Add
	netbsd_endfile_spec.
	(ENDFILE_SPEC): Use %(netbsd_endfile_spec).

2002-11-24  Jason Thorpe  <thorpej@wasabisystems.com>

	* config/netbsd-elf.h (STARTFILE_SPEC): Rename to
	NETBSD_STARTFILE_SPEC.
	(STARTFILE_SPEC): Redefine in terms of NETBSD_STARTFILE_SPEC.
	(ENDFILE_SPEC): Likewise.
	* config/netbsd.h (LIB_SPEC, LIBGCC_SPEC): Likewise.

2002-11-24  Andreas Schwab  <schwab@suse.de>

	* Makefile.in (install-driver): Remove versioned link before
	trying to create it.

	* config/m68k/m68k.c: Fix typo in last change defining
	TARGET_ASM_CAN_OUTPUT_MI_THUNK.

2002-11-23  H.J. Lu <hjl@gnu.org>

	* aclocal.m4: Include ../config/accross.m4.
	(gcc_AC_COMPILE_CHECK_SIZEOF): Removed.
	(gcc_AC_C_COMPILE_ENDIAN): Removed.
	(gcc_AC_C_FLOAT_FORMAT): Check $ac_cv_c_bigendian
	instead of $ac_cv_c_compile_endian.

	* configure.in: Replace gcc_AC_COMPILE_CHECK_SIZEOF with
	AC_COMPILE_CHECK_SIZEOF.
	Replace gcc_AC_C_COMPILE_ENDIAN with AC_C_BIGENDIAN_CROSS.
	* configure: Rebuild.

2002-11-23  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (print_operand): Update the use of
	h8300_tiny_constant_address_p.
	(h8300_adjust_insn_length): Likewise.
	(h8300_tiny_constant_address_p): Check if the given rtx is a
	variable declared with __attribute__ ((tiny_data)).

2002-11-22  Dale Johannesen  <dalej@apple.com>

	* toplev.c (rest_of_compilation):  Fix comments.

2002-11-22  Geoffrey Keating  <geoffk@apple.com>

	* aclocal.m4 (ac_cv_func_mmap_dev_zero): Darwin does not
	allow mmap from /dev/zero.  Don't make decisions for the host
	based on presence or absence of /dev/zero on the build machine.
	(ac_cv_func_mmap_anon): Darwin does have working MMAP_ANON.
	(AC_FUNC_MMAP_FILE): Darwin does have mmap of a file.
	* configure: Regenerate.

2002-11-22  Daniel Jacobowitz  <drow@mvista.com>

	* gcc.c (make_relative_prefix, split_directories)
	(free_split_directories): Removed.

2002-11-22  Daniel Jacobowitz  <drow@mvista.com>

	* configure.in: Set insn=nop for DWARF-2 tests on ARM.
	* configure: Regenerated.

2002-11-22  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (compute_a_shift_length): Fix the insn
	length computation when xor.l is output.

2002-11-21  Douglas B Rupp  <rupp@gnat.com>

	* alpha.md (movstrdi, clrstrdi): New VMS patterns.
	(call_vms_1, call_value_vms_1): Cleanup syntax.

Thu Nov 21 19:20:27 CET 2002  Jan Hubicka  <jh@suse.cz>

	* athlon.md (define_atuomaton): Add athlon_load.
	(athlon-double): New reservation.
	(athlon-ieu0): New CPU unit.
	(athlon-load?): Use athlon_load automaton.
	(*_k8 reservations): New.
	(other insn revervations): Activate for K8.

Thu Nov 21 15:07:42 CET 2002  Jan Hubicka  <jh@suse.cz>

	* cfgrtl.c (verify_flow_info):  Accept EDGE_CAN_FALLTHRU flag.

2002-11-21  Jim Wilson  <wilson@redhat.com>

	* config/rs6000/rs6000.c (function_arg): Set inner mode of SPE
	vectors to SI.

2002-11-21  Bob Wilson  <bob.wilson@acm.org>

	* config/xtensa/xtensa-protos.h (xtensa_copy_incoming_a7): Declare.
	* config/xtensa/xtensa.c (struct machine_function): Add
	incoming_a7_copied flag.
	(xtensa_copy_incoming_a7): Define.
	(xtensa_emit_move_sequence): Use xtensa_copy_incoming_a7.
	* config/xtensa/xtensa.md (movdi, movsf, movdf): Ditto.

Thu Nov 21 23:52:04 CET 2002  Jan Hubicka  <jH@suse.cz>

	* i386-protos.h (x86_64_sign_extended_value): Fix prototype.
	* i386.c (x86_64_general_operand, x86_64_szext_general_operand,
	x86_64_nonmemory_operand, x86_64_movabs_operand,
	x86_64_szext_nonmemory_operand, x86_64_immediate_operand,
	ix86_expand_int_movcc): Update call of x86_64_sign_extended_value.
	(local_symbolic_operand): Do not care the 64bit limits.
	(x86_64_sign_extended_value): Remove allow_rip support.
	(legitimate_pic_address_disp_p): Handle all cases allowed
	with RIP addressing.
	(legitimate_address_p): Use legitimate_pic_address_disp_p for PIC.
	(legitimize_pic_address): Reorganize.
	* i386.h (EXTRA_CONSTRAINT): Update call of x86_64_sign_extended_value.

2002-11-21  Jason Thorpe  <thorpej@wasabisystems.com>

	* config.gcc (arm*-*-netbsdelf*): Enable configuration.
	* config/arm/netbsd-elf.h: New file.

2002-11-21  Jason Thorpe  <thorpej@wasabisystems.com>

	* config/arm/elf.h (SUBTARGET_EXTRA_SPECS): Add
	subtarget_asm_float_spec.
	(SUBTARGET_ASM_FLOAT_SPEC): Define, moving the
	defaults from...
	(ASM_SPEC): ...here.  Use subtarget_asm_float_spec.

2002-11-21  Nick Clifton  <nickc@redhat.com>

	* config/fr30/fr30.md (movsf_constant_store): Move code to
	detect 0.0 into fr30.c.
	* config/fr30/fr30-protos.h (fr30_const_double_is_zero):
	Prototype.
	* config/fr30/fr30.c (fr30_const_double_is_zero): New
	function.  Return true if the rtx is 0.0.

2002-11-21  Jason Thorpe  <thorpej@wasabisystems.com>

	* config/arm/elf.h (ASM_SPEC, LINK_SPEC): Pass -EL
	if -mlittle-endian is specified.

2002-11-21  Richard Earnshaw  <rearnsha@arm.com>

	PR optimization/2903
	* arm.md (anddi_notzesidi_di): Operand 2 is inverted not operand 1.
	(anddi_notsesidi_di): Likewise.

2002-11-21  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (print_operand): Use
	h8300_eightbit_constant_address_p and
	h8300_tiny_constant_address_p.
	(h8300_adjust_insn_length): Likewise.
	* config/h8300/h8300.h (EIGHTBIT_CONSTANT_ADDRESS_P): Remove.
	(TINY_CONSTANT_ADDRESS_P): Likewise.
	(OK_FOR_U): Use eightbit_constant_address_p.

2002-11-21  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/libgcc-libc.ver: Add multilib support.
	* config/s390/linux.h (MULTILIB_DEFAULT): Define.
	* config/s390/t-linux64 (MULTILIB_OPTIONS, MULTILIB_DIRNAMES,
	MULTILIB_OSDIRNAMES, LIBGCC, INSTALL_LIBGCC,
	EXTRA_MULTILIB_PARTS): Define.

2002-11-21  Richard Earnshaw  <rearnsha@arm.com>

	* arm.c (arm_get_frame_size): A leaf function does not need its
	stack padding to an aligned boundary if it has no frame.
	(thumb_get_frame_size): Likewise.

Wed Nov 20 22:25:53 CET 2002  Jan Hubicka  <jh@suse.cz>

	* x86-64.h (MCOUNT_NAME): Fix typo in my previous patch.
	(override_options): Likewise.

Wed Nov 20 19:07:17 CET 2002  Jan Hubicka  <jh@suse.cz>

	* config.gcc: Add k8 target alias support
	* i386.c (_cost): Declare costs for various variants of divides and
	multiplies.
	(k8_cost): New.
	(m_K8, m_ATHLON_K8): New macros.
	(x86_use_leave, x86_push_memory, x86_movx, x86_unroll_strlen,
	x86_cmove, x86_3dnow_a, x86_deep_branch, x86_use_fiop,
	x86_promote_QImode, x86_sub_esp_?, x86_add_esp_?,
	x86_integer_DFmode_moves, x86_partial_reg_dependency,
	x86_memory_mismatch_stall, x86_accumulate_outgoing_args,
	x86_prologue_using_move, x86_epilogue_using_move,
	x86_arch_always_fancy_math_387, x86_sse_partial_regs,
	x86_sse_typeless_stores): Set for K8
	(override_options): Add k8 support; fix athlon alignment;
	complain about non-x86-64 capable CPU being used in x86-64 compilation.
	(ix86_issue_rate): Set for K8.
	(ix86_adjust_cost, ia32_use_dfa_pipeline_interface,
	x86_machine_dependent_reorg): Handle K8 like
	* i386.h
	(x86_costs):  Change mult_init and divide into array.
	(TARGET_K8, TARGET_ATHLON): New macros.
	(MODE_INDEX): New macro.
	(RTX_COST): Use new costs.
	(TARGET_CPU_CPP_BUILTINS):  Define __k8__ and __tune_k8__.
	(TARGET_CPU_DEFAULT_NAMES): Add k8
	(TARGET_CPU_DEFAULT_k8): New constant
	(enum processor_type): Add PROCESSOR_K8.
	* i386.md (cpu attribute): Add k8.

	* invoke.texi: Document -march=k8.

	* i386.md (type attribute): Add leave
	(mode attribute): Remove unknownfp.
	(length_immediate, modrm, memory attributes): Handle leave correctly.
	(fp comparison patterns): Determine FP mode.
	(leave, leave_rex64): Remove special cases.
	* ppro.md (ppro_uops, ppro_p2): Add leave
	* pentiun.md (pent_pop): Handle leave too.
	* k6.md (k6_load): Handle leave.
	* athlon.md (athlon_leave, athlon_pop): Fix.
	(athlon_decode): Handle leave.

2002-11-20  Steve Ellcey  <sje@cup.hp.com>

	* emit-rtl.c (gen_reg_rtx): Simplify mapping of Complex type
	to component type using GET_MODE_INNER.
	* expr.c (emit_move_insn_1): Ditto.
	* optabs.c (expand_binop): Ditto.
	(expand_unop): Ditto.
	(expand_complex_abs): Ditto.

2002-11-20  Douglas B Rupp  <rupp@gnat.com>

	* hwint.h (HAVE___INT64): Fix typo (was HAVE__INT64).

2002-11-20  DJ Delorie  <dj@redhat.com>

	* config/stormy16/stormy16.c (s16builtins,
	xstormy16_init_builtins, xstormy16_expand_builtin): New.
	* config/stormy16/stormy16.md (divmodhi4, sdivlh, udivlh): New.

2002-11-20  Hans-Peter Nilsson  <hp@bitrange.com>

	* Makefile.in (RUN_GEN, VALGRIND_DRIVER_DEFINES): New variables.
	(DRIVER_DEFINES): Add $(VALGRIND_DRIVER_DEFINES).
	(executing gencheck, genconfigs, genconditions, genflags,
	gencodes, genconstants, genemit, genrecog, genopinit, genextract,
	genpeep, genattr, genattrtab, genoutput, gengenrtl, genpreds,
	gengtype, genprotos): Prepend $(RUN_GEN).
	* configure.in: Move host compiler tests before --enable-checking
	tests.
	(--enable-checking=valgrind): New.
	* config.in, configure: Regenerate.
	* cppfiles.c [!ENABLE_VALGRIND_CHECKING] (VALGRIND_DISCARD):
	Define as empty.
	(read_include_file): When doing the mmap+1 trick,
	valgrind-annotate the byte after the mmap:ed area as readable.
	(purge_cache): Remove above annotation.
	* gcc.c (execute) [ENABLE_VALGRIND_CHECKING]: Arrange to prepend
	VALGRIND_PATH -q to each command.

	* ggc-common.c [!ENABLE_VALGRIND_CHECKING] (VALGRIND_DISCARD):
	Define as empty.
	(ggc_realloc): Update valgrind annotations.
	* ggc-page.c [!ENABLE_VALGRIND_CHECKING] (VALGRIND_DISCARD):
	Define as empty.
	(alloc_anon, free_page, ggc_alloc, poison_pages): Add machinery to
	valgrind-annotate memory.

2002-11-20  Ulrich Weigand  <uweigand@de.ibm.com>

	* recog.c (constrain_operands): Prefer exact match over reloadable
	EXTRA_MEMORY_CONSTRAINT or EXTRA_ADDRESS_CONSTRAINT.

	* reload.c (find_reloads): Always reload EXTRA_ADDRESS_CONSTRAINT
	operands in Pmode.

2002-11-20  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR c/8518
	* c-decl.c (duplicate_decls): Outline the second definition
	of an extern inline function in all cases.

2002-11-20  Richard Sandiford  <rsandifo@redhat.com>

	* stor-layout.c (place_field): Update rli->offset as well as
	rli->bitpos.

2002-11-20  Richard Sandiford  <rsandifo@redhat.com>

	* sched-deps.c (sched_analyze): Check HARD_REGNO_CALL_PART_CLOBBERED.

2002-11-20  Richard Sandiford  <rsandifo@redhat.com>

	* config/sh/sh.md (udivsi3): Don't put udivsi3_i4_media instructions
	into a libcall block.
	(divsi3): Likewise divsi3_i4_media.

2002-11-20  Richard Sandiford  <rsandifo@redhat.com>

	* global.c (find_reg): Check HARD_REGNO_NREGS before kicking
	out another register.

2002-11-20  Jakub Jelinek  <jakub@redhat.com>

	* combine.c (force_to_mode): Only replace with (not Y) if all bits in fuller_mask
	(not just mask) are set in C.

2002-11-19  Steven Bosscher <steven.bosscher@usafa.af.mil>

	* config/mips/vr.h (DRIVER_SELF_SPECS): Change %{<mgp32} to %<mgp32.

2002-11-19  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	* profile.c (index_counts_file): Fix obvious mistake.

2002-11-19  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	* Makefile.in (profile.o): Add hashtab.h dependency.
	* gcov-io.h (GCOV_SUMMARY_LENGTH): New.
	* profile.c: Include hashtab.h.
	(htab_counts_index_hash, htab_counts_index_eq, htab_counts_index_del,
	cleanup_counts_index, index_counts_file, struct section_reference,
	struct da_index_entry, counts_file_name, counts_file_index): New.
	(get_exec_counts, init_branch_prob): Modified.

2002-11-19  Kaz Kojima  <kkojima@gcc.gnu.org>

	* config.gcc (sh*-*-linux*): Add t-slibgcc-elf-ver and t-linux
	to tmake_file. Remove setting gas and gnu_ld here.
	* config/sh/libgcc-glibc.ver: New file.
	* config/sh/t-linux (EXTRA_MULTILIB_PARTS): Add crtbeginT.o.
	(SHLIB_MAPFILES): New.
	* config/sh/linux.h (MD_EXEC_PREFIX): Undefine.
	(MD_STARTFILE_PREFIX): Likewise.
	(HANDLE_PRAGMA_PACK_PACK_PUSH_POP): Define.
	(DWARF2_UNWIND_INFO): Redefine.
	(ASM_PREFERRED_EH_DATA_FORMAT): Define.
	(LINK_EH_SPEC): Redefine.
	(MD_FALLBACK_FRAME_STATE_FOR): Define except for SH-media.
	(SH_FALLBACK_FRAME_FLOAT_STATE): Define.
	(SH_DWARF_FRAME_GP0, SH_DWARF_FRAME_FP0, SH_DWARF_FRAME_XD0,
	SH_DWARF_FRAME_BT0, SH_DWARF_FRAME_PR, SH_DWARF_FRAME_PR_MEDIA,
	SH_DWARF_FRAME_GBR, SH_DWARF_FRAME_MACH, SH_DWARF_FRAME_MACL,
	SH_DWARF_FRAME_PC, SH_DWARF_FRAME_SR, SH_DWARF_FRAME_FPUL,
	SH_DWARF_FRAME_FPSCR): Likewise.
	* config/sh/sh-protos.h (sh_set_return_address): Declare.
	* config/sh/sh.c (calc_live_regs): Count EH_RETURN_DATA_REGNO
	registers if the current function calls EH return.
	(sh_expand_epilogue): Handle EH stack adjustments.
	(sh_set_return_address): New function.
	* config/sh/sh.h (SH_DBX_REGISTER_NUMBER): Handle PR_MEDIA_REG.
	Don't abort even if the number is mapped to -1.
	(EH_RETURN_DATA_REGNO): Define.
	(EH_RETURN_STACKADJ_RTX): Define.
	* config/sh/sh.md (UNSPEC_EH_RETURN): New.
	(eh_return): New pattern.
	(eh_set_ra_di, eh_set_ra_si): Likewise.
	Add splitter to perform EH return after reload.

Tue Nov 19 12:52:07 2002  J"orn Rennecke <joern.rennecke@superh.com>

	* stor-layout.c (excess_unit_span): New function.
	(place_field): Use it.

2002-11-19  Andreas Schwab  <schwab@suse.de>

	* unwind.h (_Unwind_GetTextRelBase): Revert last change, this is
	not valid in C++.

2002-11-19  Nathanael Nerode  <neroden@gcc.gnu.org>

	* configure.in, Makefile.in: Correct BUILD/HOST confusion.
	* configure: Regenerate.

Tue Nov 19 00:11:44 CET 2002  Jan Hubicka  <jh@suse.cz>

	* convert.c (strip_float_extensions): New function.
	(convert_to_real): Optimize some cases.

2002-11-19  Andreas Jaeger  <aj@suse.de>

	* loop.c (record_giv): Initialize not_replaceable.
	(check_final_value): Likewise.

2002-11-19  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (h8300_init_once): Replace 1 with
	MASK_H8300S.

2002-11-19  Vijay L. Khuspe  <vijayk1@kpit.com>

	* config/h8300/h8300.c (h8300_init_once): Allow -mn switch
	only if -mh or -ms present.
	(h8300_eightbit_constant_address_p): Support the normal mode.
	(h8300_tiny_constant_address_p): Likewise.
	* config/h8300/h8300.h (TARGET_NORMAL_MODE): New.
	(POINTER_SIZE): Add 16 bit pointer for the normal mode.
	(Pmode): Evaluate to HImode for the normal mode.
	(SIZE_TYPE): Evaluate to unsigned int for normal mode.
	(PTRDIFF_TYPE): Evaluate to int for the normal mode.
	(ASM_WORD_OP): Evaluate to word for the normal mode.
	* config/h8300/h8300.md (tablejump_normal_mode): New.
	(indirect_jump_normal_mode): New.
	* config/h8300/t-h8300 (MULTILIB_OPTIONS): Pass -mn option to
	directory.
	(MULTILIB_DIRNAMES): Create target dependent directory
	'normal'.
	(MULTILIB_EXCEPTIONS): Don't turn on -mn on H8/300.
	* doc/invoke.texi (gccoptlist): Describe the new switch -mn.

Tue Nov 19 23:50:56 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (length_immediate): Do not refer to insn address.
	(jcc*, jmp patterns):  Compute length explicitly.

2002-11-19 Eric Botcazou <ebotcazou@libertysurf.fr>

	PR c/8588
	* optabs.c (expand_binop): Convert CONST_INTs in shift
	operations too.

2002-11-19  Roger Sayle  <roger@eyesopen.com>

	* gcse.c (gcse_emit_move_after): Correct typo in REG_EQUAL note.

2002-11-19  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (an anonymous pattern): Relax the
	condition to accept the same operands and/or subregs.

2002-11-19  Daniel Jacobowitz  <drow@mvista.com>

	* config/sh/sh.c (gen_shl_and): Revert previous patch.
	* config/sh/sh.md (ashrdi3+1, ashrdi3+2): Predicate on
	reload_completed.

2002-11-19  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (print_operand): Update the use of
	EIGHTBIT_CONSTANT_ADDRESS_P.
	(h8300_adjust_insn_length): Likewise.
	(h8300_eightbit_constant_address_p): Check if the given rtx is
	a variable with __attribute__((eightbit_data)).
	* config/h8300/h8300.h (OK_FOR_U): Update the use of
	EIGHTBIT_CONSTANT_ADDRESS_P.

2002-11-19  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/contrib.texi (Contributors): Add self as second contact in
	addition to Jeff Law.

2002-11-19  Andreas Jaeger  <aj@suse.de>

	* tree-inline.c: Move prototpyes of find_alloca_call_1 and
	find_alloca_call to right place.

2002-11-19  Kazu Hirata  <kazu@cs.umass.edu>

	* cppfiles.c: Fix formatting.

2002-11-19  Jason Thorpe  <thorpej@wasabisystems.com>

	* gcc.c (The Specs Language): Document spec functions.
	(static_spec_functions, lookup_spec_function)
	(eval_spec_function, handle_spec_function)
	(if_exists_spec_function, alloc_args): New.
	(execute): Abort if processing_spec_function is true.
	(do_spec_1): Hand off spec to handle_spec_function if %:
	is encountered.  If processing_spec_function is true,
	end any pending argument when the end of the string is reached.
	(main): Use alloc_args to allocate the initial argument vector.
	* gcc.h (struct spec_function): New.
	(lang_specific_spec_functions): New extern.

	* config/netbsd-elf.h (STARTFILE_SPEC): Add if-exists(crti%O%s).
	(ENDFILE_SPEC): Add if-exists(crtn%O%s).
	* config/alpha/netbsd.h (ENDFILE_SPEC): Likewise.

	* doc/invoke.texi: Document spec functions.

	* cppspec.c (lang_specific_spec_functions): New.
	* gccspec.c: Likewise.

2002-11-18  Steve Ellcey  <sje@cup.hp.com>

	* config/ia64/hpux_longdouble.h (FIXUNS_TRUNCTFSI2_LIBCALL): New.
	(FIXUNS_TRUNCTFDI2_LIBCALL): New.
	(fixunstfsi_libfunc): Change.
	(fixunstfdi_libfunc): Change.
	(sdiv_optab): Don't zero out SImode handler.
	(udiv_optab): Don't zero out SImode handler.
	(smod_optab): Don't zero out SImode handler.
	(umod_optab): Don't zero out SImode handler.

2002-11-18  Neil Booth  <neil@daikokuya.co.uk>

	PR preprocessor/8524
	* cpplib.c (run_directive): Remove previous kludge to _Pragma.
	Add a new one in its place, which hopefully works.
	(skip_rest_of_line): Change test for bottom-of-context-stack.

Mon Nov 18 21:29:03 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (addqi_1_slp): Fix output template.
	(subqi_1_slp): Fix type.

Sun Nov 17 00:01:28 CET 2002  Jan Hubicka  <jh@suse.cz>

	* calls.c (alloca_call_p): New global function.
	* tree.h (alloca_call_p): New.
	* tree-inline.c (inlinable_function_p):  Do not inline when
	function calls alloca.
	(find_alloca_call, find_alloca_call_1): New functions.

2002-11-18  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (*andorqi3): Use bor between bld and
	bst.  Update the insn length.
	(*andorhi3): Likewise.
	(*andorsi3): Likewise.

2002-11-18  Richard Sandiford  <rsandifo@redhat.com>

	* config/sh/sh-protos.h (sh_mark_label): Declare.
	* config/sh/sh.c (sh_mark_label): New function, taken from
	movdi_const, but fixing the case when the address has an addend.
	* config/sh/sh.md (movdi_const, movdi_const_32bit): Use it.

2002-11-18  Richard Sandiford  <rsandifo@redhat.com>

	* config/sh/sh.c (pool_node): New field: part_of_sequence_p.
	(add_constant): Set it.
	(dump_table): Don't reorder a constant if part_of_sequence_p.
	(machine_dependent_reorg): Assume that float constants will
	stay in their original order if used as a sequence.

2002-11-18  Richard Sandiford  <rsandifo@redhat.com>

	* config/sh/sh.c (calc_live_regs): Update check for PIC liveness
	in compact code.

2002-11-18  Richard Sandiford  <rsandifo@redhat.com>

	* config/sh/sh.md (initialize_trampoline): Do not force the
	trampoline address into R0_REGS here.

Sun Nov 17 14:01:09 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (negsf2_ifs, negdf2_ifs, negdf2_ifs_rex64, abssf2_ifs,
	absdf2_ifs, absdf2_ifs_rex64): Fix constraints.
	(neg?f2_ifs, abs?f2_ifs splitters): Refuse memory operand; do not
	generate unnecesary subregs.

2002-11-17  Kazu Hirata  <kazu@cs.umass.edu>

	* df.c: Fix formatting.

2002-11-17  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (two anonymous patterns): Fix insn
	lengths.

2002-11-17  Daniel Jacobowitz  <drow@mvista.com>

	* sh.c (gen_shl_and): Don't create a zero_extend if the operand
	is not an arith_reg_operand.

2002-11-17  Graham Stott  <graham.stott@btinternet.com>

	* real.c (real_to_decimal): Fix buffer overrun when buffer size
	is smaller than representation.

2002-11-17  Kazu Hirata  <kazu@cs.umass.edu>

	* builtins.c: Fix formatting.

Sat Nov 16 16:49:58 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (truncdfsf2_1_sse, truncdfsf2_1_sse_nooverlap, truncdfsf2_2,
	floats?dff2_i387):
	Work around regclass stupidity.
	(truncdfsf_2_1_sse splitter):  Accept !TARGET_PARTIAL_SSE_REGS

Sat Nov 16 02:17:48 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (fop_df_6): New pattern.
	(fop_xf_4, fop_xf_5): Handle both SF and DFmode extensions.
	(fop_xf_6): Rewrite
	(fop_xf_7): Delete.
	(fop_tf_4, fop_tf_5): Handle both SF and DFmode extensions.
	(fop_tf_6): Rewrite
	(fop_tf_7): Delete.

2002-11-16  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (two anonymous patterns): Fix typos.

2002-11-16  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md: Fix formatting.

2002-11-16  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md: Replace spaces with tabs.
	* config/h8300/t-h8300: Remove a trailing empty line.

2002-11-16  Kazu Hirata  <kazu@cs.umass.edu>

	* tlink.c: Fix formatting.

2002-11-16  David Edelsohn  <edelsohn@gnu.org>

	PR 8362
	* config/rs6000/rs6000.c (rs6000_outout_load_multiple): New function.
	* config/rs6000/rs6000.md (movti_string): Remove output modifier
	when scratch register never needed.
	(ldmsi[3-8]): New patterns.

2002-11-16  Kazu Hirata  <kazu@cs.umass.edu>

	* hard-reg-set.h: Follow spelling conventions.
	* real.c: Likewise.
	* target.h: Likewise.

2002-11-16  Jakub Jelinek  <jakub@redhat.com>

	* config/i386/x86-64.h (MCOUNT_NAME): Change into string literal.

2002-11-16  Kazu Hirata  <kazu@cs.umass.edu>

	* optabs.c: Fix formatting.

Sat Nov 16 02:06:02 CET 2002  Jan Hubicka  <jh@suse.cz>

	* athlon.md, k6.md, pentium.md, ppro.md: Handle shift1, rotate1
	* i386.md (attribute type): Add type shift1 and rotate1.
	(*_slp): Rewrite to have just two operands to avoid reload problems.

2002-11-15  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (4 anonymous patterns): New.

2002-11-15  Geoffrey Keating  <geoffk@apple.com>

	* params.def (GGC_MIN_HEAPSIZE): Fix GGC_ALWAYS_COLLECT problem.
	* doc/invoke.texi: Correct description of what needs to be done to
	force collection at every ggc_collect call.

2002-11-15  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.c (optimization_options): Set
	flag_asynchronous_unwind_tables to 1 by default.

2002-11-15  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.h (ASM_PREFERRED_EH_DATA_FORMAT): Define.

Fri Nov 15 14:54:19 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386-protos.h (x86_function_profiler): New function
	* i386.h (MCOUNT_NAME): New.
	(PROFILE_COUNT_REGISTER): New.
	(FUNCTION_PROFILER): Move offline to ...
	* i386.c (x86_function_profiler) ... here; fix 64bit support
	* beos-elf.h (FUNCTION_PROFILER): Kill.
	(MCOUNT_NAME): New.
	* freebsd-aout.h (FUNCTION_PROFILER): Kill.
	(MCOUNT_NAME): New.
	(PROFILE_COUNT_REGISTER): New.
	* linux.h (FUNCTION_PROFILER): Kill.
	(MCOUNT_NAME): New.
	* x86-64.h (FUNCTION_PROFILER): Kill.
	(MCOUNT_NAME): New.
	* freebsd.h (FUNCTION_PROFILER): Kill.
	(MCOUNT_NAME): New.

2002-11-14  Jeroen Dobbelaere  <jeroen.dobbelaere@acunia.com>

	* config/arm/arm.h (EXPAND_BUILTIN_VA_ARG,
	FUNCTION_ARG_PASS_BY_REFERENCE): Define.
	* config/arm/arm.c (arm_va_arg,
	arm_function_arg_pass_by_reference): New.
	* config/arm/arm-protos.h: Add prototypes.

2002-11-14  Kazu Hirata  <kazu@cs.umass.edu>

	* gthr-single.h: Fix formatting.

2002-11-14  Zack Weinberg  <zack@codesourcery.com>

	* tree.c (tree_vec_elt_check_failed): New function.
	* tree.h (TREE_VEC_ELT_CHECK): New checking macro.
	(TREE_VEC_ELT): Use it.

	* tree-inline.c (optimize_inline_calls): Don't copy a
	zero-length vector.

2002-11-14  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* diagnostic.c (sorry): Don't repeat "sorry, unimplemented" text.

2002-11-14  Jakub Jelinek  <jakub@redhat.com>

	* varasm.c (output_addressed_constants) [MINUS_EXPR]: Clear reloc if
	both operands contain local relocations.
	(categorize_decl_for_section): Don't use mergeable sections if
	initializer has any relocations.

2002-11-14  Kazu Hirata  <kazu@cs.umass.edu>

	* gthr-vxworks.h: Fix formatting.

2002-11-13  Janis Johnson  <janis187@us.ibm.com>

	* doc/install.texi (Testing): Document extra Java testing.
	* doc/sourcebuild.texi (Test Suites): Document libgcj testing.

2002-11-13  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* pa64-hpux.h (LINK_SPEC): Move "+Accept TypeMismatch" switch to the
	beginning of the spec.
	(LDD_SUFFIX, PARSE_LDD_OUTPUT): Delete.
	(LD_INIT_SWITCH, LD_FINI_SWITCH): Define but don't enable.  Add comment
	regarding problems with global constructors when using GNU ld.

2002-11-13  Kazu Hirata  <kazu@cs.umass.edu>

	* gthr-solaris.h: Fix formatting.

2002-11-13  Kazu Hirata  <kazu@cs.umass.edu>

	* gthr-posix.h: Fix formatting.

2002-11-12  Devang Patel <dpatel@apple.com>
	* gcc.c (display_help): Two new options -Xpreprocessor and -Xassembler.
	(process_command): Same.
	* doc/invoke.texi: Info about these two new options.

2002-11-12  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (*andorsi3): New.

2002-11-12  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	* doc/install.texi (powerpc-*-linux-gnu*): Update binutils requirement.

2002-11-12  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (tiny_constant_address_p): Parenthesize
	expressions appropriately.

2002-11-12  Kazu Hirata  <kazu@cs.umass.edu>

	* gthr-win32.h: Fix formatting.

2002-11-12  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (single_one_operand): Correctly compute
	mask when mode is SImode.
	(single_zero_operand): Likewise.
	* config/h8300/h8300.md (two new anonymous insns): New.

2002-11-12  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	* doc/contrib.texi (Contributors): Use GCJ instead of gcj to refer
	to that entire project.

2002-11-12  Rainer Orth  <ro@TechFak.Uni-Bielefeld.DE>

	* config/mips/t-iris6 (MULTILIB_OSDIRNAMES): Restore old
	directories.

2002-11-11  Zack Weinberg  <zack@codesourcery.com>

	* params.def (ggc-min-expand, ggc-min-heapsize): New parameters.
	* doc/invoke.texi: Document them.

	* ggc-page.c: Include params.h.  Remove definitions of
	GGC_MIN_EXPAND_FOR_GC, GGC_MIN_LAST_ALLOCATED.  Replace
	GGC_POISON with ENABLE_GC_CHECKING in ifdefs, delete #define.
	(init_gcc): Don't set G.allocated_last_gc here.
	(ggc_collect): Use PARAM_VALUE (GGC_MIN_HEAPSIZE) and
	PARAM_VALUE (GGC_MIN_EXPAND) to decide whether or not to
	perform collection.
	* ggc-simple.c: Similarly.
	* Makefile.in (ggc-common.o, ggc-simple.o): Add $(PARAMS_H) to
	dependencies.

2002-11-11  Kazu Hirata  <kazu@cs.umass.edu>

	* gthr-dce.h: Fix formatting.

2002-11-11  Franz Sirl  <Franz.Sirl-kernel@lauterbach.com>

	PR c/8467
	* stmt.c (tail_recursion_args): Handle DECL_MODE differing from the
	mode of DECL_RTL case.

2002-11-11  Janis Johnson  <janis187@us.ibm.com>

	* doc/contrib.texi: Merge in the list from the libstdc++ web pages.

Mon Nov 11 12:06:08 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (construct_container): Fix handling of SSE_CLASS.

2002-11-10  Joel Sherrill <joel@gcc.gnu.org>

	* config/m68k/t-crtstuff (crti.o): Use this...
	($(T)crti.o): ... instead.
	(crtn.o): Use this...
	($(T)crtn.o): ... instead.

2002-11-10  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR c/8439
	* recog.c (validate_replace_rtx_1) [PLUS]: Simplify only
	if there is something new to be simplified.

2002-11-10  H.J. Lu <hjl@gnu.org>

	* calls.c (PUSH_ARGS_REVERSED): Define only if not defined.
	* expr.c (PUSH_ARGS_REVERSED): Likewise.

	* config/i386/i386.h (PUSH_ARGS_REVERSED): Set to 1.

2002-11-10  Zack Weinberg  <zack@codesourcery.com>

	* config/rs6000/sysv4.h: Define NO_IMPLICIT_EXTERN_C here...
	* config/rs6000/linux.h, config/rs6000/linux64.h,
	config/rs6000/windiss.h: ... not here.

2002-11-10  Jason Thorpe  <thorpej@wasabisystems.com>

	* config/mips/netbsd.h (TARGET_OS_CPP_BUILTINS): Define
	__ABICALLS__ if TARGET_ABICALLS.

Sun Nov 10 18:49:21 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.h (MIN_UNITS_PER_WORD): Define to 8 for x86-64 libgcc.

2002-11-10  Joseph S. Myers  <jsm@polyomino.org.uk>

	* c-decl.c (grokdeclarator): Make error for duplicate type
	qualifiers into a pedwarn, disabled for C99.

2002-11-10  Hans-Peter Nilsson  <hp@bitrange.com>

	* config/mmix/mmix.h (FUNCTION_ARG_CALLEE_COPIES): Define the same
	as FUNCTION_ARG_PASS_BY_REFERENCE.

2002-11-09  Zack Weinberg  <zack@codesourcery.com>

	* doc/install.texi: Add *-*-vxworks* specific installation
	instructions.

	* config/vxlib.c: Rewrite using generation numbers to identify
	valid TSD keys.

Sat Nov  9 00:10:54 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (x86_machine_dependent_reorg): Fix even more side cases.

2002-11-09  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* pa.h (STARTING_FRAME_OFFSET): Change offset for TARGET_64BIT to 16.

	* config.gcc (hppa*64*-*-linux*): Shorten lines in tm_file define.
	(hppa*64*-*-hpux11*): Likewise.  Use elfos.h with gas.
	* pa.c (output_millicode_call): Use symbol difference rather than
	$PIC_pcrel$0 when using HP assembler.
	* pa64-hpux.h (TARGET_GAS): Define to 1 or 0 depending on whether or
	not elfos.h (i.e., gas) is being used.
	(ASM_FILE_START, STRING_ASM_OP, TEXT_SECTION_ASM_OP,
	DATA_SECTION_ASM_OP, BSS_SECTION_ASM_OP, ASM_OUTPUT_ALIGNED_COMMON,
	ASM_OUTPUT_ALIGNED_LOCAL, GLOBAL_ASM_OP, ASM_DECLARE_FUNCTION_NAME,
	ASM_OUTPUT_EXTERNAL, ASM_OUTPUT_EXTERNAL_LIBCALL,
	ASM_OUTPUT_INTERNAL_LABEL, ASM_GENERATE_INTERNAL_LABEL): Define when
	using elfos.h.
	(TARGET_ASM_GLOBALIZE_LABEL): Undefine when using elfos.h.
	(DWARF2_ASM_LINE_DEBUG_INFO): Delete.
	(ASM_FILE_START): Add standard .SPACE and .SUBSPA defines when not
	using elfos.h.
	(TEXT_SECTION_ASM_OP, READONLY_DATA_SECTION_ASM_OP, DATA_SECTION_ASM_OP,
	BSS_SECTION_ASM_OP): New HP style defines when not using elfos.h.
	(TARGET_ASM_NAMED_SECTION, MAKE_DECL_ONE_ONLY, ASM_WEAKEN_LABEL):
	Don't define when not using elfos.h.
	(ASM_DECLARE_RESULT): Don't define.
	* doc/install.texi (hppa*-hp-hpux*): Remove statement that HP assembler
	doesn't work on hppa64-hp-hpux11.
	(hppa*-hp-hpux11): Update.

2002-11-09  Jason Thorpe  <thorpej@wasabisystems.com>

	* config/mips/netbsd.h (SUBTARGET_ASM_SPEC): Don't pass -KPIC
	to the assembler if -mno-abicalls was specified.

2002-11-09  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* pa-linux.h (PREFERRED_DEBUGGING_TYPE, DWARF2_ASM_LINE_DEBUG_INFO,
	ASM_OUTPUT_DEF): Delete.

2002-11-09  Neil Booth  <neil@daikokuya.co.uk>

	* c-opts.c (COMMAND_LINE_OPTIONS): Fix -Wimplicit.

2002-11-08  Roger Sayle  <roger@eyesopen.com>

	* real.c (real_sqrt): Update comment with bibliographic reference.

Fri Nov  8 13:33:58 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (sse_loadss, sse2_loadsd): Fix expander.

Fri Nov  8 13:25:41 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (x86_machine_dependent_reorg): Fix handling of empty functions.

Fri Nov  8 13:01:42 CET 2002  Jan Hubicka  <jh@suse.cz>

	* builtins.c (expand_builtin_mathfn): Handle floor/ceil/trunc/round/nearbyint
	(expand_builtin): Likewise.
	* builtins.def: Add
	__builtin_floor, __builtin_floorf, __builtin_floorl
	__builtin_ceil, __builtin_ceilf, __builtin_ceill
	__builtin_round, __builtin_roundf, __builtin_roundl
	__builtin_trunc, __builtin_truncf, __builtin_truncl
	__builtin_nearbyint, __builtin_nearbyintf, __builtin_nearbyintl.
	* genopinit.c (optabs): Initialize the new optabs.
	* optab.c (init_optabs): Likewise.
	* optabs.h (optab_index): Add OTI_floor, OTI_ceil, OTI_trunc,
	OTI_round, OTI_nearbyint.
	(floor_optab, ceil_optab, trunc_optab, round_optab, nearbyint_optab): New.
	* doc/md.texi: Document new named patterns.
	* doc/extend.texi (builtin functions)  Document
	floor, floorf, floorl, ceil, ceilf,
	ceill, round, roundf, roundl, trunc,
	truncf, truncl, nearbyint, nearbyintf, nearbyintl.

Fri Nov  8 11:36:11 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (sse_movdfcc, sse_movsfcc): Fix typo in previous patch.

2002-11-08  Dale Johannesen  <dalej@apple.com>

	* dbxout.c (dbxout_type):  Fix stabs info for vector types.

2002-11-08  Neil Booth  <neil@daikokuya.co.uk>

	PR preprocessor/8497
	PR preprocessor/8501
	* cpptrad.c (scan_out_logical_line): A '#' from a macro doesn't
	start a directive.  In assembler, #NUM is not a line directive.

2002-11-08  Neil Booth  <neil@daikokuya.co.uk>

	* cppmain.c (cpp_preprocess_file): Loop to pop any -included
	buffers.

2002-11-08  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (two anonymous test insns): New.

Fri Nov  8 11:20:19 CET 2002  Jan Hubicka  <jh@suse.cz>

	* jump.c (mark_jump_label): Handle subregs of label_refs.

Thu Nov  7 21:54:22 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (sse_movdfcc, sse_movsfcc): Avoid overactive matching.
	* i386.c (ix86_expand_fp_movcc): Match the reversed cases.

2002-11-07  David Mosberger  <davidm@hpl.hp.com>

	* config/ia64/crtend.asm: Include "auto-host.h".
	[HAVE_INITFINI_ARRAY]: Invoke __do_global_ctors_aux via .init_array.
	* config/ia64/crtbegin.asm: Similarly.
	* config/ia64/t-ia64 (crtbegin.o): Include from current directory.
	(crtend.o, crtbeginS.o, crtendS.o): Likewise.

	* aclocal.m4 (gcc_AC_INITFINI_ARRAY): New.
	* configure.in: Use it if --enable-initfini-array not specified.
	* doc/install.texi (Configuration): Document --enable-initfini-array.
	* configure, config.in: Rebuild.

2002-11-07  Jason Thorpe  <thorpej@wasabisystems.com>

	* config/arm/arm-protos.h (arm_get_frame_size)
	(thumb_get_frame_size): New prototypes.
	* config/arm/arm.c (arm_get_frame_size)
	(thumb_get_frame_size): New functions.
	(use_return_insn, arm_output_epilogue, arm_output_function_epilogue)
	(arm_compute_initial_elimination_offset, arm_expand_prologue): Use
	arm_get_frame_size.
	(thumb_expand_prologue, thumb_expand_epilogue): Use
	thumb_get_frame_size.
	* config/arm/arm.h (PREFERRED_STACK_BOUNDARY): Define.
	(machine_function): Add frame_size member.
	(THUMB_INITIAL_ELIMINATION_OFFSET): Use thumb_get_frame_size.

2002-11-07  Richard Earnshaw  <rearnsha@arm.com>

	* arm.c (bit_count): Make argument unsigned long.  Return unsigned.
	Adjust code to use portable unsigned bit manipulation.
	(insn_flags, tune_flags): Change type to unsigned.
	(struct processors): Make flags unsigned long.
	(arm_override_options): Change type of count and current_bit_count
	to unsigned.

2002-11-07  Richard Earnshaw  <rearnsha@arm.com>

	* arm/elf.h (TYPE_OPERAND_FMT): Prefix type with %.

Thu Nov  7 15:50:18 2002  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.h (DWARF_FRAME_RETURN_COLUMN): Use DWARF_FRAME_REGNUM.

Thu Nov  7 11:18:01 CET 2002  Jan Hubicka  <jh@suse.cz>

	* reg-stack.c (compensate_edge): Fix sanity check.

2002-11-05  Geoffrey Keating  <geoffk@apple.com>

	* config.gcc: Don't create crtbegin, crtend on Darwin; do create
	crt2.o.  Rearrange t-darwin makefiles.
	* crtstuff.c [OBJECT_FORMAT_MACHO]: Delete.
	* unwind-dw2-fde-darwin.c: New.
	* unwind-dw2-fde-glibc.c: Correct comment.
	* unwind-dw2-fde.c (__register_frame_info_bases)
	[DWARF2_OBJECT_END_PTR_EXTENSION]: Clear fde_end.
	(classify_object_over_fdes): Use last_fde.
	(add_fdes): Likewise.
	(linear_search_fdes): Likewise.
	* unwind-dw2-fde.h (struct object)
	[DWARF2_OBJECT_END_PTR_EXTENSION]: Add fde_end field.
	(last_fde): New.
	* config/darwin.h (STARTFILE_SPEC): Include crt2.o not crtbegin.o.
	(ENDFILE_SPEC): No crtend.o.
	* config/t-darwin: New.
	* config/i386/t-darwin: Delete.
	* config/darwin-crt2.c: New.
	* config/rs6000/t-darwin: Delete contents duplicated in t-rs6000
	or config/t-darwin.

2002-11-06  Douglas B Rupp  <rupp@gnat.com>

	* config/i386/i386-interix.h (TARGET_SUBTARGET_DEFAULT): Or
	MASK_MS_BITFIELD_LAYOUT
	(SUBTARGET_OVERRIDE_OPTIONS): Warn about and turn off
	MS bitfields for Objective-C.
	(PCC_BIT_FIELD_TYPE_TEST, GROUP_BITFIELDS_BY_ALIGN): Remove
	defines.

	* config/i386/i386.c (ix86_ms_bitfield_layout): New function.
	(TARGET_MS_BITFIELD_LAYOUT_P): Define to above function.
	(TARGET_USE_MS_BITFIELD_LAYOUT): Define.

	* config/i386/i386.h (MASK_MS_BITFIELD_LAYOUT: New mask.
	TARGET_USE_MS_BITFIELD_LAYOUT): New macro.
	(TARGET_SWITCHES): Add above mask.

	* testsuite/gcc.dg/bf-ms-layout.c: New test case.
	* testsuite/gcc.dg/bf-no-ms-layout.c: New test case.
	* testsuite/gcc.dg/i386-bitfield1.c (dg-options): Add appropriate
	flags for interix.

Wed Nov  6 18:54:47 2002  Alexandre Oliva  <aoliva@redhat.com>

	* config/mips/mips.h (ASM_OUTPUT_ADDR_DIFF_ELT): Output
	.gpword/.gpdword for ABI_N32 and ABI_64 too, if using the GNU
	assembler.
	* config/mips/mips.md (tablejump_internal3): Output .cpadd
	before jump on ABI_N32 too.
	(tablejump_internal4): Ditto on ABI_64.  Increase maximum
	length to match.

Wed Nov  6 17:16:48 CET 2002  Jan Hubicka  <jh@.suse.cz>

	* i386.md (negsf splitter): Accept memory operand in second register.
	(abssf/absdf splitters): Simplify
	(sse_loadss, sse_loadsd): Turn into expander.

2002-11-06  David Edelsohn  <edelsohn@gnu.org>

	PR target/8480
	* config/rs6000/rs6000.md (movdi_internal64): Discourage
	FPR to FPR moves.

2002-11-06  Janis Johnson  <janis187@us.ibm.com>

	* doc/contrib.texi: Merge in the list from the Java web pages.

2002-11-06  David O'Brien  <obrien@FreeBSD.org>

	* config/sparc/freebsd: Fix typo.

2002-11-06  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* pa64-hpux.h (LDD_SUFFIX, PARSE_LDD_OUTPUT): Define.

2002-11-06  Alexandre Oliva  <aoliva@redhat.com>

	* config/mips/mips.md (call_value_multiple_internal2): Use dla for
	non-SImode addresses.

Tue Nov  5 14:34:36 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (float_truncate SSE splitter): Ensure that operand is not
	stack register.
	(float SSE splitters): Reorder conditional.

2002-11-05  Bob Wilson  <bob.wilson@acm.org>

	* config/xtensa/elf.h (LIB_SPEC): Add "-lhal".

2002-11-05  John David Anglin  <dave2hiauly1.hia.nrc.ca>

	* pa64-hpux.h (LIB_SPEC): Fix p and pg options.
	(STARTFILE_SPEC): Remove p and pg options.

2002-11-05  Andrew Haley  <aph@redhat.com>

	* fold-const.c (fold): Don't transform (a0 op compound(a1,a2))
	to (compound(a1,a0 op a2)) if a0 or a1 have side effects.

2002-11-05  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.h (CANNOT_CHANGE_MODE_CLASS): Move comment to...
	* config/mips/mips.c (mips_cannot_change_mode_class): ...here.

2002-11-04  Zack Weinberg  <zack@codesourcery.com>

	* gthr-vxworks.h: Rewritten from scratch.
	* config/vxlib.c: New file.
	* config/t-vxworks: Add config/vxlib.c to LIB2FUNCS_EXTRA.
	* config/rs6000/t-vxworks: Add config/vxlib.c to
	LIB2FUNCS_EXTRA here too, because of clash with
	config/rs6000/t-ppccomm.

2002-11-04  Dale Johannesen  <dalej@apple.com>

	* doloop.c (doloop_modify_runtime):  Fix loop count computation
	for unrolled loops.
	* loop.c (loop_invariant_p):  Support calling from unroller.

2002-11-04  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.c (s390_decompose_address): Use arg_pointer_rtx
	for comparison.

2002-11-04  Aldy Hernandez  <aldyh@redhat.com>

	* hard-reg-set.h (REG_CANNOT_CHANGE_MODE_P): New.

	* config/rs6000/rs6000.h (CLASS_CANNOT_CHANGE_MODE_P): Remove.
	(CLASS_CANNOT_CHANGE_MODE): Remove.
	(CANNOT_CHANGE_MODE_CLASS): New.

	* config/alpha/alpha.h: Same.

	* config/ia64/ia64.h: Same.

	* config/mips/mips.h: Same.

	* config/s390/s390.h: Same.

	* config/sh/sh.h: Same.

	* config/pa/pa64-regs.h: Same.

	* config/sh/sh-protos.h (sh_cannot_change_mode_class): Add prototype.

	* config/sh/sh.c (sh_cannot_change_mode_class): New.

	* config/mips/mips-protos.h (mips_cannot_change_mode_class): Add
	prototype.

	* config/mips/mips.c (mips_cannot_change_mode_class): New.

	* doc/tm.texi (Register Classes): Remove
	CLASS_CANNOT_CHANGE_MODE and CLASS_CANNOT_CHANGE_MODE_P.
	Document CANNOT_CHANGE_MODE_CLASS.

	* reload.c (push_reload): Use CANNOT_CHANGE_MODE_CLASS.
	(push_reload): Same.

	* simplify-rtx.c (simplify_subreg): Same.

	* reload1.c (choose_reload_regs): Same.

	* recog.c (register_operand): Same.

	* regrename.c (mode_change_ok): Change to use new
	CANNOT_CHANGE_MODE_CLASS infrastructure.

	* regclass.c (cannot_change_mode_set_regs): New.
	Declare subregs_of_mode.
	(regclass): Use subregs_of_mode.
	Remove references to reg_changes_mode.
	(init_reg_sets_1): Remove class_can_change_mode and
	reg_changes_mode code.
	(invalid_mode_change_p): New.
	(dump_regclass): Use invalid_mode_change_p instead of
	class_can_change_mode.
	(regclass): Same.
	(record_operand_costs): Do not set reg_changes_mode.

	* local-alloc.c (struct qty): Remove changes_mode field.
	(alloc_qty): Remove changes_mode initialization.
	(update_qty_class): Remove set of changes_mode.
	(find_free_reg): Use subregs_of_mode.

	* global.c (find_reg): Use subregs_of_mode info.

	* rtl.h (cannot_change_mode_set_regs): New prototype.
	(invalid_mode_change_p): Same.
	(REG_CANNOT_CHANGE_MODE_P): New macro.

	* flow.c (mark_used_regs): Calculate subregs_of_mode.  Remove
	REG_CHANGES_MODE.
	(life_analysis): Clear subregs_of_mode.

	* combine.c (subst): Pass class to CLASS_CANNOT_CHANGE_MODE_P.
	Remove use of CLASS_CANNOT_CHANGE_MODE.
	(simplify_set): Same.
	(gen_lowpart_for_combine): Calculate subregs_of_mode.  Remove
	REG_CHANGES_MODE.

	* regs.h: Add extern for subregs_of_mode;
	Include hard-reg-set and basic-block.
	(REG_CHANGES_MODE): Delete.

2002-11-03  Roger Sayle  <roger@eyesopen.com>

	* real.c (real_sqrt): New function to calculate square roots.
	* real.h (real_sqrt): Add function prototype.
	* builtins.c (fold_builtin): Fold sqrt of constant argument.
	* simplify-rtx.c (simplify_unary_operation): Simplify sqrt
	of constant argument.

2002-11-03  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* jump.c (never_reached_warning): Don't set contains_insn until the
	first line note is seen.

2002-11-03  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.md (movti_string): Use string instructions.

2002-11-03  Roger Sayle  <roger@eyesopen.com>

	PR c/7128
	* c-typeck.c (c_expand_asm_operands): Defend against
	error_mark_nodes in the output argument to avoid ICE.

2002-11-03  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR middle-end/8408
	* genrecog.c (preds): Handle ADDRESSOF.
	(validate_pattern): Mark it as an lvalue.

2002-11-02  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.c (rs6000_override_options): Use string
	instructions when optimizing for size.

2002-11-02  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.h: Fix comment typos.
	* config/h8300/h8300.md: Likewise.
	* config/h8300/lib1funcs.asm: Likewise.

2002-11-02  Gerald Pfeifer  <pfeifer@dbai.tuwien.ac.at>

	Revert this change:

	*doc/install.texi (Installing GCC: Configuration): Clarify
	the only supported ways to configure gcc.

2002-11-01  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.md (anonymous and:QI pattern): Use 'n'
	instead of 'O' for the constraint for the second operand.

2002-11-01  Mark Mitchell  <mark@codesourcery.com>

	PR c++/8391
	* toplev.c (rest_of_compilation): Do not refuse to output code for
	an inline function in a local class.

2002-11-01  David O'Brien  <obrien@FreeBSD.org>

	* config/sparc/freebsd.h (CPP_CPU64_DEFAULT_SPEC): Define __arch64__.
	(TRANSFER_FROM_TRAMPOLINE): Reformat.
	Add comment.

2002-11-01  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.h (CAN_ELIMINATE): Simplify.

2002-11-01  Toshiyasu Morita  <toshiyasu.morita@hsa.hitachi.com>

	* config/h8300/h8300.h (OPTIMIZATION_OPTIONS): New.

2002-11-01  Steve Ellcey  <sje@cup.hp.com>

	* config/ia64/ia64.h (MASK_INLINE_DIV_LAT): Remove.
	(MASK_INLINE_DIV_THR): Remove.
	(TARGET_INLINE_DIV_LAT): Remove.
	(TARGET_INLINE_DIV_THR): Remove.
	(TARGET_INLINE_DIV): Remove.
	(MASK_INLINE_FLOAT_DIV_LAT): New macro.
	(MASK_INLINE_FLOAT_DIV_THR): New macro.
	(MASK_INLINE_INT_DIV_LAT): New macro.
	(MASK_INLINE_INT_DIV_THR): New macro.
	(TARGET_INLINE_FLOAT_DIV_LAT): New macro.
	(TARGET_INLINE_FLOAT_DIV_THR): New macro.
	(TARGET_INLINE_INT_DIV_LAT): New macro.
	(TARGET_INLINE_INT_DIV_THR): New macro.
	(TARGET_INLINE_FLOAT_DIV): New macro.
	(TARGET_INLINE_INT_DIV): New macro.
	* config/ia64/ia64.md (divsi3): Change to use new macros.
	(modsi3): Ditto.
	(udivsi3): Ditto.
	(umodsi3): Ditto.
	(divsi3_internal): Ditto.
	(divdi3): Ditto.
	(moddi3): Ditto.
	(udivdi3): Ditto.
	(umoddi3): Ditto.
	(divdi3_internal_lat): Ditto.
	(divdi3_internal_thr): Ditto.
	(divsf3): Ditto.
	(divsf3_internal_lat): Ditto.
	(divsf3_internal_thr): Ditto.
	(divdf3): Ditto.
	(divdf3_internal_lat): Ditto.
	(divdf3_internal_thr): Ditto.
	(divtf3): Ditto.
	(divtf3_internal_lat): Ditto.
	(divtf3_internal_thr): Ditto.
	* config/ia64/ia64.c (ia64_override_options): Change
	to check new macros for conflicts in settings.
	* doc/invoke.texi (-minline-divide-min-latency): Remove.
	(-minline-divide-max-throughput): Remove.
	(-minline-float-divide-min-latency): New.
	(-minline-float-divide-max-throughput): New.
	(-minline-int-divide-min-latency): New.
	(-minline-int-divide-max-throughput): New.

2002-11-01  Richard Earnshaw  (rearnsha@arm.com)

	PR target/7856
	* arm.c (use_return_insn): Don't use a return insn if there are
	saved integer regs, but LR is not one of them.

Fri Nov  1 10:33:15 CET 2002  Jan Hubicka  <jh@suse.cz>

	* expr.c (emit_move_insn):  Use SCALAR_FLOAT_MODE_P
	* machmode.h (SCALAR_FLOAT_MODE_P): New macro.

Thu Oct 31 18:20:50 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (sse_loadss, sse_loadsd):  Canonicalize; add expander
	(movps, movpd splitters): Use canonical form.
	(movv2di): Fix merge problem.

Thu Oct 31 16:22:31 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (negdf2_ifs_rex64): Don't allow GPR operand.

2002-10-31  Nathanael Nerode  <neroden@gcc.gnu.org>

	PR optimization/6162
	* doc/md.texi: Document restriction on commutative operand
	specification.

2002-10-31  Eric Christopher  <echristo@redhat.com>

	* explow.c (convert_memory_address): Use shallow_copy_rtx.

2002-10-31  Steve Ellcey  <sje@cup.hp.com>

	* expmed.c (store_bit_field): Check FUNCTION_ARG_REG_LITTLE_ENDIAN.

2002-10-31  Steve Ellcey  <sje@cup.hp.com>

	* config/ia64/hpux.h (MEMBER_TYPE_FORCES_BLK): Set for non-floats.

Thu Oct 31  Dale Johannesen  <dalej@apple.com>

	* config/rs6000/darwin.h:  Correct formatting in previous.

Thu Oct 31  Dale Johannesen  <dalej@apple.com>

	* config/rs6000/darwin.h:  Enable -falign-xxx options.

Thu Oct 31 18:08:00 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (override_options): Set defaults for flag_omit_frame_pointer,
	flag_asynchronous_unwind_tables, flag_pcc_struct_return.
	* i386.c (optimization_options): Set flag_omit_frame_pointer,
	flag_asynchronous_unwind_tables, flag_pcc_struct_return to 2.
	Do not clear -momit-leaf-frame-pointer when profiling.
	(ix86_frame_pointer_required): Frame pointer is always required when
	profiling.

Thu Oct 31 16:09:44 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (negdf2_ifs_rex64): Don't allow GPR operand.

Thu Oct 31 12:45:55 2002  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.h (binary_logical_operator): Declare.
	* sh.c (binary_logical_operator): New function.
	* sh.md (xordi3+1): New combiner splitter pattern.

2002-10-31  David O'Brien  <obrien@FreeBSD.org>

	* config/sparc/freebsd.h (TRANSFER_FROM_TRAMPOLINE): Define
	__enable_execute_stack function.

2002-10-30  Zack Weinberg  <zack@codesourcery.com>

	* gthr.h, gthr-dce.h, gthr-posix.h, gthr-rtems.h,
	gthr-solaris.h, gthr-win32.h: Remove __gthread_key_dtor.
	* unwind-sjlj.c (fc_key_dtor): Delete.
	(fc_key_init): Adjust __gthread_key_create call to match.

2002-10-30  Aldy Hernandez  <aldyh@redhat.com>

	* c-common.c: Add GTY to vector_type_node_list.

2002-10-30  John David Anglin  <dave@hiauly.hia.nrc.ca>

	* pa-linux.h (ASM_OUTPUT_EXTERNAL_LIBCALL): Define.
	* pa-protos.h (attr_length_millicode_call, attr_length_call,
	pa_init_machine_status): Declare new global functions.
	* pa.c (void copy_fp_args, length_fp_args, get_plabel): Declare and
	implement new functions.
	(attr_length_millicode_call, attr_length_call): Implement.
	(total_code_bytes): Change type to long.
	(pa_output_function_prologue): Compute total_code_bytes on TARGET_64BIT.
	Reset counter if flag_function_sections.
	(output_deferred_plabels): Set output alignment to 3 for TARGET_64BIT.
	(output_cbranch): Move call to gen_label_rtx.
	(output_millicode_call): Rewrite adding long TARGET_64BIT call, expose
	delay slot in all variants, shorten pc-relative calls.
	(output_call): Rewrite adding long TARGET_64BIT call, improved delay
	slot usage and exposure, various new call variants, and shortened
	sequences for some variants on TARGET_PA_20.
	Miscellaneous format changes.
	* pa.h (total_code_bytes): Change type to long.
	(MASK_LONG_CALLS, TARGET_LONG_CALLS, TARGET_LONG_ABS_CALL,
	TARGET_LONG_PIC_SDIFF_CALL, TARGET_LONG_PIC_PCREL_CALL): Define.
	(TARGET_SWITCHES): Add "-mlong-calls" and "-mno-long-calls" options.
	(EXTRA_CONSTRAINT, GO_IF_LEGITIMATE_ADDRESS,
	LEGITIMIZE_RELOAD_ADDRESS): Don't use long floating point loads and
	stores on TARGET_ELF32.
	*pa.md (define_delay): Allow insns in delay on TARGET_PORTABLE_RUNTIME.
	(unnamed patterns for mulsi3, divsi3, udivsi3, modsi3, umodsi3 and
	canonicalize_funcptr_for_compare expanders): Calculate attribute length
	attr_length_millicode_call().
	(call_internal_symref, call_value_internal_symref): Clobber register 1.
	Calculate attribute length using attr_length_call().
	(call_internal_reg_64bit, call_value_internal_reg_64bit): Move gp load
	to delay slot.
	(sibcall, sibcall_value): Rewrite.
	(sibcall_internal_symref, sibcall_value_internal_symref): Clobber
	register 1.  Use attr_length_call().
	(sibcall_internal_symref_64bit, sibcall_value_internal_symref_64bit):
	New patterns.
	(unamed pattern for canonicalize_funcptr_for_compare): Rewrite.
	* som.h (MEMBER_TYPE_FORCES_BLK): Define.
	* t-pa64 (TARGET_LIBGCC2_CFLAGS): Add "-mlong-calls".
	* doc/invoke.texi (mlong-calls): Document.

2002-10-30  Roger Sayle  <roger@eyesopen.com>

	* fold-const.c (fold_binary_op_with_conditional_arg):  Improve
	handling of cases where one or both branches of the conditional
	have void type, i.e. throw an exception or don't return.
	(fold): Only apply (and undo) type conversion to the non-void
	branches of a COND_EXPR.

2002-10-30  Mark Mitchell  <mark@codesourcery.com>

	PR c++/8333
	* varasm.c (asm_output_aligned_bss): Do not call
	ASM_GLOBALIZE_LABEL.

2002-10-30  David Edelsohn  <edelsohn@gnu.org>
	    Torbjorn Granlund  <tege@swox.com>

	* config/rs6000/rs6000.md (load_toc_v4_PIC_1): Use preferred form
	for addressibility.
	(load_toc_v4_PIC_1b): Same.

2002-10-30  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (h8300_eightbit_constant_address_p):
	Truncate the addresses for H8/300 using HImode.

Tue Oct 29 23:28:10 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (negdf splitter): Fix construction of the constant.

Tue Oct 29 20:47:06 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (negsf, negdf): Reorganize to use vector modes
	for SSE variants.
	(abssf, absdf): Use force_reg.
	(movv4sf, movv2df): New splitters.
	* i386.h (PREDICATE_CODES): add zero_extended_scalar_load_operand
	* i386.c (zero_extended_scalar_load_operand

	* i386-protos.h (ix86_expand_call): Update prototype.
	* i386.c (ix86_function_ok_for_sibcall): Handle 64bit
	(ix86_expand_call): Use r11 for indirect sibcalls.
	* i386.md (call, call_value, untyped_call, call_value_pop):
	update x86_expand_call call.
	(sibcall, sibcall_value): new patterns
	(call_rex64, call_value_rex64): Do not accept sibcalls.
	(sibcall_rex64, sibcall_value_rex64,
	sibcall_rex64_v, sibcall_value_rex64_v): New.

Tue Oct 29 15:37:39 CET 2002  Jan Hubicka  <jh@suse.cz>

	* toplev.c (rest_of_compilation): Reorganize way reg_scan is called
	before final pass.

2002-10-29  Hans-Peter Nilsson  <hp@bitrange.com>

	* toplev.c (rest_of_type_compilation): Return early in case of
	errors.
	(check_global_declarations): Don't call debug_hooks->global_decl
	in case of errors.

2002-10-28  Andreas Bauer  <baueran@in.tum.de>

	* doc/c-tree.texi (Tree overview): Fix typos.

2002-10-29  Phil Edwards  <pme@gcc.gnu.org>

	* Makefile.in (gnucompare*):  Only record bad comparisons
	if there really was a bad comparison.

Tue Oct 29 19:32:16 CET 2002  Jan Hubicka  <jh@suse.cz>

	* i386.h (CONST_DOUBLE_OK_FOR_LETTER_P): Remove 'H'
	* i386.md (movsf*, movdf*): Use 'C' instead of 'H'
	* md.texi (machine dependent constraints): Document 'C'

	* simplify-rtx.c (simplify_subreg): Fix const_int->vector subregging.

	* i386.c (ix86_expand_vector_move): Fix.

	* i386.c (ix86_expand_builtin): Use sse2_maskmovdqu_rex64.
	* i386.md (sse2_maskmovdqu_rex64): New pattern

	PR target/8322
	* xmmintrin.h (_mm_stream_pi, _mm_stream_pd): Fix cast.
	(ix86_init_mmx_sse_builtins): Fix type.

2002-10-29  Jason Thorpe  <thorpej@wasabisystems.com>

	* gthr-posix.h: Include <unistd.h> for feature tests.
	(sched_get_priority_max, sched_get_priority_min)
	(pthread_getschedparam, pthread_setschedparam): Only use
	if _POSIX_THREAD_PRIORITY_SCHEDULING is defined.
	(__gthread_objc_thread_set_priority): Don't treat all nonzero
	returns from sched_get_priority_max and sched_get_priority_min
	as an error.

2002-10-29  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.h (TARGET_DEFAULT): Make it
	MASK_QUICKCALL.

2002-10-29  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (h8300_eightbit_constant_address_p): New.
	(h8300_tiny_constant_address_p): Likewise.
	* config/h8300/h8300.h (EIGHTBIT_CONSTANT_ADDRESS_P): Use
	h8300_eightbit_constant_address_p.
	(TINY_CONSTANT_ADDRESS_P): Use h8300_tiny_constant_address_p.
	* config/h8300/h8300-protos.h: Add the prototypes for the two
	new functions.

2002-10-29  Kazu Hirata  <kazu@cs.umass.edu>

	* reload1.c (update_eliminables): Unconditionally check if
	frame_pointer_needed has changed.

Tue Oct 29 15:37:39 CET 2002  Jan Hubicka  <jh@suse.cz>

	* toplev.c (rest_of_compilation): Reorganize way reg_scan is called
	before final pass.

2002-10-29  Eric Botcazou  <ebotcazou@libertysurf.fr>

	PR optimization/8334
	* expr.c (expand_expr) [PLUS]: Don't use simplify_binary_operation;
	check for zero operands explicitly.

2002-10-29  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.md (extv, extzv, insv): Set size of referenced
	memory after adjusting to BLKmode.

2002-10-29  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.h (MASK_*): New.
	(TARGET_*): Use MASK_*.

2002-10-28  Zack Weinberg  <zack@codesourcery.com>

	* config.gcc (*-*-vxworks, powerpc-wrs-vxworks*): New stanzas.
	* config/t-vxworks, config/vxworks.h, config/rs6000/t-vxworks,
	config/rs6000/vxworks.h: New files.
	* config/rs6000/sysv4.h: Rip out -mvxworks and all related code.

	* config.gcc (alpha*-*-vxworks*, arm-*-vxworks*,
	i?86-wrs-vxworks*, i960-wrs-vxworks* [all],
	m68k-wrs-vxworks*, mips-wrs-vxworks, powerpc-wrs-vxworks*,
	powerpcle-wrs-vxworks*, sparc*-wrs-vxworks* [all],
	sparc-*-vxsim*): Delete stanzas.
	* gthr-vxworks.h: Rip out all substantive code and just
	include gthr-single.h.

	* config/alpha/vxworks.h, config/arm/vxarm.h,
	config/i386/vxi386.h, config/i960/t-vxworks960,
	config/i960/vx960-coff.h, config/i960/vx960.h,
	config/m68k/t-vxworks68, config/m68k/vxm68k.h,
	config/mips/vxworks.h, config/rs6000/vxppc.h,
	config/sparc/t-vxsparc, config/sparc/t-vxsparc64,
	config/sparc/vxsim.h, config/sparc/vxsparc.h,
	config/sparc/vxsparc64.h: Delete files.

2002-10-28  Jason Thorpe  <thorpej@wasabisystems.com>

	* config.gcc (*-*-netbsd*): Add NETBSD_ENABLE_PTHREADS to
	tm_defines if pthreads are enabled.
	* config/netbsd.h (LIB_SPEC): Only support the -pthread option
	if NETBSD_ENABLE_PTHREADS is defined.

2002-10-28  Kazu Hirata  <kazu@cs.umass.edu>

	* ChangeLog.1: Fix typos.
	* cse.c: Fix a comment typo.
	* reload1.c: Likewise.

2002-10-27  Hans-Peter Nilsson  <hp@bitrange.com>

	* fixinc/inclhack.def (libc1_G_va_list): Correct test_text.
	* fixinc/tests/base/_G_config.h: New file.

2002-10-27  Kazu Hirata  <kazu@cs.umass.edu>

	* combine.c: Fix comment formatting.
	* loop.c: Likewise.
	* real.c: Likewise.
	* regclass.c: Likewise.
	* regmove.c: Likewise.
	* regrename.c: Likewise.
	* reg-stack.c: Likewise.
	* reload1.c: Likewise.
	* reload.c: Likewise.
	* reload.h: Likewise.
	* unroll.c: Likewise.

2002-10-27  Kazu Hirata  <kazu@cs.umass.edu>

	* reload1.c (reload): Fix a comment typo.

Sun Oct 27 10:15:24 CET 2002  Jan Hubicka  <jh@suse.cz>

	* linux64.h (DEFAULT_PCC_STRUCT_RETURN):  Define.

2002-10-27  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	* Makefile.in (dwarf2out.o): Add dependendcy on hashtab.h.
	* dwarf2out.c: Include hashtab.h.
	(is_main_source): New static variable.
	(attr_checksum, die_checksum): Modified to handle die references.
	(same_loc_p, same_dw_val_p, same_attr_p, same_die_p, same_die_p_wrap,
	unmark_all_dies, htab_cu_hash, htab_cu_eq, htab_cu_del, check_duplicate_cu,
	record_comdat_symbol_number): New static functions.
	(output_comp_unit, compute_section_prefix, is_type_die, break_out_includes,
	mark_dies, unmark_dies, dwarf2out_start_source_file): Modified.
	* toplev.c (rest_of_decl_compilation): Call of dwarf2out_decl for type
	declarations added.

2002-10-26  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (initial_offset): Change to
	h8300_initial_elimination_offset.
	* config/h8300/h8300.h (INITIAL_ELIMINATION_OFFSET): Use
	h8300_initial_elimination_offset.
	* config/h8300/h8300-protos.h: Update the prototype.

2002-10-26  Hans-Peter Nilsson  <hp@bitrange.com>

	* config/mmix/mmix.h (LIBCALL_VALUE): Use
	MMIX_RETURN_VALUE_REGNUM, not MMIX_OUTGOING_RETURN_VALUE_REGNUM.
	(FUNCTION_VALUE_REGNO_P): Similar, but move code to...
	* config/mmix/mmix.c (mmix_function_value_regno_p): New.
	* config/mmix/mmix-protos.h: Remove needless ifdefs on TREE_CODE
	and RTX_CODE.
	(mmix_function_value_regno_p): Declare.

	* config/mmix/mmix.md ("fixuns_truncdfdi2"): Replace unsigned_fix,
	invalid for floating point mode result, with fix.

Fri Oct 25 00:04:21 2002  Alexandre Oliva  <aoliva@redhat.com>

	* Makefile.in (GCC_FOR_TARGET): Add -L$(objdir)/../ld.
	(STAGE2_FLAGS_TO_PASS): Pass GCC_FOR_TARGET.
	(stage1_build): Likewise.

2002-10-25  Mike Stump  <mrs@apple.com>

	Fixes gcc.dg/warn-1.c.
	* c-typeck.c (warn_for_assignment): Don't print argument number,
	if zero.

Sat Oct 26 01:44:46 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* toplev.c (dump_file_index): Add DFI_ce3.
	(dump_file_info): Likewise.
	(rest_of_compilation): Run first ifcvt pass before tracer.

2002-10-25  Steve Ellcey  <sje@cup.hp.com>

	* config/ia64/hpux.h (BITS_BIG_ENDIAN): Remove.

2002-10-25  Richard Henderson  <rth@redhat.com>

	* real.c (real_to_decimal): If the >1 tens reduction loop results
	in a negative exponent, fall into the <1 pten computation.

2002-10-25  Zack Weinberg  <zack@codesourcery.com>

	PR middle-end/6994
	* c-objc-common.c (inline_forbidden_p): Can not inline
	functions containing structures or unions containing VLAs.
	* tree-inline.c (walk_tree): For all class 't' nodes, walk
	TYPE_SIZE and TYPE_SIZE_UNIT.
	(copy_tree_r): Copy types if they are variably modified.

2002-10-25  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.md: Remove old-style peepholes.

2002-10-25  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.c (s390_decompose_address): Do not range check the
	displacement if base or index is the argument pointer register.

2002-10-24  Hans-Peter Nilsson  <hp@bitrange.com>

	PR other/3337
	PR bootstrap/6763
	PR bootstrap/8122
	* fixinc/inclhack.def (libc1_G_va_list): New fix.
	* fixinc/fixincl.x: Regenerate.
	* config/i386/linux.h: Move MD_FALLBACK_FRAME_STATE_FOR inside
	ifndef IN_LIBGCC2.  Wrap it together with signal.h and
	sys/ucontext.h inclusion in ifndef USE_GNULIBC_1.
	* configure.in (gcc_AC_CHECK_DECLS): Check vasprintf too.
	* config.in, configure: Regenerate.

2002-10-24  Igor Shevlyakov <igor@microunity.com>

	* varasm.c (struct rtx_const): Array size 16 for V16QImode.

2002-10-24  Richard Henderson  <rth@redhat.com>

	* config/i386/i386.c (x86_output_mi_thunk): Fix x86_64 pic jump.

2002-10-24  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (initial_offset): Simplify by using
	round_frame_size.

2002-10-24  Marek Michalkiewicz  <marekm@amelek.gda.pl>

	* doc/install.texi (avr): Update required binutils version.

2002-10-24  Theodore A. Roth  <troth@openavr.org>

	* doc/install.texi: Point avr users at more up-to-date information.

2002-10-24  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.md (movdi, movsi, movhi, movqi): Add peepholes2
	to pull operands out of the literal pool where possible.

2002-10-24  Denis Chertykov  <denisc@overta.ru>

	* config/avr/avr.c (init_cumulative_args): Test fntype for zero.

2002-10-24  Steve Ellcey  <sje@cup.hp.com>

	* expr.c (convert_move): If unsignedp is less then zero there
	is no equivalent code.

2002-10-24  Zack Weinberg  <zack@codesourcery.com>

	* tree.def: Delete mention of nonexistent ARRAY_TYPE fields.

2002-10-24  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.h: Rework comments; re-sort target macro definitions
	according to the sequence they are defined in the manual.
	(POINTER_BOUNDARY): Remove.

2002-10-24  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (round_frame_size): Replace 8 with
	BITS_PER_UNIT.

2002-10-24  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.h (EIGHTBIT_CONSTANT_ADDRESS_P): Make it
	64-bit safe.
	(TINY_CONSTANT_ADDRESS_P): Likewise.

2002-10-24  Richard Henderson  <rth@redhat.com>

	* config/ia64/ia64.c (TARGET_ASM_CAN_OUTPUT_MI_THUNK): True.
	(ia64_output_mi_thunk): Rewrite to use rtl, and to handle the
	vcall offset.

2002-10-24  Richard Henderson  <rth@redhat.com>

	PR opt/7944
	* reload.c (find_reloads_toplev): Mode of X is not important
	when simplifying subregs of constants.

2002-10-24  Richard Sandiford  <rsandifo@redhat.com>

	* config.gcc (mips64vr-*-elf*, mips64vrel-*-elf*): Add
	MIPS_MARCH_CONTROLS_SOFT_FLOAT=1 to $tm_defines.
	* config/mips/mips.c (MIPS_MARCH_CONTROLS_SOFT_FLOAT): Default to 0.
	(override_options): Base default setting of MASK_SOFT_FLOAT on -march
	if MIPS_MARCH_CONTROLS_SOFT_FLOAT.

2002-10-24  Richard Sandiford  <rsandifo@redhat.com>

	* optabs.c (expand_binop): Don't reuse the shift target in the
	middle of shift sequences.

Wed Oct 23 22:48:44 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (abs splitters): Do not produce nested subregs.

Wed Oct 23 12:42:32 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (movti_rex64): Fix constraints.

Wed Oct 23 12:01:21 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (abssf,absdf): Use vector operands for SSE
	(abssf2_ifs, absdf2_ifs, absdf2_ifs_rex64 and splitters): Update for
	vector operand.

2002-10-23  Ziemowit Laski <zlaski@apple.com>

	* objc/objc-act.c (get_static_reference): Remove unneeded
	TYPE_BINFO initialization.
	(get_object-reference): Likewise.
	(build_constructor): Tighten precondition check.
	(finish_message_expr): Likewise.

2002-10-23  Jakub Jelinek  <jakub@redhat.com>

	* config/i386/i386.c (local_symbolic_operand): Move LABEL_REF test
	after CONST test.

2002-10-23  Steve Ellcey  <sje@cup.hp.com>

	* config/ia64/ia64.c (hfa_element_mode): Don't allow 128 bit floats
	in HFAs.

2002-10-23  Richard Henderson  <rth@redhat.com>

	* config/alpha/alpha.c (TARGET_ASM_CAN_OUTPUT_MI_THUNK): True.
	(alpha_output_mi_thunk_osf): Handle vcall_offset.

2002-10-23  Zack Weinberg  <zack@codesourcery.com>

	* langhooks.h (struct lang_hooks_for_tree_inlining): Add
	var_mod_type_p.
	* langhooks-def.h: Default for tree_inlining.var_mod_type_p is
	hook_tree_bool_false.

	* tree.c (variably_modified_type_p): Moved here from
	cp/tree.c.  Use lang_hooks.tree_inlining.var_mod_type_p for
	language-specific cases.  Due to this, must weaken some 'if
	and only if' checks to merely 'if'.
	* tree.h: Prototype variably_modified_type_p.

	* tree-inline.c (walk_tree): #undef WALK_SUBTREE_TAIL at end.

2002-10-23  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/linux.h (CC1_SPEC, CC1PLUS_SPEC): Remove.
	* config/s390/s390.c (optimization_options): Disable -fcaller-saves.

	* config/s390/s390-protos.h (fp_operand): Remove.
	* config/s390/s390.c (fp_operand): Remove.
	* config/s390/s390.md ("movdi"): Replace fp_operand by FP_REG_P.
	("*movdi_lhi", "*movdi_lli", "*movdi_larl"): Likewise.
	("movsi", "*movsi_lhi", "*movsi_lli"): Likewise.
	(movdi_31, movdf_31 splitters): Likewise.

	* config/s390/s390.h (IEEE_FLOAT): Remove.
	(TARGET_FLOAT_FORMAT): Define in terms of TARGET_IEEE_FLOAT.
	(INT_REGNO_P): Rename to ...
	(GENERAL_REGNO_P): ... this.
	(FLOAT_REGNO_P): Rename to ...
	(FP_REGNO_P): ... this.
	(ADDR_REGNO_P): New macro.
	(GENERAL_REG_P, ADDR_REG_P, FP_REG_P, CC_REG_P): New macros.
	(REGNO_OK_FOR_DATA_P, REGNO_OK_FOR_FP_P): Remove.
	(DATA_REG_P, FP_REG_P, ADDRESS_REG_P): Likewise.
	(HARD_REGNO_NREGS): Adapt to macro renaming.
	(HARD_REGNO_MODE_OK): Likewise.

2002-10-23  David Edelsohn  <edelsohn@gnu.org>
	    Geoff Keating  <geoffk@apple.com>

	* config/rs6000/rs6000.c (rs6000_register_move_cost): New function.
	(rs6000_memory_move_cost): New function.
	* config/rs6000/rs6000-protos.h: Declare them.
	* config/rs6000/rs6000.h: Use them.

2002-10-23  Ulrich Weigand  <uweigand@de.ibm.com>

	* libgcc2.c (__udiv_w_sdiv): Use attribute ((always_inline)) when
	inlining it into other libgcc2 routines.
	(__udivmoddi4): Likewise.

2002-10-22  Nathanael Nerode  <neroden@gcc.gnu.org>

	* doc/sourcebuild.texi (Test Suites): Improve.

2002-10-22  Stan Shebs  <shebs@apple.com>

	* config/rs6000/rs6000.c (rs6000_output_mi_thunk): Add missing
	case for Darwin.

2002-10-22  Jim Wilson  <wilson@redhat.com>

	* config/i386/i386.md (subdi3_1): Add call to ix86_binary_operator_ok.

Wed Oct 23 01:52:36 CEST 2002  Jan Hubicka  <jh@suse.cz>

	PR other/8289
	* xmmintrin.h: Add const to the argument of loads.

	* i386.md (pushv2di): New pattern.
	PR target/6890
	* xmmintrin.h (_MM_TRANSPOSE4_PS): New.

2002-10-22  Richard Henderson  <rth@redhat.com>

	* target.h (gcc_target.asm_out): Merge output_mi_thunk and
	output_mi_vcall_thunk into a single hook.  Add can_output_mi_thunk.
	* target-def.h (TARGET_ASM_OUTPUT_MI_THUNK): Don't conditionalize.
	(TARGET_ASM_OUTPUT_MI_VCALL_THUNK): Remove.
	(TARGET_ASM_CAN_OUTPUT_MI_THUNK): New.
	(TARGET_ASM_OUT): Update.
	* hooks.c (hook_bool_tree_hwi_hwi_tree_false): New.
	(hook_bool_tree_hwi_hwi_tree_true): New.
	(default_can_output_mi_thunk_no_vcall): New.
	* hooks.h: Declare them.
	* system.h (ASM_OUTPUT_MI_THUNK): Poison.

	* config/alpha/alpha.c (TARGET_ASM_CAN_OUTPUT_MI_THUNK): New.
	(alpha_output_mi_thunk_osf): Add VCALL_OFFSET parameter.
	* config/arm/arm.c, config/cris/cris.c, config/frv/frv.c,
	config/i960/i960.c, config/ia64/ia64.c, config/m68k/m68k.c,
	config/mmix/mmix.c, config/pa/pa.c, config/sparc/sparc.c,
	config/stormy16/stormy16.c: Similarly.

	* config/i386/i386.c (x86_output_mi_thunk): Merge vcall_offset code.
	Handle 64-bit properly.  Streamline.
	(x86_output_mi_vcall_thunk): Remove.
	(x86_this_parameter): Rename from ia32_this_parameter; handle 64-bit.
	(x86_can_output_mi_thunk): New.
	(TARGET_ASM_OUTPUT_MI_VCALL_THUNK): Remove.
	(TARGET_ASM_CAN_OUTPUT_MI_THUNK): New.
	(override_options): Don't zap targetm.asm_out.output_mi_vcall_thunk.

	* config/rs6000/rs6000.c (rs6000_output_mi_thunk): Rename from
	output_mi_thunk; make static; always use function_section.
	(TARGET_ASM_OUTPUT_MI_THUNK): New.
	(TARGET_ASM_CAN_OUTPUT_MI_THUNK): New.
	(rs6000_ra_ever_killed): Test no_new_pseudos not
	targetm.asm_out.output_mi_thunk in conjunction with thunks.
	* config/rs6000/rs6000-protos.h: Update.
	* config/rs6000/sysv4.h (TARGET_ASM_OUTPUT_MI_THUNK): Remove.
	* config/rs6000/xcoff.h (ASM_DECLARE_FUNCTION_NAME): Don't call
	xcoffout_declare_function when using rs6000_output_mi_thunk.

	* config/s390/s390.c (s390_output_mi_thunk): Rename from
	s390_output_mi_vcall_thunk.
	(TARGET_ASM_OUTPUT_MI_THUNK): Remove.
	(TARGET_ASM_CAN_OUTPUT_MI_THUNK): New.

	* config/vax/vax.c (vax_output_mi_thunk): Static; add vcall_offset.
	(TARGET_ASM_OUTPUT_MI_THUNK, TARGET_ASM_CAN_OUTPUT_MI_THUNK): New.
	* config/vax/vax-protos.h: Update.
	* config/vax/vax.h (ASM_OUTPUT_MI_THUNK): Remove.

Wed Oct 23 00:33:11 CEST 2002  Jan Hubicka  <jh@suse,cz>

	* i386.c (standard_sse_constant_p): Accept vector and integer zeros too.
	* i386.h (EXTRA_CONSTRAINT): Recognize 'C'
	* i386.md (movti_internal): Use 'C'

	* xmmintrin.h (_mm_cmplt_epi*): New.

2002-10-22  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.md ("*movdi_64"): Fix op_type attribute.
	("*movdf_64"): Likewise.
	("*lshrdi3_64"): Likewise.
	("blockage"): Add length attribute.
	("lit"): Likewise.

Tue Oct 22 23:51:34 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md: FIx typo.
	(sse2_cvtsi2sd, sse2_pslrdq): Fix template.
	(sse2_umulv2siv2di3): Fix predicate.
	(sse2_psadbw, ashrv8hi3, ashrv4si3, lshrv8hi3 lshrv4si3,
	lshrv2di3, ashlv8hi3, ashlv4si3, ashlv2di3): Likewise.
	* xmmintrin.h (_mm_mul_epu16): Rename to...
	(_mm_mul_epu32): This one.
	(_mm_cvtsi32_si128, _mm_cvtsi128_si32): New.

	(contains_128bit_aligned_vector_p): Undo accidental checkin.

2002-10-22  Eric Christopher  <echristo@redhat.com>

	* config/sparc/sparc.h: Add #error.

2002-10-22  Ulrich Weigand  <uweigand@de.ibm.com>

	* config.gcc [s390-*-linux]: Remove s390/t-linux from tmake_file.
	[s390x-*-linux*]: Likewise.
	* config/s390/t-linux: Remove.
	* config/s390/s390.h: Include fixdfdi.h when building libgcc2.

Tue Oct 22 19:07:03 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (builtin_description): Add IX86_BUILTIN_PUNPCKHQDQ128.
	(ix86_expand_builtin): Fix MASKMOVDQU expasion.
	* i386.h (ix86_builtins): Add IX86_BUILTIN_PUNPCKHQDQ128.
	* i386.md (mmx_punpck?dq): Simplify.
	(sse2_pubpcklqdq): Fix.
	(sse2_pubpckhqdq): New.
	* xmmintrin.h (_mm_unpackhi_epi32): New.

	* xmmintrin.h (_mm_cvt*, _mm_stream_pd): Fix prototypes.
	(_mm_shufflehi_epi16, _mm_shufflelo_epi16): Fix typo.

2002-10-22  Nathan Sidwell  <nathan@codesourcery.com>

	PR c++/7209
	* fold_const.c (fold_binary_op_with_conditional_arg): Always
	build compound_expr if we used save_expr.

2002-10-22  Alan Modra  <amodra@bigpond.net.au>

	* output.h (SECTION_NOTYPE): Define.
	* varasm.c (default_section_type_flags_1): Set SECTION_NOTYPE for
	init array sections.
	(default_elf_asm_named_section): Mind SECTION_NOTYPE.
	* config/arm/arm.c (arm_elf_asm_named_section): Likewise.  Also
	merge TLS support.

2002-10-21  Richard Henderson  <rth@redhat.com>

	* config/i386/i386.c (ix86_function_ok_for_sibcall): Look at
	the function type, not the return type.

2002-10-21  Richard Henderson  <rth@redhat.com>

	* real.c (sticky_rshift_significand): Return inexact, don't
	or it in immediately.
	(sub_significands): Accept incomming carry.
	(div_significands, rtd_divmod): Update for sub_significands change.
	(round_for_format): Update for sticky_rshift_significand change.
	(do_add): Don't involve the inexact bit in addition, do give the
	inexact bit as the subtraction carry-in.
	(encode_internal, decode_internal, real_internal_format): New.
	* real.h (real_internal_format): Declare.

2002-10-21  Ulrich Weigand  <uweigand@de.ibm.com>

	* libgcc2.c: Fix __udiv_w_sdiv breakage on platforms that
	don't define sdiv_qrnnd.

2002-10-21  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.h (EIGHTBIT_CONSTANT_ADDRESS_P): Simplify
	using IN_RANGE.
	(TINY_CONSTANT_ADDRESS_P): Likewise.

Tue Oct 22 00:04:20 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (builtin_description): Add punpcklqdq and movdq2q
	(ix86_init_mmx_sse_builtins): Add v2di_ftype_void, di_ftype_v2di,
	v16qi_ftype_pchar, void_ftype_pchar_v16qi, v4si_ftype_pchar,
	void_ftype_pchar_v4si; Initialize __builtin_ia32_movdq2q,
	__builtin_ia32_loaddqa, __builtin_ia32_loaddqu, __builtin_ia32_loadd
	__builtin_ia32_storedqa, __builtin_ia32_storedqu, __builtin_ia32_stored
	__builtin_ia32_setzero128.
	(ix86_expand_builtin): Handle IX86_BUILTIN_CLRTI, IX86_BUILTIN_LOADDQA,
	IX86_BUILTIN_LOADDQU, IX86_BUILTIN_LOADD, IX86_BUILTIN_STOREDQA,
	IX86_BUILTIN_STOREDQU, IX86_BUILTIN_STORED, Ix86_BUILTIN_MOVQ.
	* i386.h (ix86_builtins): Add IX86_BUILTIN_LOADDQA, IX86_BUILTIN_LOADDQU,
	IX86_BUILTIN_STOREDQA, IX86_BUILTIN_STOREDQU, IX86_BUILTIN_LOADD,
	IX86_BUILTIN_STORED, IX86_BUILTIN_CLRTI, IX86_BUILTIN_MOVDQ2Q,
	IX86_BUILTIN_PUNPCKLQDQ128, Ix86_BUILTIN_MOVQ.
	* i386.md (sse2_punpcklqdq, sse2_movqsse2_loadd, sse2_stored,
	sse2_movq): New patterns.
	(sse2_movdqa, sse2_movdqu, sse2_movdq2q): Fix.
	* xmmintrin.h (_mm_load_si128, _mm_loadu_si128, _mm_loadl_epi64,
	_mm_store_si128, _mm_storeu_si128, _mm_storel_epi64,
	_mm_setzero_si128, _mm_set_epi64, _mm_set_epi32, _mm_set_epi16,
	_mm_set_epi8, _mm_set1_epi64, _mm_set1_epi32, _mm_set1_epi16,
	_mm_set1_epi8, _mm_setr_epi64, _mm_setr_epi32, _mm_setr_epi16,
	_mm_setr_epi8, _mm_unpacklo_epi64,_mm_set_moveq): New functions.
	(_mm_insert_epi16): Fix.

2002-10-21  Dale Johannesen  <dalej@apple.com>

	* config/rs6000/rs6000.c (rs6000_reverse_condition): Handle
	    unsafe math reversals correctly for RTL generation.
	  (output_cbranch):  Replace rs6000_reverse_condition call
	    by its former definition.

2002-10-21  Jakub Jelinek  <jakub@redhat.com>

	* config/i386/i386.c (x86_64_sign_extended_value): Add allow_rip
	argument.  In CM_SMALL_PIC model consider SYMBOL_REFs binding locally or
	from constant pool or LABEL_REFs as sign extended if allow_rip.
	Change all +-1GB limits to +-16MB.
	(x86_64_general_operand, x86_64_szext_general_operand,
	x86_64_nonmemory_operand, x86_64_movabs_operand,
	x86_64_szext_nonmemory_operand, x86_64_immediate_operand,
	legitimate_address_p, ix86_expand_int_movcc): Update callers.
	(local_symbolic_operand): Don't allow offsets bigger than +-16MB
	in CM_SMALL_PIC model.
	(legitimate_pic_address_disp_p): Don't check offsets before
	calling local_symbolic_operand.
	(legitimize_pic_address): Force offsets bigger than +-16MB into
	register.
	* config/i386/i386.h (EXTRA_CONSTRAINT, CONST_COSTS): Likewise.
	* config/i386/i386-protos.h (x86_64_sign_extended_value): Update
	prototype.

	* configure.in: Test for @GOTNTPOFF and @INDNTPOFF on IA-32 too.
	Add x86-64 test.  Set tls_first_minor to 14 on IA-32 and x86-64.
	* configure: Rebuilt.
	* config/i386/i386.c (x86_64_sign_extended_value): Don't allow TLS
	SYMBOL_REFs unless enclosed in UNSPEC.  Handle UNSPEC_DTPOFF,
	UNSPEC_GOTNTPOFF and UNSPEC_NTPOFF.
	(legitimate_address_p): Allow foo@dtpoff(base) even on TARGET_64BIT
	-fpic.
	(ix86_encode_section_info): Don't ever generate TLSGD or TLSLD for
	non-pic code if TARGET_64BIT.
	(legitimize_address): Generate 64-bit TLS sequences.
	(output_pic_addr_const): Support x86-64 TLS operators.
	(i386_output_dwarf_dtprel): Output 64-bit DTPOFF as .long f@DTPOFF, 0.
	(print_operand_address): Use %fs instead of %gs on TARGET_64BIT.
	Don't append (%rip) in 64-bit TLSGD and TLSLD sequences.
	(output_addr_const_extra): Support x86-64 TLS operators.
	(maybe_get_pool_constant): Handle TARGET_64BIT -fpic.
	(ix86_tls_get_addr): Use __tls_get_addr on TARGET_64BIT
	unconditionally.
	* config/i386/i386.md (*tls_global_dynamic_gnu): Renamed to...
	(*tls_global_dynamic_32_gnu): ..., add !TARGET_64BIT.
	(*tls_global_dynamic_sun): Renamed to...
	(*tls_global_dynamic_32_sun): ..., add !TARGET_64BIT.
	(tls_global_dynamic): Renamed to...
	(tls_global_dynamic_32): ... this.
	(tls_global_dynamic_64, *tls_global_dynamic_64): New.
	(*tls_local_dynamic_base_dynamic_gnu): Renamed to...
	(*tls_local_dynamic_base_dynamic_32_gnu): ..., add !TARGET_64BIT.
	(*tls_local_dynamic_base_dynamic_sun): Renamed to...
	(*tls_local_dynamic_base_dynamic_32_sun): ..., add !TARGET_64BIT.
	(tls_local_dynamic_base_dynamic): Renamed to...
	(tls_local_dynamic_base_dynamic_32): ... this.
	(tls_local_dynamic_base_dynamic_64,
	*tls_local_dynamic_base_dynamic_64): New.
	(*tls_local_dynamic_once): Renamed to...
	(*tls_local_dynamic_32_once): ... this.

2002-10-21  Ulrich Weigand  <uweigand@de.ibm.com>

	* libgcc2.c: Inline __udiv_w_sdiv when compiling __udivdi3,
	__divdi3, __umoddi3, or __moddi3.

2002-10-21  Ulrich Weigand  <uweigand@de.ibm.com>

	* c-opts.c (missing_arg): Use cl_options[opt_index].opt_code
	instead of just opt_index as switch expression.

	* calls.c (store_one_arg): Change type of 'excess_align'
	to unsigned int.

	* profile.c (output_gcov_string): Change type of 'temp'
	to size_t.

2002-10-21  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/fixdfdi.h (__fixunsdfdi, __fixdfdi): Add prototypes.
	(__fixunssfdi, __fixsfdi): Likewise.
	* config/s390/s390.c (s390_single_hi): Initialize 'value'.
	(s390_single_qi): Likewise.
	(s390_emit_epilogue): Initialize 'offset'.  Remove signed vs.
	unsigned comparison warning.
	(s390_return_addr_rtx): New function.
	* config/s390/s390-protos.h (s390_return_addr_rtx): Declare it.
	* config/s390/s390.h (RETURN_ADDR_RTX): Use it.
	(HARD_REGNO_MODE_OK): Rewrite condition to silence warnings.

2002-10-21  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.c (s390_output_mi_vcall_thunk): New function.
	(TARGET_ASM_OUTPUT_MI_VCALL_THUNK): Define target hook.
	(s390_output_mi_thunk): Remove.
	(TARGET_ASM_OUTPUT_MI_THUNK): Remove.

2002-10-21  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.h (N_REG_CLASSES): Parenthesize.

2002-10-20  Zack Weinberg  <zack@codesourcery.com>

	* config/i386/i386.c (ix86_function_ok_for_sibcall): Fix an
	inverted test in the conditional determining the possibility
	of sibcalls in PIC mode.

2002-10-20  Richard Henderson  <rth@redhat.com>

	* target.h (struct gcc_target): Line wrap.

	* config/alpha/alpha.c (alpha_output_mi_thunk_osf): Static.
	(TARGET_ASM_OUTPUT_MI_THUNK): Define here...
	* config/alpha/alpha.h: ... not here.
	* config/alpha/alpha-protos.h: Update.

	* config/arm/arm.c, config/arm/arm.h, config/arm/arm-protos.h
	config/cris/cris-protos.h, config/cris/cris.c, config/cris/cris.h,
	config/frv/frv-protos.h, config/frv/frv.c, config/frv/frv.h,
	config/i386/i386-protos.h, config/i386/i386.c, config/i386/openbsd.h,
	config/i386/unix.h, config/i960/i960-protos.h, config/i960/i960.c,
	config/i960/i960.h, config/ia64/ia64-protos.h, config/ia64/ia64.c,
	config/ia64/ia64.h, config/m68k/linux.h, config/m68k/m68k-protos.h,
	config/m68k/m68k.c, config/m68k/netbsd-elf.h, config/m68k/openbsd.h,
	config/mmix/mmix-protos.h, config/mmix/mmix.c, config/mmix/mmix.h,
	config/pa/pa-protos.h, config/pa/pa.c, config/pa/pa.h,
	config/s390/s390-protos.h, config/s390/s390.c, config/s390/s390.h,
	config/sparc/openbsd.h, config/sparc/sparc-protos.h,
	config/sparc/sparc.c, config/sparc/sparc.h,
	config/stormy16/stormy16-protos.h, config/stormy16/stormy16.c,
	config/stormy16/stormy16.h: Similarly.

	* config/m68k/m68k.c (m68k_output_mi_thunk): Replicate mnemonic
	selection logic from call patterns.

2002-10-20  Mark Mitchell  <mark@codesourcery.com>

	* config/m68k/m68k.c (m68k_output_mi_thunk): Fix typo.

2002-10-20  Zdenek Dvorak  <rakdver@atrey.karlin.mff.cuni.cz>

	PR other/8202
	* i386.c (ix86_init_mmx_sse_builtins, ix86_expand_builtin): Define and
	expand __builtin_ia32_pslldqi128 and __builtin_ia32_psrldqi128.
	* i386.h (IX86_BUILTIN_PSLLDQI128, IX86_BUILTIN_PSRLDQI128): New.
	* xmmintrin.h (_mm_srli_si128, _mm_slli_si128): New.

2002-10-20  Roger Sayle  <roger@eyesopen.com>

	PR c/761
	* toplev.c (flag_unsafe_profile_arcs): Remove.
	(flag_bounded_pointers): Remove.
	(flag_bounds_check): Correct comments.
	(lang_independent_options): Remove -funsafe-profile-arcs and
	-fbounded-pointers.  Correct -fbounds-check comments.

	* flags.h: Correct flag_schedule_interblock comments.
	(flag_bounded_pointers): Remove prototype.
	(flag_bounds_check): Correct comments.

	* c-opts.c (c_common_init_options): No need to mark
	flag_bounds_check as unspecified.
	(c_common_post_options): And no need to set it from
	flag_bounded_pointers if its still unspecified.

	* doc/invoke.texi: Fix some overfull hboxes in "make dvi".
	Document --version, -feliminate-dwarf-2-dups, -fno-sched-interblock,
	-fno-sched-spec, -fsched-spec-load, -fsched-spec-load-dangerous,
	-fsched-verbose=n, -fno-branch-count-reg and -fbounds-check.

Sat Oct 19 22:02:28 2002  Alexandre Oliva  <aoliva@redhat.com>
	Angela Marie Thomas  <angela@releasedominatrix.com>
	Brendan Kehoe  <brendan@zen.org>
	Nick Clifton  <nickc@redhat.com>
	Andrew Haley  <aph@redhat.com>

	* configure.in (--with-sysroot): New.  Don't inhibit libc if
	given.  AC_SUBST TARGET_SYSTEM_ROOT, TARGET_SYSTEM_ROOT_DEFINE
	and CROSS_SYSTEM_HEADER_DIR.
	* configure: Rebuilt.
	* Makefile.in (CROSS_SYSTEM_HEADER_DIR): Set in configure.
	(TARGET_SYSTEM_ROOT): New.
	(DRIVER_DEFINES): Define CROSS_INCLUDE_DIR from
	CROSS_SYSTEM_HEADER_DIR.
	(install-gcc-tooldir): New target.
	(stmp-fixinc): Do not create $(libsubdir), but rather bail out
	if SYSTEM_HEADER_DIR does not exist and it's not the default
	sys-include directory.
	(deduced.h, stmp-fixproto): Quote SYSTEM_HEADER_DIR properly.
	(install-mkheaders): Likewise.
	* gcc.c (target_system_root): New variable.
	(add_sysrooted_prefix): New function.
	(process_command): Recompute run-time target_system_root from
	gcc_exec_prefix, keeping it unchanged if the relocated sysroot
	does not exist.
	(do_spec_1): Process 'R' spec.
	(main): Add md_exec_prefix to exec_prefixes regardless of
	startfile_prefix_spec.  Use add_sysrooted_prefix for
	startfile_prefixes, and don't skip the default ones when cross
	compiling with sysroot enabled.  Removed unused case of
	non-absolute standard_startfile_prefix.
	* config/interix.h: Remove the only potential, yet disabled,
	occurrence of non-absolute (empty) standard_startfile_prefix.
	* config/sh/linux.h (LIB_SPEC): Add -rpath-link in non-static
	linking.
	* config/mips/linux.h (LIB_SPEC): Define as in sh/linux.h.
	* doc/install.texi (--with-sysroot): Document.
	(--with-headers, --with-libs): Deprecate.

2002-10-19  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>
	    Mark Mitchell  <mark@codesourcery.com>

	* alpha-protos.h (alpha_output_mi_thunk_osf): Update signature to
	match target.h.
	* arm-protos.h, arm.c (arm_output_mi_thunk): Likewise.
	* cris-protos.h, cris.c (cris_asm_output_mi_thunk): Likewise.
	* frv-protos.h, frv.c (frv_asm_output_mi_thunk): Likewise.
	* i386-protos.h, i386.c (x86_output_mi_vcall_thunk,
	x86_output_mi_thunk): Likewise.
	* i960-protos.h, i960.c (i960_output_mi_thunk): Likewise.
	* ia64-protos.h, ia64.c (ia64_output_mi_thunk): Likewise.
	* m68k-protos.h, m68k.c (m68k_output_mi_thunk): Likewise.
	* mmix-protos.h, mmix.c (mmix_asm_output_mi_thunk): Likewise.
	* rs6000-protos.h, rs6000.c (output_mi_thunk): Likewise.
	* s390-protos.h, s390.c (s390_output_mi_thunk): Likewise.
	* stormy16-protos.h, stormy16.c (xstormy16_asm_output_mi_thunk):
	Likewise.
	* vax-protos.h, vax.c (vax_output_mi_thunk): Likewise.

	* target.h (gcc_target): Update output_mi_thunk and
	output_mi_vcall_thunk to take a HOST_WIDE_INT delta and
	vcall_index.

	* config/alpha/alpha.c: Replace ASM_OUTPUT_MI_THUNK with
	TARGET_ASM_OUTPUT_MI_THUNK in comments.
	* config/alpha/vms.h (ASM_OUTPUT_MI_THUNK): Don't #undef it.
	(TARGET_ASM_OUTPUT_MI_THUNK): #undef it.
	* config/frv/frv.h (DEFAULT_VTABLE_THUNKS): Remove definition.
	* config/i386/i386-protos.h (x86_output_mi_vcall_thunk): Update
	signature.
	* config/i386/i386.c (x86_output_mi_vcall_thunk): Likewise.
	* config/i386/openbsd.h: Replace ASM_OUTPUT_MI_THUNK with
	TARGET_ASM_OUTPUT_MI_THUNK in comments.
	* config/i960/i960.h (ASM_OUTPUT_MI_THUNK): Don't define.
	(TARGET_ASM_OUTPUT_MI_THUNK): Do define.
	* config/m68k/openbsd.h: Replace ASM_OUTPUT_MI_THUNK with
	TARGET_ASM_OUTPUT_MI_THUNK in comments.
	* config/rs6000/rs6000.c (rs6000_ra_ever_killed): Remove #ifdef
	ASM_OUTPUT_MI_THUNK and replace with check of targetm.

	* doc/tm.texi (TARGET_ASM_OUTPUT_MI_THUNK): Update signature.
	(TARGET_ASM_OUTPU_MI_VCALL_THUNK): Likewise.

2002-10-19  Brad Lucier  <lucier@math.purdue.edu>

	* real.c (do_add): Fix 0+0 sign corner case.
	(do_divide): Fix Inf/0 corner case.

Sun Oct 20 00:31:31 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (classify_argument): Pass MMX arguments in memory
	(ix86_expand_builtin): Expand proper address mode for cflush.
	* i386.md (movdqa): Fix typo.
	(sse2_cflush): Accept DImode addresses.

	* xmmintrin.h (_mm_sqrt_sd): Accept two arguments.
	(_mm_max_sd): Fix pasto.
	(_mm_storeh_pd, _mm_storel_pd): Fix.

	* i386.c (bdesc_comi): Fix to match specification.
	(ix86_expand_sse_comi): Emit the comparison properly.
	* i386.md (sse_comi, sse2_comi, sse_ucomi, sse2_ucomi):
	Do not use comparison operator.
	(vnmaskcmp): Fix template.

	* xmmintrin.h (_mm_cvtps_pi16): Fix.

2002-10-19  Sebastian Pop  <s.pop@laposte.net>

	* dependence.c : Removed.
	* Makefile.in : Remove dependence.o.

Sat Oct 19 10:46:52 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* mmintrin.h (__m64): typedef it to v2si.
	(_mm_cvtsi32_si64, _mm_cvtsi32_si64_mm_sll_pi16,
	_mm_sll_pi32, _mm_sll_pi64, _mm_slli_pi64, _mm_sra_pi16,
	_mm_sra_pi32, _mm_srl_pi16, _mm_srl_pi32, _mm_srl_pi64,
	_mm_srli_pi64, _mm_and_si64, _mm_andnot_si64,
	_mm_or_si64, _mm_xor_si64): Add neccesary casts.
	* xmmintrin.h (_mm_setzero_si64): Likewise.

	* i386.h (ALIGN_MODE_128): Update comment; add missing modes
	(SSE_REG_MODE_P, MMX_REG_MODE_P): New macros.

	PR target/7693
	Patch by Shawn Wagner
	* mmintrin.h: Replace pi64 by si64.

2002-10-18  David Edelsohn  <edelsohn@gnu.org>

	* rs6000.md (movdf_hardfloat32): Order alternatives consistently.
	Use length of 4 not *.
	(movdf_hardfloat64): Same.  Support DFmode moves to/from CTR/LR.
	(movdf_softfloat64): Likewise.
	(movdi_internal32): Use length of 4 not *.
	(movti_power): Same.
	(ctrsi, ctrdi): Same.

2002-10-18  Zack Weinberg  <zack@codesourcery.com>

	* c-decl.c (start_decl): Point users of the old initialized-
	typedef extension at __typeof__.

2002-10-18  Richard Henderson  <rth@redhat.com>

	* real.c (cmp_significand_0, rtd_divmod, ten_to_mptwo): New.
	(real_to_decimal): Re-implement using the logic from the
	gcc 3.2 etoasc.  Comment heavily.
	(div_significands): Simplify loop startup and comparison logic.

2002-10-18  Mark Mitchell  <mark@codesourcery.com>

	* target-def.h (TARGET_ASM_OUTPUT_MI_THUNK): Default to NULL.
	(TARGET_ASM_OUTPUT_MI_VCALL_THUNK): Likewise.
	(TARGET_ASM_OUT): Add them.
	* target.h (asm_out): Add output_mi_thunk and
	output_mi_vcall_thunk.
	* config/alpha/alpha.h (ASM_OUTPUT_MI_THUNK): Rename to ...
	(TARGET_ASM_OUTPUT_MI_THUNK): ... this.
	* config/arm/arm-protos.h (arm_output_mi_thunk): Declare.
	* config/arm/arm.c (arm_output_mi_thunk): Define.
	* config/arm/arm.h (ASM_OUTPUT_MI_THUNK): Rename to ...
	(TARGET_ASM_OUTPUT_MI_THUNK): ... this.
	* config/cris/cris.h (ASM_OUTPUT_MI_THUNK): Rename to ...
	(TARGET_ASM_OUTPUT_MI_THUNK): ... this.
	* config/frv/frv.h (ASM_OUTPUT_MI_THUNK): Rename to ...
	(TARGET_ASM_OUTPUT_MI_THUNK): ... this.
	* config/i386/i386-protos.h (x86_output_mi_thunk): Adjust
	prototype.
	(x86_output_mi_vcall_thunk): Declare.
	* config/i386/i386.c (override_options): Clear
	output_mi_vcall_thunk in 64-bit mode.
	(ix86_fntype_regparm): New function.
	(ix86_return_pops_args): Use it.
	(ia32_this_parameter): New function.
	(x86_output_mi_vcall_thunk): New function.
	(x86_output_mi_thunk): Use it
	* config/i386/unix.h (TARGET_ASM_OUTPUT_MI_THUNK): Adjust.
	(TARGET_ASM_OUTPUT_MI_VCALL_THUNK): Define.
	* config/i960/i960-protos.h (i960_output_mi_thunk): Declare.
	* config/i960/i960.c (i960_output_mi_thunk): New function.
	* config/i960/i960.h (ASM_OUTPUT_MI_THUNK): Adjust.
	* config/ia64/ia64-protos.h (ia64_output_mi_thunk): Declare.
	* config/ia64/ia64.c (ia64_output_mi_thunk): Define.
	* config/ia64/ia64.h (ASM_OUTPUT_MI_THUNK): Rename to ...
	(TARGET_ASM_OUTPUT_MI_THUNK): ... this.
	* config/m68k/m68k-protos.h (m68k_output_mi_thunk): New function.
	* config/m68k/linux.h (ASM_OUTPUT_MI_THUNK): Rename to ...
	(TARGET_ASM_OUTPUT_MI_THUNK): ... this.
	* config/m68k/netbsd-elf.h (ASM_OUTPUT_MI_THUNK): Rename to ...
	(TARGET_ASM_OUTPUT_MI_THUNK): ... this.
	* config/mmix/mmix.h (ASM_OUTPUT_MI_THUNK): Rename to ...
	(TARGET_ASM_OUTPUT_MI_THUNK): ... this.
	* config/pa/pa.h (ASM_OUTPUT_MI_THUNK): Rename to ...
	(TARGET_ASM_OUTPUT_MI_THUNK): ... this.
	* config/rs6000/sysv4.h (ASM_OUTPUT_MI_THUNK): Rename to ...
	(TARGET_ASM_OUTPUT_MI_THUNK): ... this.
	* config/s390/s390-protos.h (s390_output_mi_thunk): Declare.
	* config/s390/s390.c (s390_output_mi_thunk): Define.
	* config/s390/s390.h (ASM_OUTPUT_MI_THUNK): Rename to ...
	(TARGET_ASM_OUTPUT_MI_THUNK): ... this.
	* config/sparc/sparc.h (ASM_OUTPUT_MI_THUNK): Rename to ...
	(TARGET_ASM_OUTPUT_MI_THUNK): ... this.
	* config/stormy16/stormy16.h (ASM_OUTPUT_MI_THUNK): Rename to ...
	(TARGET_ASM_OUTPUT_MI_THUNK): ... this.
	* config/vax/vax-protos.h (vax_output_mi_thunk): Declare.
	* config/vax/vax.c (vax_output_mi_thunk): Define.
	* config/vax/vax.h (ASM_OUTPUT_MI_THUNK): Rename to ...
	(TARGET_ASM_OUTPUT_MI_THUNK): ... this.
	* doc/tm.texi: Adjust documentation.

2002-10-18  Jason Thorpe  <thorpej@wasabisystems.com>

	* config/netbsd.h (NETBSD_ENABLE_EXECUTE_STACK): Define
	__enable_execute_stack function.
	* config/alpha/netbsd.h (TRANSFER_FROM_TRAMPOLINE): Define
	as NETBSD_ENABLE_EXECUTE_STACK.
	* config/i386/netbsd-elf.h (TRANSFER_FROM_TRAMPOLINE): Ditto.
	* config/i386/netbsd.h (TRANSFER_FROM_TRAMPOLINE): Ditto.
	* config/i386/netbsd64.h (TRANSFER_FROM_TRAMPOLINE): Ditto.
	* config/sparc/netbsd-elf.h (TRANSFER_FROM_TRAMPOLINE): Ditto.
	* config/sparc/netbsd.h (TRANSFER_FROM_TRAMPOLINE): Ditto.

2002-10-18  Jason Thorpe  <thorpej@wasabisystems.com>

	* config/i386/i386.c (x86_initialize_trampoline): Emit a call
	to __enable_execute_stack with the address of the trampoline
	if TRANSFER_FROM_TRAMPOLINE is defined.
	* config/i386/i386.h (TARGET_64BIT): Expand to a compile-time
	constant if building libgcc2.

Thu Oct 17 17:40:05 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (pentium4_cost): Fix according to Intel recommendations.
	(ix86_memory_move_cost): Fix for 64bit compilation.

2002-10-17  Roger Sayle  <roger@eyesopen.com>

	* doc/c-tree.texi: Update description of COND_EXPR tree nodes.

2002-10-17  Geoffrey Keating  <geoffk@apple.com>

	* config/rs6000/rs6000.h (HARD_REGNO_MODE_OK): Allow arbitrary modes
	in CTR/LR/MQ.
	* config/rs6000/rs6000.md (movcc_internal1): Support CCmode moves
	to/from CTR/LR/MQ.
	(movsf_hardfloat): Support SFmode moves to/from CTR/LR/MQ.
	(movsf_softfloat): Likewise.

2002-10-17  Janis Johnson  <janis187@us.ibm.com>

	* Makefile.in (site.exp): Add ALT_CXX_UNDER_TEST and COMPAT_OPTIONS.

2002-10-17  Jason Thorpe  <thorpej@wasabisystems.com>

	* config/alpha/alpha.c (alpha_initialize_trampoline): Use
	tramp, not addr, to pass the trampoline address to
	__enable_execute_stack.

Thu Oct 17 18:40:47 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* mmintrin.h: Guard by __MMX__
	* xmmintrin.h: Guard by __SSE__

	PR other/8062
	* xmmintrin.h (_MM_SHUFFLE2): New macro.
	(_mm_load*_?d): New functions.
	(_mm_set*_?d): New functions.
	(_mm_store*_?d): New functions.

Wed Oct 16 15:01:29 CEST 2002  Jan Hubicka  <jh@suse.cz>

	Really commit patch announced at Oct 14
	PR c/7344
	* predict.c (can_predict_insn_p): New function.
	(estimate_probability): Avoid unnecesary work.
	(process_note_prediction): Likewise.
	* toplev.c (rest_of_compilation): Account early branch prediction pass
	as TV_BRANCH_PROB.

	PR other/8048
	Found by Ian Ollmann
	* xmmintrin.h (_mm_shuffle_pd): Fix typo.
	(_mm_load?_pd): Likewise.
	(_mm_store?_pd): Likewise.

	PR target/7386
	* i386.c (builtin_description):Drop cmpg[te]s[sd].
	* xmmintrin.h (__mm_cmpg[te]_s[sd]): Rewrite using
	swapped alternative.

	PR opt/7630
	* reload1.c (reload_inner_reg_of_subreg): New argument output;
	(push_reload): Update call.

2002-10-17  Richard Sandiford  <rsandifo@redhat.com>

	* config.gcc (mips*-*-*): Add OBJECT_FORMAT_ELF to $tm_defines
	if using mips/elf.h or mips/elf64.h.
	* config/mips/elf.h (OBJECT_FORMAT_ELF): Remove.
	* config/mips/elf64.h (OBJECT_FORMAT_ELF): Remove.

2002-10-16  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.c (function_arg): Set inner mode of V1DI to
	SI.

2002-10-16  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/linux.h (ASM_DOUBLE, _ASM_OUTPUT_LONG): Remove.
	(LPREFIX): Likewise.
	(ASM_COMMENT_START, LOCAL_LABEL_PREFIX, ASM_FORMAT_PRIVATE_NAME,
	ASM_OUTPUT_ADDR_VEC_ELT, ASM_OUTPUT_ADDR_DIFF_ELT,
	ASM_OUTPUT_ALIGN, ASM_OUTPUT_SKIP, ASM_OUTPUT_ALIGNED_BSS,
	TEXT_SECTION_ASM_OP, DATA_SECTION_ASM_OP, BSS_SECTION_ASM_OP,
	GLOBAL_ASM_OP, ASM_OUTPUT_MI_THUNK): Move to s390.h.

	* config/s390/s390.h (ASM_COMMENT_START, LOCAL_LABEL_PREFIX,
	ASM_FORMAT_PRIVATE_NAME, ASM_OUTPUT_ALIGN, ASM_OUTPUT_SKIP,
	ASM_OUTPUT_ALIGNED_BSS, TEXT_SECTION_ASM_OP, DATA_SECTION_ASM_OP,
	BSS_SECTION_ASM_OP): Move from linux.h.
	(ASM_OUTPUT_ADDR_VEC_ELT, ASM_OUTPUT_ADDR_DIFF_ELT): Likewise.
	Also, use ASM_GENERATE_INTERNAL_LABEL instead of LPREFIX.

	* config/s390/s390.c (s390_function_profiler): Use
	ASM_GENERATE_INTERNAL_LABEL instead of LPREFIX.

2002-10-15  Eric Christopher  <echristo@redhat.com>

	* stor-layout.c (layout_type): Call GET_MODE_BITSIZE once.
	* java/parse.y (obtain_incomplete_type): Make pointer
	ptr_mode.

2002-10-15  Richard Henderson  <rth@redhat.com>

	* real.c (real_to_decimal): Accept BUF_SIZE and CROP_TRAILING_ZEROS
	as arguments.  Bound DIGITS by the available buffer size.
	(real_to_hexadecimal): Likewise.
	* real.h (real_to_decimal, real_to_hexadecimal): Update prototypes.
	(REAL_VALUE_TO_DECIMAL): Remove.
	* c-common.c, c-pretty-print.c, print-rtl.c, print-tree.c,
	sched-vis.c, config/arc/arc.c, config/c4x/c4x.c, config/fr30/fr30.c,
	config/i370/i370.h, config/i386/i386.c, config/i960/i960.c,
	config/ip2k/ip2k.c, config/m32r/m32r.c, config/m68hc11/m68hc11.c,
	config/m68k/hp320.h, config/m68k/m68k.h, config/m68k/sun2o4.h,
	config/m68k/sun3.h, config/mips/mips.c, config/ns32k/ns32k.c,
	config/pdp11/pdp11.h, config/vax/vax.h: Update all callers to
	use real_to_decimal directly, and with the proper arguments.
	* doc/tm.texi (REAL_VALUE_TO_DECIMAL): Remove.

2002-10-15  Jim Wilson  <wilson@redhat.com>

	* reload1.c (merge_assigned_reloads): After converting overlapping
	reloads to RELOAD_OTHER, abort if there are now conflicting reloads.

	* config/i386/i386.md (adddi3_1): Add call to ix86_binary_operator_ok.

Tue Oct 15 22:08:35 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* expr.c (do_tablejump): Fix typo in my previous commit.

2002-10-15  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/vr.h (DRIVER_SELF_SPECS): Change %<mgp32 to %{<mgp32}.

2002-10-15  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.c (s390_split_branches): Add return
	value.  Add parameters TEMP_REG and TEMP_USED.  Use unspec 104.

	(find_base_register_in_addr): New function.
	(find_base_register_ref): New function.
	(replace_base_register_ref): New function.

	(struct constant_pool): Add members pool_insn, insns, and anchor.
	Remove member last_insn.
	(s390_start_pool): Initialize them.
	(s390_end_pool): Emit pool placeholder insn.
	(s390_add_pool_insn): New function.
	(s390_find_pool): Use insns bitmap instead of addresses.
	(s390_dump_pool): Replace placeholder insn.  Emit anchor.
	Replace unspec 104 by local-pool-relative references.
	(s390_output_constant_pool): Output anchor label if required.
	(s390_output_symbolic_const): Handle unspec 104 and 105.
	(s390_add_pool): Remove, replace by ...
	(s390_add_constant, s390_find_constant): ... these new functions.
	(s390_add_anchor): New function.

	(s390_chunkify_pool): Delete, replace by ...
	(s390_chunkify_start, s390_chunkify_finish,
	s390_chunkify_cancel): ... these new functions.
	(s390_optimize_prolog): Add parameter TEMP_REGNO.
	Recompute register live data for special registers.
	(s390_fixup_clobbered_return_reg): New function.
	(s390_machine_dependent_reorg): Rewrite to use new
	s390_chunkify_... routines.

	config/s390/s390.md ("reload_base"): Rename to ...
	("reload_base_31"): ... this.
	("reload_base_64"): New insn.
	("reload_base2"): Remove.
	("reload_anchor"): New insn.
	("pool"): New insn.

	s390.c (s390_pool_overflow): Remove.
	s390.h (s390_pool_overflow): Likewise.
	s390.md ("cjump", "icjump", "doloop_si"): Remove s390_pool_overflow.

Tue Oct 15 16:51:04 2002  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.md (movv8qi_i+2): Don't split if source is -1.

2002-10-15  Janis Johnson  <janis187@us.ibm.com>

	* doc/install.texi: Formatting changes for conformance to HTML 4.01.

2002-10-15  Ulrich Weigand  <uweigand@de.ibm.com>

	PR opt/7409
	* loop.c (loop_regs_scan): Mark registers used for function
	argument passing as MAY_NOT_OPTIMIZE.

Mon Oct 14 19:22:19 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* gcov-io.h (gcov_info): Fix type.
	* profile.c (create_profiler): Fix type mismatch.

Mon Oct 14 20:33:12 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (movv2di_internal): New pattern.
	(movv2df_internal, movv8hi_internal, movv16qi_internal): Fix predicate.
	(movv2di): New expander.
	* i386.c (ix86_preferred_reload_class): Return NO_REGS for vector operands.

	* i386.c (ix86_expand_timode_binop_builtin): Delete.
	(builtin_description): Add SSE1 logicals; rename SSE2 logicals.
	(ix86_init_mmx_sse_builtins): Kill SSE1 logicals.
	(ix86_expand_builtin): Likewise.
	* i386.h (sse_andti4_df_1, sse_andti3_df_2, sse_andti3_sf_1, sse_andti3_sf_2,
	sse_andti3,
	sse_andnti4_df_1, sse_andti3_df_2, sse_andti3_sf_1, sse_andti3_sf_2,
	sse_andnti3,
	sse_orti4_df_1, sse_orti3_df_2, sse_orti3_sf_1, sse_orti3_sf_2,
	sse_orti3,
	sse_xorti4_df_1, sse_xorti3_df_2, sse_xorti3_sf_1, sse_xorti3_sf_2,
	sse_xorti3): Kill.
	(sse_andv4sf3, sse_andnv4sf3, sse_orv2df3, sse_xorv2df3, sse_andv2df3,
	 sse_andnv2df3, sse_orv2df3, sse_xorv2df3): New expanders.
	(*sse_andv4sf3, *sse_andnv2df3, *sse_orv4sf3, *sse_xorv4sf3, *sse_andv2df3,
	 *sse_andnv2df3, *sse_orv2df3, *sse_xorv2df3): New patterns.
	(*sse_andsf3, *sse_andndf3, *sse_ordf3, *sse_xordf3, *sse_anddf3,
	 *sse_andndf3, *sse_orv2df3, *sse_xorv2df3): New patterns.

	* xmmintrin.h (__m128i): Define as __v2di.

	PR c++/6419
	(expand_expr): Use DECL_RTL_SET_P.

2002-10-14  Roger Sayle  <roger@eyesopen.com>

	* combine.c (simplify_set):  Treat MODE_CC registers like cc0.

2002-10-14  Roger Sayle  <roger@eyesopen.com>
	    Zack Weinberg <zack@codesourcery.com>

	* config/i386/i386.c (k6_cost): Correct typo.

2002-10-14  Mark Mitchell  <mark@codesourcery.com>

	PR optimization/6631
	* alias.c (objects_must_conflict_p): Check honor_readonly when
	examining TYPE_READONLY.
	* function.c (assign_stack_temp_for_type): Likewise.

2002-10-14  Falk Hueffner  <falk.hueffner@student.uni-tuebingen.de>

	* config/alpha/alpha.md (extendsidi2_nofix, extendsidi2_fix):
	Swap zero extension arguments.
	(umaxhi3): Fix instruction class.
	PR target/7211
	(prefetch): Fix prefetch instructions.
	PR target/7238
	(pkwb): Fix output constraint.

2002-10-14  Alexandre Oliva  <aoliva@redhat.com>

	* config/mips/mips.c (print_operand): Increase buffer size for
	real numbers.

2002-10-14  Richard Henderson  <rth@redhat.com>

	PR opt/8165
	* gcse.c (adjust_libcall_notes): Revert last change.
	* simplify-rtx.c (simplify_replace_rtx): Handle LO_SUM.

2002-10-14  Andrew Haley  <aph@redhat.com>

	* tree-inline.c (remap_block): All local class initialization
	flags go in the outermost scope.
	(expand_call_inline): Call java_inlining_map_static_initializers.
	(expand_call_inline): Call java_inlining_merge_static_initializers.
	* java/lang.c (merge_init_test_initialization): New.
	(java_inlining_merge_static_initializers): New.
	(inline_init_test_initialization): New.
	(java_inlining_map_static_initializers): New.

	* tree-inline.c (expand_call_inline): Convert retvar to expected
	type.

2002-10-14  Graham Stott  <graham.stott@btinternet.com>

	* stmt.c (decl_conflicts_with_clobbers_p): Add REG_P check.

2002-10-14  Aldy Hernandez  <aldyh@redhat.com>

	* stmt.c: Fix typo in comment.

Mon Oct 14 11:35:49 2002  J"orn Rennecke <joern.rennecke@superh.com>

	* c-common.c (c_common_type_for_mode): Add V2HImode case.
	* tree.c (build_common_tree_nodes_2): Initialize
	unsigned_V2HI_type_node and V2HI_type_node.
	* tree.h (enum tree_index): Add TI_UV2HI_TYPE and TI_V2HI_TYPE.
	(unsigned_V2HI_type_node, V2HI_type_node): Define.

2002-10-14  Jakub Jelinek  <jakub@redhat.com>

	* config/i386/i386.h (ASM_OUTPUT_REG_PUSH, ASM_OUTPUT_REG_POP):
	Handle TARGET_64BIT.

2002-10-14  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/vr.h (DRIVER_SELF_SPECS): Define.
	* config/mips/t-vr (MULTILIB_OPTIONS): Remove mlong32.
	(MULTILIB_DIRNAMES): Remove long32.
	(MULTILIB_EXCEPTIONS): Don't build -mabi=32 -mgp32 multilibs.
	(MULTILIB_REDUNDANT_DIRS): Remove.

2002-10-14  Richard Sandiford  <rsandifo@redhat.com>

	* doc/tm.texi (DRIVER_SELF_SPECS): Document.
	* gcc.c (driver_self_specs): New variable.
	(do_self_spec): New function.
	(main): Use it to process driver_self_specs.

2002-10-13  Richard Henderson  <rth@redhat.com>

	* config/i386/i386.c (ix86_function_ok_for_sibcall): Reject
	indirect sibcalls when regparm >= 3.

	* config/i386/i386.c (sibcall_insn_operand): New.
	* config/i386/i386.h (PREDICATE_CODES): Update.
	* config/i386/i386-protos.h: Update.
	* config/i386/i386.md (sibcall_1, sibcall_value_1): Use it.

	* rtl.c (shallow_copy_rtx): Use memcpy for the entire node.

2002-10-12  Roger Sayle  <roger@eyesopen.com>

	* simplify-rtx.c (simplify_binary_operation) [ASHIFTRT]: Optimize
	arithmetic right shifts of ~0 during RTL simplifications.

2002-10-12  Neil Booth  <neil@daikokuya.co.uk>

	PR preprocessor/7862
	PR preprocessor/8190
	* gcc.c (cpp_unique_options): Don't delete .d files.
	Remove stray whitespace.

2002-10-12  Naohiko Shimizu  <pshimizu@fa2.so-net.ne.jp>

	* pdp11.h (ASM_OUTPUT_SKIP): Add preceding 0 for octal constant.
	(ASM_OUTPUT_COMMON, ASM_OUTPUT_LOCAL): Likewise.
	* pdp11.c (pdp11_output_function_prologue): 0%o -> %#o.
	(pdp11_output_function_epilogue, output_ascii): Likewise.
	(output_addr_const_pdp11): Likewise.
	* pdp11.md (movdi): Use offsetable memory for floating store.
	(lshrsi3, negsi2): Delete irrelevant comment.

2002-10-11  Andreas Bauer  <baueran@in.tum.de>

	* config/i386/i386.c (ix86_function_ok_for_sibcall): Allow
	indirect calls to be sibcall optimized.
	* config/i386/i386.md (sibcall_1): New.
	(call_1): Add no-sibcalls condition.
	(sibcall_value_1): New.
	(call_value_1): Add no-sibcalls condition.

2002-10-11  Eric Christopher  <echristo@redhat.com>

       * output.h (default_valid_pointer_mode): Declare.
       * varasm.c (default_valid_pointer_mode): Define.
       * target-def.h (TARGET_VALID_POINTER_MODE): Use.
       * target.h: Ditto.
       * tree.c (build_pointer_type_for_mode): New function.
       (build_pointer_type): Use.
       (build_reference_type_for_mode): New function.
       (build_reference_type): Use.
       * tree.h: Declare new functions.
       * c-common.c (handle_mode_attribute): Use new functions, check
       for type.
       * stor-layout.c (layout_type): Depend on machine mode for
       REFERENCE_TYPE and POINTER_TYPE.
       * dwarf2out.c (simple_type_size_in_bits): Move upward in file.
       (modified_type_die): Use instead of PTR_SIZE for POINTER_TYPE
       and REFERENCE_TYPE.
       * config/mips/mips.c (mips_valid_pointer_mode): New function.
       (TARGET_VALID_POINTER_MODE): Use and define.
       * config/mips/mips-protos.h (mips_valid_pointer_mode): Declare.

2002-10-11  Geoffrey Keating  <geoffk@apple.com>

	* cse.c (mention_regs): Set SUBREG_TICKED to the register number,
	not the address of the REG.
	(struct cse_reg_info): Make subreg_ticked unsigned.

2002-10-11  Janis Johnson  <janis187@us.ibm.com>

	* doc/compat.texi: Add info about C++ libraries.

2002-10-11  Richard Henderson  <rth@redhat.com>

	PR opt/8165
	* gcse.c (adjust_libcall_notes): Also adjust notes for INSN.

2002-10-11  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* cfganal.c (dfs_enumerate_from): Use PARAMS.
	* genautomata.c (output_insn_code_cases): Likewise.
	* real.c (real_format): Likewise.
	* tree.c (tree_size): Revise expressions using TREE_CODE_LENGTH to
	ensure value is promoted before doing subtraction.

Fri Oct 11 22:22:38 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* calls.c (expand_call): Simplify noreturn call.

	PR c/7344
	* cfgbuild.c (make_edges): Create edge cache when we do have
	large jumptable.
	* expr.c (do_tablejump): Note size of maximal jumptable.
	* function.c (prepare_function_start): Zero out size.
	* function.h (function): Add max_jumptable_ents.

	* cfgcleanup.c (insn_match_p): Verify sibcall flag for calls to.

Fri Oct 11 12:34:33 2002  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.md (movv8qi_i+2): For V8QI destinations, generate V4HI
	register for mperm_w operation.

Fri Oct 11 10:56:17 2002  J"orn Rennecke <joern.rennecke@superh.com>

	* emit-rtl.c (gen_lowpart_common): When asked to make a vector from
	an integer, use simplify_gen_subreg.

2002-10-10  Diego Novillo  <dnovillo@redhat.com>

	* calls.c (flags_from_decl_or_type): Make extern.
	(ECF_*): Move ...
	* rtl.h (ECF_*): ... here.
	(flags_from_decl_or_type): Declare.

2002-10-10  Roger Sayle  <roger@eyesopen.com>
	    Nathan Sidwell <nathan@codesourcery.com>

	* fold-const.c (fold) [RSHIFT_EXPR]: Optimize arithmetic right
	shifts of the form -1 >> x.

Thu Oct 10 16:52:55 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* cfgcleanup.c (insn_match_p): Verify sibcall flag for calls to.

2002-10-10  Aldy Hernandez  <aldyh@redhat.com>

	* extend.texi (Vector Extensions): Remove comment about single
	element vectors.

2002-10-10  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* fold-const.c (size_htab_hash): Use htab_hash_pointer.
	* function.c (insns_for_mem_hash): Likewise.
	* varasm.c (STRHASH): Likewise.

2002-10-10  Stuart Hastings  <stuart@apple.com>

	* cse.c (struct cse_reg_info): Add subreg_ticked.
	(SUBREG_TICKED): New.
	(get_cse_reg_info): Initialize SUBREG_TICKED.
	(mention_regs): Use it.
	(invalidate): Set SUBREG_TICKED.
	(invalidate_for_call): Likewise.
	(addr_affects_sp_p): Likewise.

2002-10-10  Jakub Jelinek  <jakub@redhat.com>

	* config/i386/i386.md (tls_local_dynamic_base): Put pic reg
	into proper operand.

2002-10-10  Denis Chertykov  <denisc@overta.ru>

	* config/ip2k/ip2k.c (function_epilogue): Optimize stack
	deallocation.
	* config/ip2k/libgcc.S: Combine routines used by function
	epilogue.

2002-10-10  Jim Wilson  <wilson@redhat.com>

	* cse.c (fold_rtx): Don't perform associative optimization for DIV and
	UDIV.

2002-10-10  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/aix52.h: New file.
	* config/rs6000/t-aix52: New File.
	* config.gcc (rs6000-ibm-aix5.1.*): New entry.
	(rs6000-ibm-aix[56789].*): Default to AIX 5.2.

Thu Oct 10 19:37:54 CEST 2002  Jan Hubicka  <jh@suse.cz>

	PR target/5610
	* invoke.texi (-msse-math): Kill
	(-msse): Add note to mfpmath=sse.

Thu Oct 10 17:08:30 CEST 2002  Jan Hubicka  <jh@suse.cz>

	PR target/7723
	* i386.c (ix86_expand_vector_move): Do not generate const0->mem moves.

2002-10-10  Neil Booth  <neil@daikokuya.co.uk>

	PR preprocessor/8179
	* gcc.c (cpp_options): Add {ansi}, move %{m*} to same location
	as cc1_options.
	(default_compilers): Pass debug options when preprocessing
	stdin.

2002-10-06  Richard Henderson  <rth@redhat.com>

	* toplev.c (rest_of_compilation): Revert opt/2960 change.

Wed Oct  9 21:18:43 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (*_cost): Add branch costs.
	(override_options): set ix86_branch_cost.
	(ix86_expand_int_movcc): Use BRANCH_COST.
	* i386.h (costs): Add branch_cost.

2002-10-09  Zack Weinberg  <zack@codesourcery.com>

	PR c/7353
	* c-decl.c (start_decl): Unconditionally issue error for
	'typedef foo = bar'.
	(finish_decl): Remove special case for TYPE_DECL with initializer.

	* doc/extend.texi: Delete "Naming Types" section.  Change all
	cross-references to that section to refer to "Typeof" instead.
	Add the useful safe-max()-macro example from "Naming Types" to
	"Typeof", rewritten using that extension.  Add some compatibility
	notes to "Typeof."

2002-10-09  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* loop.c: Revert 2002-08-15 change.
	(LOOP_REGNO_NREGS): Ensure type is int.

2002-10-09  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.md (extenddftf2): Change to define_insn
	which copies first FPR and clears second.
	(extendsftf2): Same.
	(floatditf2): Fix typo.
	(floatsitf2): Same.
	(fix_trunctfdi2): Same.
	(fix_trunctfsi2): Same.

2002-10-09  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* conflict.c (arc_hash): Change return type to hashval_t.
	* cselib.c (get_value_hash): Likewise.
	* genautomata.c (automaton_decl_hash, insn_decl_hash, decl_hash,
	state_hash, automata_list_hash): Likewise.
	* read-rtl.c (def_hash): Likewise.
	* tree.c (type_hash_hash): Likewise.

2002-10-08  Aldy Hernandez  <aldyh@redhat.com>

	* config/rs6000/rs6000.c (rs6000_ra_ever_killed): Call
	prologue_epilogue_contains instead of using REG_MAYBE_DEAD notes.

Wed Oct  9 15:54:49 2002  J"orn Rennecke <joern.rennecke@superh.com>

	* sh.md (ffssi2): Fix emitted code.

2002-10-09  Ulrich Weigand  <uweigand@de.ibm.com>

	* cse.c (insn_live_p): Pass insn pattern, not full insn
	to may_trap_p.

2002-10-09  Neil Booth  <neil@daikokuya.co.uk>

	* cppmacro.c (paste_tokens): Only allow / to paste with =.

2002-10-09  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.md (movdf splitter): Use gen_int_mode on
	64-bit hosts.
	(movtf_internal): Reference correct displacement for second value
	in memory.
	(movtf splitter): Correct generation of constants in 64-bit mode.

2002-10-09  Alan Modra  <amodra@bigpond.net.au>

	* libgcc2.c (__floatdisf): Properly cure double rounding.

2002-10-09  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	* c-common.c (cb_register_builtins): Define __WCHAR_MAX__.
	* doc/cpp.texi (Common Predefined Macros): Document.

2002-10-09  Gabriel Dos Reis  <gdr@integrable-solutions.net>

	PR doc/7484
	* doc/invoke.texi (Option Summary): List
	-Wmissing-declarations as a C only option.

2002-10-08  Roger Sayle  <roger@eyesopen.com>

	* fold-const.c (fold) [LROTATE_EXPR, RROTATE_EXPR]: Optimize
	left and right rotates of ~0, i.e. integer_all_onesp (arg0).
	[LSHIFT_EXPR, RSHIFT_EXPR]: Optimize shifts and rotates of zero.

Tue Oct  8 01:24:19 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (x86_sse_partial_reg_dependency, x86_sse_partial_regs,
	x86_sse_typeless_stores, x86_sse_load0_by_pxor): New global
	variables.
	(safe_vector_operand): Update sse_clrv4sf call.
	(ix86_expand_buildin): Likewise
	* i386.h (x86_sse_partial_reg_dependency, x86_sse_partial_regs,
	x86_sse_typeless_stores, x86_sse_load0_by_pxor): Declare.
	(TARGET_SSE_PARTIAL_REG_DEPENDENCY, TARGET_SSE_PARTIAL_REGS,
	TARGET_SSE_TYPELESS_STORES, TARGET_SSE_TYPELESS_LOAD0): New
	macros.
	* i386.md (movsf*, movdf*, movti, movv4sf, movv2df, movv16qi, movv8hi,
	movv4si):  Obey the new flags.
	(floatsi2sf, floatdi2sf, truncatedf2sf): Emit extra load of 0 to avoid
	reformating penalty.
	(anddf, cmov patterns): Avoid reformating by first converting.
	(sse_cvtsd2ss): Fix predicate.
	(sse2_clrti): Fix mode,
	(sse_clrv4sf): Avoid unspec.

2002-10-08  Jakub Jelinek  <jakub@redhat.com>

	* config/sparc/t-linux64 (MULTILIB_OPTIONS): Remove
	mno-app-regs|mcmodel=medany.
	(MULTILIB_DIRNAMES, MULTILIB_OSDIRNAMES): Remove alt.
	(MULTILIB_EXCEPTIONS, MULTILIB_EXCLUSIONS, MULTILIB_MATCHES): Remove.
	(CRTSTUFF_T_CFLAGS): Define.

2002-10-08  Roger Sayle  <roger@eyesopen.com>

	PR target/8087
	* simplify-rtx.c (avoid_constant_pool_reference):  Allow constant
	pool references that are constructed using LO_SUM.

2002-10-08  Nathan Sidwell  <nathan@codesourcery.com>

	* c-opts.c (c_common_decode_option): Add warn_strict_aliasing to
	-Wall.
	* c-typeck.c (build_c_cast): Use warn_strict_aliasing, tweak
	message.
	* flags.h (warn_strict_aliasing): Declare.
	* toplev.c (warn_strict_aliasing): Define.
	(lang_independent_options): Add it.
	* doc/invoke.texi (-Wstrict-aliasing): Document it.

2002-10-08  Zack Weinberg  <zack@codesourcery.com>

	* system.h (GCCBUGURL): Delete.
	* version.c (bug_report_url): New.  Add commentary about
	modifying both these strings in modified distributions.
	* version.h: Declare bug_report_url.

	* diagnostic.c, gcc.c, gcov.c: Globally replace GCCBUGURL with
	bug_report_url.

2002-10-08  Nick Clifton  <nickc@redhat.com>

	* config/rs6000/spe.h (__ev_set_acc_u64): Use __ev_create_u64 to
	convert uint64_t into __ev64_opaque__.
	(__ev_set_acc_s64): Likewise, but using signed types.

2002-10-08  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.md ("*doloop_si_long"): Add missing operand.
	("*doloop_di_long"): Likewise.

Tue Oct  8 16:50:10 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* print-rtl.c (print_rtx): Increase buffer size for real numbers.

2002-10-08  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.md (define_attr cpu): Add r4111.

2002-10-08  Anthony Green  <green@redhat.com>

	* bitmap.c (bitmap_equal_p): Clear all bitmap_head fields.

2002-10-08  Michael Hayes  <m.hayes@elec.canterbury.ac.nz>

	* config/c4x/c4x.c (c4x_print_operand): Enlarge buffer
	for REAL_VALUE_TO_DECIMAL output.

2002-10-07  Richard Henderson  <rth@redhat.com>

	* cse.c (fixed_base_plus_p): Turn FIXED_BASE_PLUS_P into a
	function; cleanup PLUS case by using recursion.  Update all users.
	(NONZERO_BASE_PLUS_P): Remove.
	(find_comparison_args): Use rtx_addr_can_trap_p instead.
	(fold_rtx): Use nonzero_address_p.
	* rtl.h (nonzero_address_p): Declare.
	* rtlanal.c (rtx_varies_p): Handle ADDRESSOF.
	(rtx_addr_can_trap_p): Likewise.
	(nonzero_address_p): New.
	* simplify-rtx.c (NONZERO_BASE_PLUS_P): Remove.
	(simplify_relational_operation): Use nonzero_address_p.

2002-10-07  David Edelsohn  <edelsohn@gnu.org>

	* config/rs6000/rs6000.c (rs6000_override_options): Set
	real_format_for_mode for IBM extended format, if enabled.
	(easy_fp_constant): Add TFmode.
	(rs6000_legitimize_address): Add TFmode.
	(rs6000_legitimate_address): Same.
	(function_arg_advance): TFmode uses two FPRs.
	(rs6000_emit_prologue): Fix warning.
	(rs6000_output_function_epilogue): Add TFmode.
	(output_toc): Add TFmode.
	* rs6000.h (SLOW_UNALIGNED_ACCESS): Add TFmode.
	(LEGITIMATE_OFFSET_ADDRESS_P): Add TFmode.
	* rs6000.md (movtf splitter): Load TFmode constant.

2002-10-07  Dale Johannesen  <dalej@apple.com>

	* rtl.h:  Add NOTE_PRECONDITIONED.
	* unroll.c:  Set it.
	* loop.c:  Set loop_info->preconditioned from it.
	* doloop.c:  Permit doloop treatment when loop_info->preconditoned.

2002-10-07  Richard Henderson  <rth@redhat.com>

	* config/i960/i960.c (i960_setup_incoming_varargs): Create a
	new rtx for comparing the argument pointer against zero.
	(i960_va_start): Similarly.

2002-10-07  Richard Henderson  <rth@redhat.com>

	* config/i960/i960.md (*): Use TFmode, not XFmode.
	* config/i960/i960.c (*): Likewise.
	(i960_arg_size_and_align): Remove XFmode alignment hack.
	(i960_round_align): Merge code from ROUND_TYPE_ALIGN.
	* config/i960/i960.h (LONG_DOUBLE_TYPE_SIZE): Use 128, not 96.
	(MAX_LONG_DOUBLE_TYPE_SIZE): Likewise.
	(DATA_ALIGNMENT, ROUND_TYPE_SIZE): Remove.

2002-10-07  Richard Henderson  <rth@redhat.com>

	* config/fp-bit.c (EXTENDED_FLOAT_STUBS): Flush out all XF/TFmode
	entry points; use void return value and argument list.

2002-10-06  Andreas Bauer  <baueran@in.tum.de>

	* calls.c (expand_call): Fix function-is-volatile check.

2002-10-05  Naohiko Shimizu <nshimizu@keyaki.cc.u-tokai.ac.jp>

	* t-pdp11: Add MULTILIB support for msoft-float.
	* pdp11.h (LEGITIMATE_CONSTANT_P): Fix soft-float case.

	* t-pdp11: Add LIB2FUNCS_EXTRA.
	* pdp11.c (pdp11_output_function_prologue): Restrict offset to 16bit,
	add preceding 0 to the octal constant, rename 'fp' to 'r5', rename
	'fldd' to 'ldd', rename 'fstd' to 'std'.
	(pdp11_output_function_epilogue): Likewise.
	(output_move_quad): Make the comment gas compatible.
	(output_ascii): Add preceding 0 to the octal constant.
	(print_operand_address): Add pre_modify, post_modify.
	(output_addr_const_pdp11): Add preceding 0 to the octal constant.
	* pdp11.h (GO_IF_LEGITIMATE_ADDRESS) : Add 'movb' pre_modify case
	with the indication of Paul Koning.
	(PRINT_OPERAND): Fix floating constant.
	* pdp11.md (movdi): Restrict matching pattern.
	(movqi): Generalize the matching pattern.
	(movdf): Restrict matching pattern.
	(zero_extendqihi2): Change constant representation.
	(floatsidf2): Fix wrong operands.
	(addqi3): Fix wrong instruction name.
	(subqi3): Fix wrong instruction name.
	(andsi3, andhi3, andqi3): Simplify and fix to use 'bic'.
	(xorsi3): Fix wrong insn.
	(one_cmplqi2): Add two operand pattern.
	(lsrsi3): New.
	(negsi2): New.
	(call): Add register indirect case.
	(mod): Fix wrong subreg.

2002-10-06  Eric Botcazou  <ebotcazou@libertysurf.fr>
	    Volker Reichelt <reichelt@igpm.rwth-aachen.de>

	PR c/7411
	* expr.c (expand_expr) [PLUS]: Simplify after the operands
	have been expanded in EXPAND_NORMAL mode.

2002-10-06  Richard Henderson  <rth@redhat.com>

	* config/rs6000/rs6000.md (load_toc_v4_PIC_2): Fix base constraint.

2002-10-06  Richard Henderson  <rth@redhat.com>

	PR optimization/2960
	* toplev.c (rest_of_compilation): Don't copy_loop_headers if
	optimize_size.

2002-10-06  Alexandre Oliva  <aoliva@redhat.com>

	* config/mips/mips.h (SIZE_TYPE, PTRDIFF_TYPE): Override
	previously definitions.

2002-10-06  Frank Ch. Eigler  <fche@redhat.com>

	* cppinit.c (init_standard_includes, parse_option): Use strncmp.
	* c-opts.c (find_opt): Similarly.

Sat Oct  5 22:48:06 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* athlon.md: rewrite to DFA.
	* i386 (ix86_adjust_cost): Drop memory latency code.
	(ia32_use_dfa_pipeline_interface): Return true for Athlon.

2002-10-05  Jakub Jelinek  <jakub@redhat.com>

	* gcc.c (set_multilib_dir): Don't access *end.
	Use memcpy instead of strncpy.  Don't write beyond malloced buffer.
	(print_multilib_info): Don't show paths starting with ".:".
	* genmultilib: Add new option, "yes" if multilibs are enabled.
	Update comments.  If multilibs not enabled, print .:${osdirout}
	for each directory.  If multilibs are enabled, always print
	${dirout}:${osdirout}, even if the two are the same.
	* Makefile.in (s-mlib): Pass @enable_multilib@ to genmultilib.
	Pass all MULTILIB_* variables to genmultilib even if
	--disable-multilib but MULTILIB_OSDIRNAMES is not empty.

2002-10-04  Zack Weinberg  <zack@codesourcery.com>

	* gcc.c (process_command): Set .validated for -pipe.  Correct
	grammar in comment.

2002-10-04  Bruce Korb  <bkorb@gnu.org>

	* fixinc/inclhack.def(hpux11_abs):  use format fix
	* fixinc/fixincl.x: regenerate
	* fixinc/tests/base/stdlib.h: accommodate new fix test

Sat Oct  5 19:42:45 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* c-common.c (cb_register_builtins):  Use really_no_inline.

2002-10-04  David Edelsohn  <edelsohn@gnu.org>

	* unroll.c (copy_loop_body): Remove REG_EQUAL note attached to
	copied instruction if the note is not loop invariant.

2002-10-04  Loren J. Rittle  <ljrittle@acm.org>

	* gcc/ginclude/stddef.h: Support the FreeBSD 5 typedef system.

2002-10-04  Steve Ellcey  <sje@cup.hp.com>

	* doc/invoke.texi (HPPA):  Add -mlinker-opt, -mgnu-ld,
	and -mhp-ld options to list of options.  Add -mgnu-ld
	and -mhp-ld option descriptions.

2002-10-04  Steve Ellcey  <sje@cup.hp.com>

	* fixinc/inclhack.def (hpux11_abs):  New.
	(stdio_va_list): change __va_list__ to __gnuc_va_list.
	* fixinc/fixincl.x: Rebuild.

2002-10-04  Roger Sayle  <roger@eyesopen.com>

	* config/i386/i386.h (processor_costs): Add new fields fadd,
	fmul, fdiv, fabs, fchs and fsqrt to costs structure.
	(RTX_COSTS): Use these fields to determine the RTX costs
	of floating point addition/subtraction, multiplication,
	division, fabs, negation and square root respectively.
	* config/i386/i386.c (size_cost): Provide instruction sizes
	for these new fields.
	(i386_cost, i486_cost, pentium_cost, pentiumpro_cost,
	k6_cost, athlon_cost, pentium4_cost): Provide typical cycle
	counts for these new fields for all x86 processor variants.

2002-10-04  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* mips.c (mips_const_double_ok): Delete unused variable.

	* gengtype.c (rtx_next): Change type to int.

2002-10-04  Andreas Jaeger  <aj@suse.de>

	* config/i386/t-linux64 (MULTILIB_OSDIRNAMES): Fix value.

2002-10-04  Richard Henderson  <rth@redhat.com>

	* real.h (SIGNIFICAND_BITS): Add one more word.
	(CONST_DOUBLE_FORMAT): Accomodate 6 words.
	* real.c (times_pten): New.
	(real_to_decimal, real_from_string): Use it.
	(sticky_rshift_significand): Use & to find modulus.
	(rshift_significand, lshift_significand): Likewise.
	(do_divide): Apply sticky bit after normalization.
	(real_to_decimal, real_to_hexadecimal): Fix sign of Inf and NaN.

2002-10-03  Andreas Bauer  <baueran@in.tum.de>

	* doc/tm.texi (FUNCTION_OK_FOR_SIBCALL): Remove.
	(TARGET_FUNCTION_OK_FOR_SIBCALL): New.

2002-10-03  Andreas Jaeger  <aj@suse.de>

	* gengtype.c (adjust_field_rtx_def): Cast variables of type size_t
	to unsigned long, adjust printf format string.
	(output_mangled_typename): Likewise.

2002-10-03  Jason Thorpe  <thorpej@wasabisystems.com>

	* config/vax/vax.c (vax_output_function_prologue): Use asm_fprintf.
	* config/vax/vax.h (VAX_FUNCTION_PROFILER_NAME): New.
	(FUNCTION_PROFILER): Rewrite to use ASM_GENERATE_INTERNAL_LABEL,
	assemble_name, asm_fprintf, and VAX_FUNCTION_PROFILER_NAME.
	(ASM_OUTPUT_MI_THUNK): Use asm_fprintf instead of REGISTER_PREFIX.
	(PRINT_OPERAND_PUNCT_VALID_P): Fix comment.
	* config/vax/elf.h (FUNCTION_PROFILER): Remove.
	(VAX_FUNCTION_PROFILER_NAME): Redefine as "__mcount".

2002-10-03  Mark Mitchell  <mark@codesourcery.com>

	* doc/invoke.texi (-Wabi): Document mangling bug.

2002-10-04  Alan Modra  <amodra@bigpond.net.au>

	* config/rs6000/rs6000.c (rs6000_output_function_epilogue): Use a
	name for the tbtab label that depends on the function asm name.
	Don't output tbtab label unless optional_tbtab.
	(output_mi_thunk): Formatting.

2002-10-03  Richard Henderson  <rth@redhat.com>

	* config/m68k/m68k.h (OVERRIDE_OPTIONS): Move additional code ...
	* config/m68k/m68k.c (override_options): ... here.
	* config/m68k/m68kelf.h (OVERRIDE_OPTIONS): Remove.
	* config/m68k/m68kv4.h (OVERRIDE_OPTIONS): Remove.
	* config/m68k/linux.h (SUBTARGET_OVERRIDE_OPTIONS): Remove.
	* config/m68k/netbsd-elf.h (SUBTARGET_OVERRIDE_OPTIONS): Remove.

2002-10-03  Richard Henderson  <rth@redhat.com>

	* real.h (struct real_value): Use ENUM_BITFIELD.

2002-10-03  Richard Henderson  <rth@redhat.com>

	* config/i960/i960.md (call, call_value): Use emit_call_insn.

2002-10-03  Steve Ellcey  <sje@cup.hp.com>

	* config/pa/pa64-hpux.h (INIT_ENVIRONMENT): New.

2002-10-03  Steve Ellcey  <sje@cup.hp.com>

	* config.gcc (hppa*64*-*-hpux11*): Check gnu_ld.
	* config/pa/pa.h (MASK_GNU_LD): New.
	(TARGET_GNU_LD): New.
	* config/pa/pa64-hpux.h (LINK_SPEC): Set based
	on gnu-ld and MASK_GNU_LD.
	(SUBTARGET_SWITCHES): New gnu-ld & hp-ld flags.

Thu Oct  3 23:35:51 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (athlon_cost): Fix the move costs.

Thu Oct  3 23:20:58 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* final.c (final): Use symbol name as function name for profiling.
	* profile.c (get_exec_counts): Likewise.
	(branch_prob): Likewise.

2002-10-03  Jakub Jelinek  <jakub@redhat.com>

	* longlong.h (__udiv_qrnnd): Remove PARAMS from prototype.

2002-10-03  Jakub Jelinek  <jakub@redhat.com>

	* gcc.c (print_multi_os_directory): New variable.
	(option_map): Support --print-multi-os-directory.
	(struct prefix_list): Add os_multilib field.
	(multilib_os_dir): New variable.
	(static_specs): Add multilib_options.
	(find_a_file): Add multilib argument.  Search in GCC or OS multilib
	subdirs if nonzero.
	(read_specs, execute): Update callers.
	(find_file): Likewise.  Don't prefix name with multilib_dir, instead
	pass 1 as multilib option.
	(display_help): Include --print-multi-os-directory.
	(add_prefix): Add os_multilib argument.  Initialize pl->os_multilib.
	(process_command): Update callers.  Handle --print-multi-os-directory.
	(do_spec_1) ['D']: Use multilib_os_directory if pl->os_multilib is
	set.
	(main): Update find_a_file and add_prefix callers.
	Handle print_multi_os_directory.
	(struct mdswitchstr): New.
	(mdswitches, n_mdswitches): New variables.
	(used_arg): Add MULTILIB_DEFAULT switches too if they are not
	present on the command line nor their mutually incompatible
	switches.
	(default_arg): Optimize.
	(set_multilib_dir): Compute multilib_os_dir.  Initialize mdswitches
	array.
	(print_multilib_info): Only print GCC multilib dir name, not OS
	multilib dirname.
	* genmultilib: Add osdirnames parameter.  Output multilib_options
	variable.  If osdirnames is specified, output dirnames as
	dirname:osdirname.
	* mklibgcc.in: Use MULTILIB_OSDIRNAMES, --print-multi-directory
	and --print-multi-os-directory instead of SHLIB_SLIBDIR_SUFFIXES
	to compute libgcc_s soname and install path.
	* Makefile.in (libgcc.mk): Pass MULTILIB_OSDIRNAMES instead of
	SHLIB_SLIBDIR_SUFFIXES to mklibgcc.
	(s_mlib): Pass MULTILIB_OSDIRNAMES or nothing as last genmultilib
	argument.

	* config/sparc/t-linux64 (MULTILIB_OSDIRNAMES): Set.
	(SHLIB_SLIBDIR_SUFFIXES): Remove.
	* config/sparc/linux64.h (STARTFILE_SPEC32, STARTFILE_SPEC64,
	ENDFILE_SPEC32, ENDFILE_SPEC64, ENDFILE_COMMON): Remove.
	(STARTFILE_SPEC, ENDFILE_SPEC): Don't distinguish between -m32
	and -m64.
	* config/sparc/t-sol2-64 (MULTILIB_OSDIRNAMES): Set.
	(SHLIB_SLIBDIR_SUFFIXES): Remove.
	* config/sparc/sol2-bi.h (STARTFILE_ARCH64_SPEC): Remove.
	(STARTFILE_ARCH_SPEC): Remove.
	* config/i386/t-linux64 (MULTILIB_OSDIRNAMES): Set.
	(SHLIB_SLIBDIR_SUFFIXES): Remove.
	* config/i386/linux64.h (STARTFILE_PREFIX_SPEC): Remove.
	* config/mips/t-iris6 (MULTILIB_OSDIRNAMES): Set.
	(SHLIB_SLIBDIR_SUFFIXES): Remove.

Thu Oct  3 21:42:20 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* predict.c (choose_function_section): Avoid choice for linkonce functions.

Thu Oct  3 15:15:00 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* i386.md (lea to mul peep2): Fix condition.

2002-10-02  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* pa-linux.h (FUNCTION_OK_FOR_SIBCALL): Delete macro.
	* pa32-linux.h (FUNCTION_OK_FOR_SIBCALL): Define.

2002-10-02  David Mosberger-Tang  <David.Mosberger@acm.org>

	* unwind.h (_Unwind_GetTextRelBase): Mark _C argument with
	attribute "unused".

	* config/t-libunwind: Mention unwind-sjlj.c.
	* unwind-libunwind.c: Change #ifdef __USING_LIBUNWIND_EXCEPTIONS__
	to #ifndef __USING_SJLJ_EXCEPTIONS__.

	* configure.in: Move sjlj-exceptions and --enable-libunwind-exceptions
	before inclusion of config.gcc, but after configuring the compiler etc.
	Determine default value for --enable-libunwind-exceptions based on
	whether the host has a libunwind library (not guaranteed to be correct,
	but it's a reasonable first guess and can always be overridden with an
	explicit --enable/disable-libunwind-exceptions.
	* config.gcc: For target ia64*-*-linux*, mention t-libunwind as a
	tmake_file when $use_libunwind_exceptions is enabled.
	* Makefile.in: Update comment: LIB2ADDEH is updated not just by
	ia64 (e.g., config/t-linux also updates it).
	* gcc.c (init_spec) [USE_LIBUNWIND_EXCEPTIONS]: Mention -lunwind
	along with the shared version of libgcc since the latter requires
	the former.
	* unwind-libunwind.c: New file.
	* config/t-libunwind: Ditto.

2002-10-02  Nathanael Nerode  <neroden@gcc.gnu.org>

	* config.gcc: Remove support for vax-*-vms*.
	* config/vax/vms.h: Remove.
	* config/vax/xm-vms.h: Remove.
	* config/vax/vax-protos.h: Remove VMS-specific code.
	* config/vax/vax.c: Remove VMS-specific code.

2002-10-02  Richard Henderson  <rth@redhat.com>

	PR opt/7124
	* config/i386/i386.c (ix86_register_move_cost): Increase cost
	for secondary_memory_needed pairs.

2002-10-02  Nathanael Nerode  <neroden@gcc.gnu.org>

	* doc/vms.texi: Blow away false include file section.

2002-10-02  Roger Sayle  <roger@eyesopen.com>

	PR optimization/6627
	* toplev.c (force_align_functions_log): New global variable.
	* flags.h (force_align_functions_log): Add extern prototype.
	* varasm.c (assemble_start_function): Use it to force minimum
	function alignment.
	* config/i386/i386.h (FUNCTION_BOUNDARY): Set the correct
	minimum function alignment to one byte.
	(TARGET_PTRMEMFUNC_VBIT_LOCATION): Store the virtual bit in
	the least significant bit of vtable member function pointers.
	* tree.h (enum ptrmemfunc_vbit_where_t): Move definition to
	here from cp/cp-tree.h.

Wed Oct  2 17:01:36 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (print_operand_address): Use RIP addressing for offsetted
	label refs too.

2002-09-30  David S. Miller  <davem@redhat.com>

	PR middle-end/7151
	* config/sparc/sparc.md (movdi_insn_sp32_v9): Accept 'e' regs.
	(movdi reg/reg split): Match only on sparc32, and v9 when int regs.

2002-10-01  Andreas Bauer  <baueran@in.tum.de>

	* calls.c (expand_call): Remove the `no indirect check'
	for sibcall optimization; use function_ok_for_sibcall
	target hook; refine check for `function is volatile'.
	(FUNCTION_OK_FOR_SIBCALL): Remove the redefinition.
	* hooks.c (hook_tree_tree_bool_false): New.
	* hooks.h (hook_tree_tree_bool_false): Declare.
	* target-def.h (TARGET_FUNCTION_OK_FOR_SIBCALL): New.
	(TARGET_INITIALIZER): Add it.
	* target.h (struct gcc_target): Add function_ok_for_sibcall.
	* config/alpha/alpha.c: (alpha_function_ok_for_sibcall): New.
	(TARGET_FUNCTION_OK_FOR_SIBCALL): Redefine accordingly.
	* config/alpha/alpha.h: (FUNCTION_OK_FOR_SIBCALL): Remove.
	* config/arm/arm-protos.h: (arm_function_ok_for_sibcall):
	Remove function declaration.
	* config/arm/arm.c: (arm_function_ok_for_sibcall): Make
	function static and accept another argument of type `tree'.
	(TARGET_FUNCTION_OK_FOR_SIBCALL): Redefine accordingly.
	* config/arm/arm.h: (FUNCTION_OK_FOR_SIBCALL): Remove.
	* config/frv/frv.h: (FUNCTION_OK_FOR_SIBCALL): Remove.
	* config/i386/i386.c: (ix86_function_ok_for_sibcall): New.
	(TARGET_FUNCTION_OK_FOR_SIBCALL): Redefine accordingly.
	* config/i386/i386.h: (FUNCTION_OK_FOR_SIBCALL): Remove.
	* config/pa/pa-linux.h: (FUNCTION_OK_FOR_SIBCALL): Remove.
	(TARGET_HAS_STUBS_AND_ELF_SECTIONS): New definition.
	* config/pa/pa.c: (pa_function_ok_for_sibcall): New.
	(TARGET_FUNCTION_OK_FOR_SIBCALL): Redefine accordingly.
	* config/pa/pa.h: (FUNCTION_OK_FOR_SIBCALL): Remove.
	* config/rs6000/rs6000-protos.h: (function_ok_for_sibcall):
	Remove function declaration.
	* config/rs6000/rs6000.c: (rs6000_function_ok_for_sibcall):
	Rename function_ok_for_sibcall to rs6000_function_ok_for_sibcall;
	rename first argument to `decl'; accept another argument
	of type `tree'; make static.
	(TARGET_FUNCTION_OK_FOR_SIBCALL): Redefine accordingly.
	* config/rs6000/rs6000.h: (FUNCTION_OK_FOR_SIBCALL): Remove.
	* config/sh/sh.c: (sh_function_ok_for_sibcall): New.
	(TARGET_FUNCTION_OK_FOR_SIBCALL): Redefine accordingly.
	* config/sh/sh.h: (FUNCTION_OK_FOR_SIBCALL): Remove.
	* config/sparc/sparc.c: (sparc_function_ok_for_sibcall): New.
	(TARGET_FUNCTION_OK_FOR_SIBCALL): Redefine accordingly.
	* config/sparc/sparc.h: (FUNCTION_OK_FOR_SIBCALL): Remove.
	* config/xtensa/xtensa.h: (FUNCTION_OK_FOR_SIBCALL): Remove.

2002-10-01  Roger Sayle  <roger@eyesopen.com>

	* unroll.c (loop_iterations): Revert 2002-09-08 change.

2002-10-01  Richard Henderson  <rth@redhat.com>

	* real.c (real_to_decimal): Crop trailing zeros for DIGITS < 0.
	(real_to_hexadecimal): Likewise.
	* print-rtl.c (print_rtx): If we are linked with real.c, don't
	dump the XWINT fields of a floating point CONST_DOUBLE.

2002-10-01  Jason Thorpe  <thorpej@wasabisystems.com>

	* config/vax/elf.h (FUNCTION_PROFILER): Fix __mcount call.

2002-10-01  Richard Henderson  <rth@redhat.com>

	* calls.c (precompute_register_parameters): Force non-legitimate
	constants into pseudos.

2002-10-01  Nick Clifton  <nickc@redhat.com>

	* config/rs6000/spe.md (spe_evrlwi): Add missing third operand
	to assembler template.

2002-10-01  Richard Henderson  <rth@redhat.com>

	* dwarf2out.c (loc_descriptor_from_tree): Relax requirement
	for TLS debug info to !DECL_EXTERNAL.

2002-10-01  Matt Thomas  <matt@3am-software.com>
	    Jason Thorpe  <thorpej@wasabisystems.com>

	* config.gcc (vax-*-netbsdelf*): Enable configuration.
	* config/elfos.h (PCC_BITFIELD_TYPE_MATTERS): Define only
	if not already defined.
	* config/vax/elf.h: New file.
	* config/vax/netbsd-elf.h: New file.
	* config/vax/vax.c: Include "debug.h".
	(vax_output_function_prologue): Add dwarf2 support.  Use
	MAIN_NAME_P when checking for VMS_TARGET stack adjust.
	* config/vax/vax.h (CONST_OK_FOR_LETTER_P): Add cases for
	'J' [0..63], 'K' [-128..127], 'L' [-32768..32767],
	'M' [0..255], 'N' [0..65535], and, 'O' [-63..-1].
	(VAX_ISTREAM_SYNC): Remove.
	(INITIALIZE_TRAMPOLINE): Use gen_sync_istream.
	(JUMP_TABLES_IN_TEXT_SECTION): Define.
	(ASM_OUTPUT_REG_POP): Use reg_names for the stack pointer.
	(ASM_OUTPUT_ADDR_VEC_ELT): Use ASM_GENERATE_INTERNAL_LABEL
	and assemble_name.
	(ASM_OUTPUT_ADDR_DIFF_ELT): Likewise.
	(PRINT_OPERAND_PUNCT_VALID_P): Accept '|'.
	(PRINT_OPERAND): Output REGISTER_PREFIX for '|'.
	(INCOMING_RETURN_ADDR_RTX): Define.
	* config/vax/vax.md (VUNSPEC_BLOCKAGE)
	(VUNSPEC_SYNC_ISTREAM): Define.
	(blockage): Use VUNSPEC_BLOCKAGE.
	(sync_istream): New insn.

2002-10-01  Richard Henderson  <rth@redhat.com>

	* config/vax/vax.md (call_pop, *call_pop, call_value_pop)
	(*call_value_pop, call, call_value): Add dwarf2 EH support.
	(*call): New insn.

2002-10-01  Nathan Sidwell  <nathan@codesourcery.com>

	PR c/8083
	* c-typeck.c (build_c_cast): Warn about type punning which breaks
	type based aliasing.

2002-10-01  Mark Mitchell  <mark@codesourcery.com>

	* stor-layout.c (update_alignment_for_field): New function.
	(place_union_field): Use it.
	(place_field): Likewise.

2002-10-01  Nathan Sidwell  <nathan@codesourcery.com>

	PR other/8077
	* gcc.c (cc1_options): Add space on -auxbase-strip.

2002-10-01  Jim Wilson  <wilson@redhat.com>

	* config/v850/v850.h (EPILOGUE_USES): Define.

2002-09-30  Andrew Haley  <aph@redhat.com>

	* flow.c (insn_dead_p): When using non-call-exceptions, don't
	eliminate insns that may trap.
	* cse.c (insn_live_p): Likewise.

2002-10-01  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.h (PROCESSOR_R4121): Rename to PROCESSOR_R4120.
	(TARGET_MIPS4121): Rename to TARGET_MIPS4120.
	* config/mips/mips.c (mips_cpu_info): Rename vr4121 to vr4120.
	* config/mips/mips.md: Apply same renaming here.

2002-10-01  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.c (PROCESSOR_R4320, TARGET_MIPS4320): Remove.
	(GENERATE_MULT3_SI): Remove use of TARGET_MIPS4320.
	* config/mips/mips.c (mips_cpu_info): Remove vr4320 entry.
	* config/mips/mips.md (define_attr cpu): Remove r4320.
	Remove vr4320 scheduler and uses of TARGET_MIPS4320.

2002-10-01  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.c (mips16_strings): New variable.
	(mips_output_function_epilogue): Clear the SYMBOL_REF_FLAG of every
	symbol in mips16_strings.  Free the list.
	(mips_encode_section_info): Keep track of local strings.

2002-10-01  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.md (bunge, bltgt, bungt): New define_expands.
	(sordered_df, sordered_sf): Remove.
	* config/mips/mips.c (get_float_compare_codes): New fn.
	(gen_int_relational, gen_conditional_move): Use it.

2002-10-01  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips-protos.h (mips_emit_fcc_reload): Declare.
	* config/mips/mips.h (PREDICATE_CODES): Add fcc_register_operand.
	* config/mips/mips.c (fcc_register_operand): New function.
	(mips_emit_fcc_reload): New function, extracted from reload_incc.
	(override_options): Allow TFmode values in float registers
	if ISA_HAS_8CC.
	* cnfig/mips/mips.md (reload_incc): Change destination prediate
	to fcc_register_operand.  Remove misleading source constraint.
	Use mips_emit_fcc_reload.
	(reload_outcc): Duplicate reload_incc.

2002-09-30  Zack Weinberg  <zack@codesourcery.com>

	* gcc.c (validate_switches): Handle all new forms of spec
	syntax introduced recently.  Now returns a char *.
	(validate_all_switches): Repetitive logic broken out to...
	(validate_switches_from_spec): ...here.
	* mklibgcc.in: Don't @-flag commands to generate .oS files.

2002-09-30  Ulrich Weigand  <uweigand@de.ibm.com>

	* longlong.h: Partially synchronize with GMP-4.1 version:
	Use i370 definitions also for s390.
	Add generic definition of umul_ppmm in terms of smul_ppmm.
	[s390] (umul_ppmm): Remove.
	[s390] (smul_ppmm): Fix incorrect assembler constraints.
	[s390] (smul_ppmm, sdiv_qrnnd): Rename __xx to __x.

2002-09-30  Bob Wilson  <bob.wilson@acm.org>

	* config/xtensa/xtensa.h (REG_CLASS_NAMES, REG_CLASS_CONTENTS):
	Add new RL_REGS register class.
	(PREFERRED_RELOAD_CLASS, PREFERRED_OUTPUT_RELOAD_CLASS):
	Call xtensa_preferred_reload_class for both input and output reloads.
	* config/xtensa/xtensa.c (xtensa_regno_to_class): Use new RL_REGS class.
	(xtensa_preferred_reload_class): Handle output reloads; use RL_REGS
	instead of either AR_REGS or GR_REGS classes.
	(xtensa_secondary_reload_class): Use new RL_REGS class.
	* config/xtensa/xtensa-protos.h (xtensa_preferred_reload_class): Update.

2002-09-30  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* pa.c (hppa_encode_label): Don't drop '*' from function labels.
	(pa_strip_name_encoding): Strip '@' and '*', in that order.
	* pa.h (ASM_OUTPUT_LABELREF): Output user_label_prefix except when
	there is a '*' prefix in NAME.

Mon Sep 30 21:33:23 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* reload.c (push_reload): Handle subregs and secondary memory.
	* reload1.c (gen_reload): Likewise.

	* jump.c (reg_or_subregno): New function.
	* rtl.h (reg_or_subregno): Declare
	* unroll.c (find_splittable_givs): Handle subregs.

2002-09-30  Mark Mitchell  <mark@codesourcery.com>

	* store-layout.c (finish_record_layout): Add free_p parameter.
	(layout_type): Pass it.
	* tree.h (finish_record_layout): Update prototype.

Mon Sep 30 14:57:18 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* i386.h (TARGET_CPP_CPU_BUILTINS): Define __SSE_MATH__.

	* gcse.c (cprop_jump): Check that the register has not
	been modified
	(cprop_jump): Likewise.

2002-09-30  Richard Earnshaw  <rearnsha@arm.com>

	* arm.h (BASE_REG_CLASS): Always return LO_REGS for Thumb.
	(MODE_BASE_REG_CLASS, case Thumb): Only return BASE_REGS if we know
	that we have a SImode access, and only then if reload hasn't completed;
	for all other cases, use LO_REGS.

2002-09-29  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* openbsd.h: Fix typo in last change.

2002-09-29  Richard Henderson  <rth@redhat.com>

	* real.c (real_from_string): Apply sign last.  Tidy exponent handling.

2002-09-29  Richard Henderson  <rth@redhat.com>

	PR c/8002
	* combine.c (force_to_mode): Handle FLOAT_MODE destinations
	for CONST_INT.

2002-09-29  David Edelsohn  <edelsohn@gnu.org>

	* real.h (ibm_extended_format): Declare.
	* real.c (encode_ibm_extended, decode_ibm_extended): New
	functions.

2002-09-29  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* darwin-protos.h (darwin_asm_output_dwarf_delta): Prototype.

	* ia64.c (ia64_hpux_asm_file_end): Const-ify.

2002-09-29  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* expmed.c (extract_bit_field): Fix bit-field extraction from SUBREGs.

2002-09-29  Kazu Hirata  <kazu@cs.umass.edu>

	* builtins.def: Fix comment formatting.
	* c-common.def: Likewise.
	* cfgcleanup.c: Likewise.
	* combine.c: Likewise.
	* gengtype.c: Likewise.
	* params.def: Likewise.
	* predict.def: Likewise.
	* rtl.def: Likewise.
	* stab.def: Likewise.
	* stor-layout.c: Likewise.
	* tree.def: Likewise.
	* config/darwin.c: Likewise.
	* config/darwin.h: Likewise.
	* config/dbxcoff.h: Likewise.
	* config/elfos.h: Likewise.
	* config/fp-bit.c: Likewise.
	* config/freebsd-spec.h: Likewise.
	* config/interix.h: Likewise.
	* config/libgloss.h: Likewise.
	* config/linux-aout.h: Likewise.
	* config/linux.h: Likewise.
	* config/lynx-ng.h: Likewise.
	* config/lynx.h: Likewise.
	* config/netbsd-aout.h: Likewise.
	* config/netbsd.h: Likewise.
	* config/netware.h: Likewise.
	* config/psos.h: Likewise.
	* config/ptx4.h: Likewise.

2002-09-28  Kazu Hirata  <kazu@cs.umass.edu>

	* ChangeLog.4: Fix typos.
	* ChangeLog.6: Likewise.
	* FSFChangeLog.10: Likewise.
	* genattrtab.c: Fix comment typos.
	* haifa-sched.c: Likewise.
	* real.c: Likewise.
	* tree.h: Likewise.
	* config/arm/arm.c: Likewise.
	* config/arm/crti.asm: Likewise.
	* config/arm/crtn.asm: Likewise.
	* config/frv/frv.c: Likewise.
	* config/frv/frv.md: Likewise.
	* config/h8300/h8300.md: Likewise.
	* config/i386/rtemself.h: Likewise.
	* config/ia64/unwind-ia64.c: Likewise.
	* config/ip2k/ip2k.h: Likewise.
	* config/m88k/m88k.c: Likewise.
	* config/m88k/m88k.md: Likewise.
	* config/mips/sr71k.md: Likewise.
	* config/mmix/mmix.c: Likewise.
	* config/rs6000/rs6000.c: Likewise.
	* config/sh/sh.md: Likewise.

2002-09-26  Theodore A. Roth  <troth@verinet.com>

	* config/avr/avr.c: Eliminate use of _PC_ in pc relative insns.
	* config/avr/avr.md: Ditto.

2002-09-27  Alexander N. Kabaev <ak03@gte.com>

	PR preprocessor/8055
	* cppmacro.c (stringify_arg): Do not overflow the buffer
	with the terminating NUL when the argument to be stringified
	has no tokens.

2002-09-27  Richard Henderson  <rth@redhat.com>

	* unroll.c (simplify_cmp_and_jump_insns): New.
	(unroll_loop): Use it.  Use simplify_gen_foo+force_operand
	instead of expand_simple_foo.

2002-09-27  Richard Henderson  <rth@redhat.com>

	PR optimization/7520
	* cfganal.c (flow_active_insn_p): New.
	(forwarder_block_p): Use it.

2002-09-27  Richard Henderson  <rth@redhat.com>

	* emit-rtl.c (active_insn_p): Revert last change.

2002-09-27  Jakub Jelinek  <jakub@redhat.com>

	* doc/extend.texi (tls_model): Document.
	* varasm.c (decl_tls_model): New.
	* c-common.c (handle_tls_model_attribute): New.
	(c_common_attribute_table): Add tls_model.
	* config/alpha/alpha.c (alpha_encode_section_info): Use
	decl_tls_model.
	* flags.h (enum tls_model, flag_tls_default): Move...
	* tree.h (enum tls_model, flag_tls_default): ...here.
	(decl_tls_model): New prototype.
	* config/ia64/ia64.c (ia64_encode_section_info): Likewise.
	* config/i386/i386.c (ix86_encode_section_info): Likewise.
	* config/i386/i386.md (tls_global_dynamic, tls_local_dynamic_base):
	Allow !flag_pic.

2002-09-27  Kazu Hirata  <kazu@cs.umass.edu>

	* LANGUAGES: Follow spelling conventions.
	* rtl.def: Likewise.
	* sbitmap.c: Likewise.
	* sched-int.h: Likewise.
	* sched-rgn.c: Likewise.
	* sibcall.c: Likewise.
	* simplify-rtx.c: Likewise.
	* ssa.c: Likewise.
	* stab.def: Likewise.
	* stmt.c: Likewise.
	* stor-layout.c: Likewise.
	* target.h: Likewise.
	* timevar.c: Likewise.
	* toplev.c: Likewise.
	* tree-dump.c: Likewise.
	* tree-inline.c: Likewise.
	* tree.c: Likewise.
	* tree.def: Likewise.
	* tree.h: Likewise.
	* unroll.c: Likewise.
	* varasm.c: Likewise.
	* vmsdbgout.c: Likewise.
	* treelang/treelang.texi: Likewise.
	* treelang/treetree.c: Likewise.

2002-09-27  Kazu Hirata  <kazu@cs.umass.edu>

	* config/h8300/h8300.c (compute_saved_regs): Use a macro
	instead of a hard register number.
	(get_shift_alg): Use an enumerated type instead of numbers.
	(h8300_shift_needs_scratch_p): Likewise.

2002-09-26  Kazu Hirata  <kazu@cs.umass.edu>

	* varasm.c (force_data_section): Remove.
	(assemble_constant_align): Likewise.
	* output.h: Remove corresponding prototypes.

2002-09-26  Roger Sayle  <roger@eyesopen.com>

	* stmt.c (expand_exit_loop_if_false): Expand a simple conditional
	jump, if the loop to exit is the top of the current nesting stack.

2002-09-26  Torbjorn Granlund  <tege@swox.com>

	* libgcc2.c (fixunsdfdi, fixunssfdi): Rewrite, avoiding `long long'
	arithmetic.

2002-09-26  David S. Miller  <davem@redhat.com>

	PR optimization/7335
	* calls.c (emit_library_call_value_1): Passing args by reference
	converts a CONST function into a PURE one.

2002-09-26  David Edelsohn  <edelsohn@gnu.org>

	* dbxout.c (FORCE_TEXT): Switch to current_function_decl, not
	text_section.
	* xcoffout.h (DBX_STATIC_BLOCK_START): Remove explicit change to
	text section.
	* config/rs6000/rs6000.c (rs6000_override_options): Allow
	function-sections and data-sections functionality on AIX.

2002-09-26  David Edelsohn  <edelsohn@gnu.org>
	    Dale Johannesen  <dalej@apple.com>

	* config/rs6000/rs6000.c (rs6000_emit_move): Insert zero-extend
	in RTL for sub-word loads from memory.

2002-09-26  Richard Henderson  <rth@redhat.com>

	PR c/7160
	* sched-deps.c (sched_analyze_insn): Make clobber insns depend
	on call insns.

2002-09-26  Richard Henderson  <rth@redhat.com>

	* emit-rtl.c (const_double_htab_eq): Remove unused variable.

2002-09-26  Chris Lattner  <sabre@nondot.org>

	* ssa.c (rename_insn_1): Handle RENAME_NO_RTX correctly when
	handling undefined values.

2002-09-26  Richard Henderson  <rth@redhat.com>

	PR opt/7520
	* emit-rtl.c (active_insn_p): Consider a clobber of the
	function return value to be active even after reload.

2002-09-27  Alan Modra  <amodra@bigpond.net.au>

	* doloop.c (doloop_modify_runtime <biv skips initial incr>): Adjust
	by absolute loop increment, not loop increment.

2002-09-26  Kazu Hirata  <kazu@cs.umass.edu>

	* c-common.h: Follow spelling conventions.
	* cpplex.c: Likewise.
	* cpplib.h: Likewise.
	* gthr-dce.h: Likewise.
	* gthr-posix.h: Likewise.
	* optabs.c: Likewise.
	* output.h: Likewise.
	* profile.c: Likewise.
	* protoize.c: Likewise.
	* ra-rewrite.c: Likewise.
	* real.c: Likewise.
	* recog.c: Likewise.
	* reg-stack.c: Likewise.
	* regclass.c: Likewise.
	* regmove.c: Likewise.
	* reload.c: Likewise.
	* reload.h: Likewise.
	* reload1.c: Likewise.
	* reorg.c: Likewise.
	* resource.c: Likewise.
	* rtl.h: Likewise.
	* rtlanal.c: Likewise.

2002-09-26  Steve Ellcey  <sje@cup.hp.com>

	* config/ia64/ia64.c (ia64_expand_load_address): Ensure correct mode
	for symbol address.

2002-09-24  Eric Christopher  <echristo@redhat.com>

	* config/mips/elf.h: Add HANDLE_SYSV_PRAGMA.
	* config/mips/elf64.h: Ditto.

2002-09-24  Eric Christopher  <echristo@redhat.com>

	* except.c (expand_builtin_extract_return_address): Handle case
	where Pmode != ptr_mode.

2002-09-26  Steve Ellcey  <sje@cup.hp.com>

	* config/ia64/hpux.h (ASM_OUTPUT_EXTERNAL_LIBCALL): New

2002-09-26  Steve Ellcey  <sje@cup.hp.com>

	* config/ia64/hpux.h (TARGET_DEFAULT): Include TARGET_ILP32.

2002-09-26  Igor Shevlyakov <igor@microunity.com>

	* combine.c (simplify_set): Don't call to force_to_mode if size
	of integer type is larger than HOST_BITS_PER_WIDE_INT.

2002-09-26  Janis Johnson  <janis187@us.ibm.com>

	* Makefile.in (qmtest-g++): Fix file path.

2002-09-26  Ulrich Weigand  <uweigand@de.ibm.com>

	* expr.c (expand_expr) [MINUS_EXPR]: Convert A - const to
	A + (-const) on RTX level, even for unsigned types.

2002-09-26  Ulrich Weigand  <uweigand@de.ibm.com>

	* reload.c (dup_replacements): New function.
	(find_reloads): Use it to duplicate replacements at the top level
	of match_dup operands.

2002-09-26  Miles Bader  <miles@gnu.org>

	* v850.md ("length"): Change default value to 4.

2002-09-26  Kazu Hirata  <kazu@cs.umass.edu>

	* ChangeLog.1: Follow spelling conventions.
	* ChangeLog.4: Likewise.
	* ChangeLog.6: Likewise.
	* FSFChangeLog.11: Likewise.
	* doc/cpp.texi: Likewise.
	* doc/invoke.texi: Likewise.
	* doc/tm.texi: Likewise.

2002-09-26  Nick Clifton  <nickc@redhat.com>

	* config.gcc: Add x prefix to v850e case for handling
	--with-cpu=v850e.

2002-09-25  Zack Weinberg  <zack@codesourcery.com>

	* gcc.c (input_suffix_matches, switch_matches,
	mark_matching_switches, process_marked_switches,
	process_brace_body): New functions - split from handle_braces.
	(handle_braces): Rewrite; handle %{S:X;T:Y;:D} syntax; accept
	and ignore whitespace in more places.
	(specs documentation comment): Document %{S:X;T:Y;:D}.
	Clarify other %{...} docs.
	* doc/invoke.texi: Document %{S:X;T:Y;:D}.  Clarify other
	%{...} docs.

	* config/arm/aof.h (LINK_SPEC): Change %{ov*,*} to %{ov*}.
	* config/rs6000/sysv4.h: Use N-way choice spec syntax.

2002-09-25  David S. Miller  <davem@redhat.com>

	PR target/7842
	* config/sparc/sparc.c (set_extends): SImode ASHIFT does not
	extend.

2002-09-25  Richard Henderson  <rth@redhat.com>

	* emit-rtl.c (const_double_htab_eq): Distinguish integer and
	fp CONST_DOUBLE; use real_identical.

2002-09-25  Mark Mitchell  <mark@codesourcery.com>

	* doc/invoke.texi: Add more -Wabi examples.

2002-09-25  Richard Sandiford  <rsandifo@redhat.com>

	* config/mips/mips.h (TARGET_MIPS4100): Add missing bracket.

2002-09-24  Nathan Sidwell  <nathan@codesourcery.com>

	* profile.c (end_branch_prob): Only look for __gcov_init on
	weak-enabled native compilers.

2002-09-24  Denis Chertykov  <denisc@overta.ru>

	* config/ip2k/ip2k.c (function_epilogue): Fix wrong numbers in
	cases of optimizing "add sp,w" to "inc sp".

2002-09-24  Adam Nemet  <anemet@lnxw.com>

	* config/arm/arm.c (thumb_unexpanded_epilogue): Don't generate
	epilogue for naked functions.

2002-09-24  Adam Nemet  <anemet@lnxw.com>
	    Nick Clifton  <nickc@redhat.com>

	* config/arm/arm.h (THUMB_FUNCTION_PROFILER): Remove.
	(FUNCTION_PROFILER): Only invoke THUMB_FUNCTION_PROFILER if it
	is defined.

2002-09-24  Ulrich Weigand  <uweigand@de.ibm.com>

	* config/s390/s390.c (preferred_la_operand_p): New function.
	* config/s390/s390-protos.h (preferred_la_operand_p): Declare it.
	* config/s390/s390.md ("addaddr_esame", "*la_ccclobber"): Replace by ...
	("*la_64_cc", "*la_31_cc", splitters): ... these.
	("*la_31"): Deactivate for TARGET_64BIT.
	("*la_31_and", "*la_31_and_cc"): New.

2002-09-24  Kaveh R. Ghazi  <ghazi@caip.rutgers.edu>

	* real.h (real_value): Make `exp' explicitly signed.

2002-09-24  Kazu Hirata  <kazu@cs.umass.edu>

	* config/elfos.h: Follow spelling conventions.
	* config/alpha/alpha.h: Likewise.
	* config/arc/arc.h: Likewise.
	* config/arm/arm.md: Likewise.
	* config/avr/avr.h: Likewise.
	* config/cris/cris.md: Likewise.
	* config/d30v/d30v.h: Likewise.
	* config/frv/frv.c: Likewise.
	* config/frv/frv.h: Likewise.
	* config/h8300/h8300.c: Likewise.
	* config/h8300/h8300.h: Likewise.
	* config/h8300/h8300.md: Likewise.
	* config/i386/cygwin.h: Likewise.
	* config/i386/i386.h: Likewise.
	* config/i386/sysv3.h: Likewise.
	* config/i960/i960.h: Likewise.
	* config/ia64/ia64.h: Likewise.
	* config/ia64/ia64.md: Likewise.
	* config/ip2k/ip2k.h: Likewise.
	* config/m32r/m32r.h: Likewise.
	* config/m68k/m68k.h: Likewise.
	* config/m88k/m88k.h: Likewise.
	* config/mcore/mcore.c: Likewise.
	* config/mcore/mcore.h: Likewise.
	* config/mcore/mcore.md: Likewise.
	* config/mips/mips.h: Likewise.
	* config/mmix/mmix.h: Likewise.
	* config/mmix/mmix.md: Likewise.
	* config/ns32k/netbsd.h: Likewise.
	* config/ns32k/ns32k.h: Likewise.
	* config/ns32k/ns32k.md: Likewise.
	* config/pa/pa.h: Likewise.
	* config/romp/romp.h: Likewise.
	* config/rs6000/rs6000.h: Likewise.
	* config/rs6000/rs6000.md: Likewise.
	* config/sparc/sparc.h: Likewise.
	* config/stormy16/stormy-abi: Likewise.
	* config/stormy16/stormy16.h: Likewise.
	* config/vax/vax.h: Likewise.

2002-09-23  Kazu Hirata  <kazu@cs.umass.edu>

	* config/alpha/alpha.h: Remove commented-out macro
	definitions of HAVE_{POST|PRE}_{INC|DEC}REMENT.
	* config/avr/avr.h: Likewise.
	* config/d30v/d30v.h: Likewise.
	* config/dsp16xx/dsp16xx.h: Likewise.
	* config/i370/i370.h: Likewise.
	* config/i386/i386.h: Likewise.
	* config/i960/i960.h: Likewise.
	* config/m68k/m68k.h: Likewise.
	* config/m88k/m88k.h: Likewise.
	* config/mips/mips.h: Likewise.
	* config/ns32k/ns32k.h: Likewise.
	* config/pdp11/pdp11.h: Likewise.
	* config/romp/romp.h: Likewise.
	* config/rs6000/rs6000.h: Likewise.
	* config/s390/s390.h: Likewise.
	* config/sh/sh.h: Likewise.
	* config/sparc/sparc.h: Likewise.
	* config/stormy16/stormy16.h: Likewise.
	* config/vax/vax.h: Likewise.

2002-09-23  Kazu Hirata  <kazu@cs.umass.edu>

	* function.c (push_temp_slots_for_block): Remove.
	(push_temp_slots_for_target): Likewise.
	(get_target_temp_slot_level): Likewise.
	(set_target_temp_slot_level): Likewise.
	(get_first_block_beg): Likewise.
	* function.h: Remove corresponding prototypes.

2002-09-23  Zack Weinberg  <zack@codesourcery.com>

	* version.c (version_string): Now const char[].
	* version.h: Update to match.

2002-09-23  Richard Henderson  <rth@redhat.com>

	* config/i386/i386.h (MASK_ACCUMULATE_OUTGOING_ARGS_SET, MASK_MMX_SET,
	MASK_SSE_SET, MASK_SSE2_SET, MASK_3DNOW_SET, MASK_3DNOW_A_SET): Kill.
	(TARGET_SWITCHES): Don't reference them.
	* config/i386/i386.c (override_options): Use target_flags_explicit
	to examine bits set by the user.

2002-09-23  Dale Johannesen  <dalej@apple.com>

	* dbxout.c (dbxout_parms):  Set current_sym_code for params
	passed on stack by invisible reference.

2002-09-23  Richard Earnshaw  <rearnsha@arm.com>

	* arm/unknown-elf.h (ASM_OUTPUT_ALIGNED_DECL_LOCAL): Always allocate
	at least one byte of space.

2002-09-23  Mark Mitchell  <mark@codesourcery.com>

	* c-common.h (flag_abi_version): Fix typo in comment.
	* doc/invoke.texi (flag_abi_version): Document default value.

2002-09-23  Hans-Peter Nilsson  <hp@axis.com>

	* doc/extend.texi (Extended Asm): Clarify that overlap between
	asm-declared register variables used in an asm and the asm clobber
	list is not allowed.
	* stmt.c (decl_conflicts_with_clobbers_p): New function.
	(expand_asm_operands): Keep track of clobbered registers.  Call
	decl_conflicts_with_clobbers_p for each input and output operand.
	If no conflicts found before, also do conflict sanity check when
	emitting clobbers.

2002-09-23  Richard Henderson  <rth@redhat.com>

	* c-common.c (cpp_define_data_format): Remove.
	(cb_register_builtins): Don't define __WCHAR_BIT__, __SHRT_BIT__,
	__INT_BIT__, __LONG_BIT__, __LONG_LONG_BIT__, __FLOAT_BIT__,
	__DOUBLE_BIT__, __LONG_DOUBLE_BIT__.
	* doc/cpp.texi: Don't document them either.
	(__SCHAR_MAX__, __SHRT_MAX__, __INT_MAX__, __LONG_MAX__,
	__LONG_LONG_MAX__): Document.
	(__TARGET_FLOAT_FORMAT__): Remove.

2002-09-23  Richard Henderson  <rth@redhat.com>

	* real.c (do_multiply): Normalize U before addition.

2002-09-23  Mark Mitchell  <mark@codesourcery.com>

	* c-common.c (flag_abi_version): New variable.
	* c-common.h (flag_abi_version): Declare it.
	* c-opts.c (missing_arg): Add -fabi-version.
	(c_common_decode_option): Process -fabi-version.
	* doc/invoke.texi (-fabi-version): Document it.
	(-Wabi): Add information about bit-fields in unions.

2002-09-22  Roger Sayle  <roger@eyesopen.com>

	* expr.c (STORE_BY_PIECES_P): New target macro.
	(can_store_by_pieces, store_by_pieces): Use STORE_BY_PIECES_P
	instead of MOVE_BY_PIECES_P.
	* doc/tm.texi: Document this new macro.

2002-09-22  Jason Thorpe  <thorpej@wasabisystems.com>

	* config/mips/netbsd.h (SUBTARGET_ASM_SPEC): Always pass -KPIC
	unless -fno-pic or -fno-PIC is specified.

2002-09-22  John David Anglin  <dave@hiauly1.hia.nrc.ca>

	* c-common.c (preprocessing_trad_p): Define.
	* pa-hiux.h, pa-hpux.h, pa-hpux7.h (CPP_PREDEFINES): Delete.
	(TARGET_OS_CPP_BUILTINS, SUBTARGET_SWITCHES): Define.
	* pa-hpux10.h (TARGET_OS_CPP_BUILTINS, CPP_SPEC): Define.
	* pa-hpux11.h (TARGET_OS_CPP_BUILTINS): Define.
	* pa-linux.h (CPP_PREDEFINES): Delete.
	(TARGET_OS_CPP_BUILTINS, CPP_SPEC): Define.
	* pa32-linux.h, pa64-linux.h (CPP_SPEC): Delete.
	* pa-osf.h, pa-pro-end.h, rtems.h (CPP_PREDEFINES): Delete.
	(TARGET_OS_CPP_BUILTINS): Define.
	* pa.h (MASK_SIO, TARGET_SIO, TARGET_PA_10): Define.
	(TARGET_SWITCHES): Reformat.  Use N_() macro.  Add SUBTARGET_SWITCHES.
	(SUBTARGET_SWITCHES): Provide default definition.
	(TARGET_OPTIONS): Reformat.  Use N_() macro.
	(CPP_PA10_SPEC, CPP_PA11_SPEC, CPP_PA20_SPEC, CPP_64BIT_SPEC,
	CPP_CPU_DEFAULT_SPEC, CPP_64BIT_DEFAULT_SPEC, SUBTARGET_EXTRA_SPECS,
	EXTRA_SPECS, CPP_SPEC, CPLUSPLUS_CPP_SPEC, CPP_PREDEFINES): Delete.
	(TARGET_CPU_CPP_BUILTINS): Define.
	(TARGET_OS_CPP_BUILTINS): Define for BSD-like systems.
	* doc/invoke.texi (msio, mwsio): Document new hppa options.
	* doc/tm.texi (TARGET_CPU_CPP_BUILTINS): Document macro
	preprocessing_trad_p().

2002-09-22  Jason Thorpe  <thorpej@wasabisystems.com>

	* doc/install.texi: Document behavior of --with-headers and
	--with-libs when arguments are omitted.

2002-09-22  Kazu Hirata  <kazu@cs.umass.edu>

	* dbxout.c: Follow spelling conventions.
	* defaults.h: Likewise.
	* df.c: Likewise.
	* diagnostic.h: Likewise.
	* doloop.c: Likewise.
	* dwarf2out.c: Likewise.
	* dwarfout.c: Likewise.
	* emit-rtl.c: Likewise.
	* except.c: Likewise.
	* explow.c: Likewise.
	* expmed.c: Likewise.
	* expr.c: Likewise.
	* expr.h: Likewise.
	* flags.h: Likewise.
	* flow.c: Likewise.
	* fold-const.c: Likewise.
	* function.c: Likewise.
	* function.h: Likewise.
	* gcc.c: Likewise.
	* gcov-io.h: Likewise.
	* gcov.c: Likewise.
	* gcse.c: Likewise.
	* genattrtab.c: Likewise.
	* genconfig.c: Likewise.
	* genrecog.c: Likewise.
	* ggc-page.c: Likewise.
	* ggc.h: Likewise.
	* global.c: Likewise.
	* gthr-win32.h: Likewise.
	* integrate.c: Likewise.
	* jump.c: Likewise.
	* langhooks.c: Likewise.
	* langhooks.h: Likewise.
	* line-map.h: Likewise.
	* local-alloc.c: Likewise.
	* longlong.h: Likewise.
	* loop.c: Likewise.
	* loop.h: Likewise.

Tue Aug 27 22:26:35 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* i386.h (BIGGEST_FIELD_ALIGNMENT): Set proper default for x86_64.

Tue Aug 27 20:07:01 CEST 2002  Jan Hubicka  <jh@suse.cz>

	* i386.c (overwrite_options): Set -mpreferred-stack-boundary to 128
	for -Os/TARGET_64BIT too.

2002-09-21  Kazu Hirata  <kazu@cs.umass.edu>

	* ChangeLog: Follow spelling conventions.
	* ChangeLog.0: Likewise.
	* ChangeLog.1: Likewise.
	* ChangeLog.2: Likewise.
	* ChangeLog.3: Likewise.
	* ChangeLog.4: Likewise.
	* ChangeLog.5: Likewise.
	* ChangeLog.6: Likewise.
	* FSFChangeLog.10: Likewise.
	* FSFChangeLog.11: Likewise.
	* alias.c: Likewise.
	* basic-block.h: Likewise.
	* c-aux-info.c: Likewise.
	* c-common.c: Likewise.
	* c-common.h: Likewise.
	* c-decl.c: Likewise.
	* c-format.c: Likewise.
	* c-semantics.c: Likewise.
	* c-typeck.c: Likewise.
	* calls.c: Likewise.
	* cfganal.c: Likewise.
	* cfgloop.c: Likewise.
	* collect2.c: Likewise.
	* combine.c: Likewise.
	* conflict.c: Likewise.
	* cppexp.c: Likewise.
	* cppfiles.c: Likewise.
	* cpphash.h: Likewise.
	* cppinit.c: Likewise.
	* cpplex.c: Likewise.
	* cpplib.c: Likewise.
	* cpplib.h: Likewise.
	* cppmacro.c: Likewise.
	* cse.c: Likewise.

2002-09-21  Richard Earnshaw  <rearnsha@arm.com>

	* netbsd-aout.h (NETBSD_LINK_SPEC_AOUT): New, takes old definition of
	LINK_SPEC.
	(LINK_SPEC): Define to NETBSD_LINK_SPEC_AOUT.
	* arm/netbsd.h (SUBTARGET_EXTRA_SEPCS): Add NETBSD_LINK_SPEC_AOUT.
	(LINK_SPEC): Rework to use NETBSD_LINK_SPEC_AOUT).

2002-09-21  Richard Earnshaw  <rearnsha@arm.com>

	PR opt/7930
	* cse.c (fold_rtx): Calculate old_cost before we fold each
	operand.

2002-09-21  Richard Henderson  <rth@redhat.com>

	* c-common.c (cpp_define_data_format): Remove __GCC_LITTLE_ENDIAN__,
	__GCC_BIG_ENDIAN__, __TARGET_BITS_ORDER__, __TARGET_BYTES_ORDER__,
	__TARGET_INT_WORDS_ORDER__, __TARGET_FLOAT_WORDS_ORDER__,
	__TARGET_USES_VAX_F_FLOAT__, __TARGET_USES_VAX_D_FLOAT__,
	__TARGET_USES_VAX_G_FLOAT__, __TARGET_USES_VAX_H_FLOAT__.
	* doc/cpp.texi: Don't document them.

2002-09-21  Richard Henderson  <rth@redhat.com>

	* c-common.c (builtin_define_float_constants): Use real_format
	to get the floating-point parameters.

2002-09-21  Richard Henderson  <rth@redhat.com>

	* real.c (struct real_format): Move to real.h.
	(real_format_for_mode): Rename from fmt_for_mode; update all users;
	initialize with ieee defaults.
	(real_to_target_fmt, real_from_target_fmt): New.
	(ieee_single_format, ieee_double_format, ieee_extended_motorola_format,
	ieee_extended_intel_96_format, ieee_extended_intel_128_format,
	ieee_quad_format, i370_single_format, i370_double_format,
	c4x_single_format, c4x_extended_format): Rename from s/_format//.
	(ieee_quad_format): Fix emin.
	(format_for_size, init_real_once): Remove.
	* real.h (struct real_format): Move from real.c.
	(real_format_for_mode): Declare.
	(real_to_target_fmt, real_from_target_fmt): Declare.
	(ieee_single_format, ieee_double_format, ieee_extended_motorola_format,
	ieee_extended_intel_96_format, ieee_extended_intel_128_format,
	ieee_quad_format, vax_f_format, vax_d_format, vax_g_format,
	i370_single_format, i370_double_format, c4x_single_format,
	c4x_extended_format): Declare.
	* toplev.c (do_compile): Don't call init_real_once.

	* defaults.h (INTEL_EXTENDED_IEEE_FORMAT): Remove.
	* doc/tm.texi (INTEL_EXTENDED_IEEE_FORMAT): Remove.

	* config/alpha/alpha.h (TARGET_FLOAT_FORMAT): Define.
	* config/alpha/osf5.h (LONG_DOUBLE_TYPE_SIZE): 64, if vax mode.
	* config/alpha/alpha.c (override_options): Set real_format_for_mode
	for VAX, if enabled.

	* config/c4x/c4x.c (c4x_override_options): Set real_format_for_mode
	for C4X.

	* config/i370/i370.h (OVERRIDE_OPTIONS): New.
	* config/i370/i370.c (override_options): New.
	* config/i370/i370-protos.h: Update.

	* config/i386/i386.c (override_options): Set real_format_for_mode
	for Intel 80-bit extended.
	* config/i386/i386.h (INTEL_EXTENDED_IEEE_FORMAT): Remove.

	* config/i960/i960.h (LONG_DOUBLE_TYPE_SIZE): Mind -mlong-double-64.
	(OVERRIDE_OPTIONS): Move code...
	* config/i960/i960.c (i960_initialize): ... here.  Set
	real_format_for_mode for Intel 80-bit extended.

	* config/ia64/ia64.c (ia64_override_options): Set real_format_for_mode
	for Intel 80-bit extended, if enabled.

	* config/m68k/m68k.c (override_options): Set real_format_for_mode
	for Motorola 96-bit extended.

	* config/vax/vax.h (OVERRIDE_OPTIONS): New.
	* config/vax/vax.c (override_options): New.
	* config/vax/vax-protos.h: Update.

2002-09-21  Alan Modra  <amodra@bigpond.net.au>

	* config/rs6000/rs6000.md (builtin_setjmp_receiver): Add
	#if TARGET_MACHO.

	* config/rs6000/rs6000.md (floatdisf2_internal2): Combine
	insns.  Supply missing clobber of scratch reg.

2002-09-20  Kazu Hirata  <kazu@cs.umass.edu>

	* config/m32r/m32r.c: Follow spelling conventions.
	* config/m32r/m32r.h: Likewise.
	* config/m32r/m32r.md: Likewise.
	* config/m68k/m68k.c: Likewise.
	* config/m88k/m88k.c: Likewise.
	* config/mcore/mcore.c: Likewise.
	* config/mips/mips.c: Likewise.
	* config/mips/mips.h: Likewise.
	* config/mmix/mmix.c: Likewise.
	* config/mn10200/mn10200.c: Likewise.
	* config/ns32k/ns32k.h: Likewise.
	* config/pa/pa.c: Likewise.
	* config/pa/pa64-linux.h: Likewise.
	* config/pdp11/pdp11.h: Likewise.
	* config/romp/romp.c: Likewise.
	* config/romp/romp.h: Likewise.
	* config/rs6000/eabi.asm: Likewise.
	* config/rs6000/linux64.h: Likewise.
	* config/rs6000/rs6000.c: Likewise.
	* config/rs6000/rs6000.h: Likewise.
	* config/rs6000/rs6000.md: Likewise.
	* config/rs6000/sysv4.h: Likewise.
	* config/rs6000/xcoff.h: Likewise.

2002-09-20  Jim Wilson  <wilson@redhat.com>

	* config/v850/v850/lib1funcs.asm (__muldi3): Change r5 to r28.

2002-09-20  Jakub Jelinek  <jakub@redhat.com>

	* config/i386/i386.md (UNSPEC_GOTNTPOFF, UNSPEC_INDNTPOFF): New.
	* config/i386/i386.c (legitimate_pic_address_disp_p): Handle
	UNSPEC_GOTNTPOFF and UNSPEC_INDNTPOFF like UNSPEC_GOTTPOFF.
	(legitimate_address_p): Likewise.
	(legitimize_address): Use @gotntpoff and @indntpoff.
	(output_pic_addr_const): Handle UNSPEC_GOTNTPOFF and UNSPEC_INDNTPOFF.
	(output_addr_const_extra): Likewise.

2002-09-20  Jim Wilson  <wilson@redhat.com>

	* combine.c (try_combine): When split an instruction pair, where the
	first has a sign_extend src, verify that the src and dest modes match.

2002-09-20  Richard Henderson  <rth@redhat.com>

	* config/mips/mips.c (dfhigh, dflow, sfhigh, sflow): Remove.
	(override_options): Do not initialize them.
	(mips_const_double_ok): Allow no fp constants except zero,
	and not even that for mips16.
	(const_float_1_operand): Use dconst1.
	* config/mips/mips.md (movsf, movsf_internal1, movsf_internal2,
	movdf, movdf_internal1, movdf_internal1a, movdf_internal2):
	Don't allow arbitrary constants; fix predicates and C constraint.

2002-09-20  Neil Booth  <neil@daikokuya.co.uk>

	* cppmacro.c: Don't warn about function-like macros without
	'(' during pre-expansion.

2002-09-20  Jim Wilson  <wilson@redhat.com>

	* config/v850/v850.c (current_function_anonymous_args): Delete.
	(expand_prologue): Use current_function_args_info.anonymous_args.
	(expand_epilogue): Delete use of current_function_anonymous_args.
	* config/v850/v850.h (struct cum_arg): Add anonymous_args field.
	(INIT_CUMULATIVE_ARGS): Clear anonymous_args field.
	(current_function_anonymous_args): Delete extern declaration.
	(SETUP_INCOMING_VARARGS): Set anonymous_args field.

2002-09-20  Geoffrey Keating  <geoffk@apple.com>

	* config/rs6000/rs6000.c (rs6000_emit_prologue): Update for change
	to load_macho_picbase.
	* config/rs6000/rs6000.md: Document Darwin-specific unspec IDs.
	(load_macho_picbase): Take the symbol to use as a parameter.
	(macho_correct_pic): New insn.
	(builtin_setjmp_reciever): On Darwin, restore the PIC register.

	* config/rs6000/rs6000.h (ELIMINABLE_REGS): Use
	RS6000_PIC_OFFSET_TABLE_REGNUM rather than hardcoding 30.
	(CAN_ELIMINATE): Likewise.
	(INITIAL_ELIMINATION_OFFSET): Likewise.
	(TOC_REGISTER): Likewise.

2002-09-20  Richard Henderson  <rth@redhat.com>

	* real.c (real_hash): New.
	* real.h: Declare it.
	* cse.c (canon_hash): Use it.
	* cselib.c (hash_rtx): Likewise.
